--[[游戏数据管理对象
	1.目前管理静态、动态数据库
  ]]
gameData = {}
--[[缓存数据的对象
]]
gameData._tables = {}
gameData._staticCacheData = {} ---静态数据缓存 
gameData.ludDataIsOk = true

function gameData.reset()
    gameData._tables = {}
    gameData._staticCacheData = {}
end

function gameData.firstInit()

	local dbTableList = {
        "hero",--武将
        "formation",--布阵 formation
        "formation_level",--阵法升级表
        "item",--物品表  背包
        "chapter",--副本
        "tollgate",--关卡
        "houseEffect_smith", -- 铁匠铺效果
        "weapon",--兵器
        "weapon_foundry",--兵器铸造
        "weapon_recast",--兵器锻造
        "guidelist",--引导
        "functions",--功能开启
        "house_level",--建筑等级
        "houseEffect_castle",--建筑效果表
        "castle_grid",--命格
        "castle_grid_level",--命格等级
        "task",--任务
        "task_daily",--日常任务
    }  

    for i=1,#dbTableList do 
        gameData.checkJoinDb(dbTableList[i])
    end
end

function gameData.changeConditionToString( condition )
    if condition then 
        local str = ""
        for k,v in pairs (condition) do 
            str = str..tostring(k)..tostring(v)
        end
        return str
    end 
    return nil
end

function gameData.checkJoinDb( tableName )
    if tableName and not gameData._tables[tableName] then
        local _data
        if not gameData.ludDataIsOk then
            _data = cc.FileUtils:getInstance():getStringFromFile("res/dbJson/" .. tableName .. ".json")
            _data = json.decode(_data)
        else
            local name = "src/staticData/" .. tostring(tableName) .. ".lua"
            print("gameData.checkJoinDb tableName=",name)
            _data = requires( name )
        end
        gameData._tables[tableName] = _data
    end
end

function gameData.getAllDataWithNoClone( tableName )
    gameData.checkJoinDb(tableName)
    if tableName and #tableName > 0 then 
        return gameData._tables[tableName]
    end 
    return {}
end

function gameData.getDataFromCache(tableName, condition)
    gameData.checkJoinDb(tableName)
	
	local data = nil	
	if tableName and #tableName > 0 then 
		if not condition then ---无条件查询
			data = gameData._tables[tableName]
		else 
			local key = gameData.changeConditionToString(condition)
			-- print("the key is ",key)
			---先从缓存里取
			if gameData._staticCacheData[tableName] then 
				data = gameData._staticCacheData[tableName][key]
				-- print("the key is ",key)
				if data and #data > 0 then 
					return clone(data)
				end 
			else 
				gameData._staticCacheData[tableName] = {}
			end 
			data = {}
			---缓存里没有再遍历查询
			local targData = gameData._tables[tableName]
			if targData then 
				local index = {}	
				local j = 1		
				-- for i = 1,#targData do
                    -- local _tarD =  targData[i]
                for i,_tarD in pairs(targData) do
					local have = false
					for k,v in pairs(condition) do
						local value = tostring(v)
                        local key
                        if gameData.ludDataIsOk then
                            key = tostring(_tarD[k])
                        else
                            key = _tarD[k]
                        end
                        -- dump(_tarD, "wm---test : " .. k)
                        -- print("key : ", key, " , value : ", value) 
                        if key == value then 
							have = true
						else
							have = false
							break
						end 
					end 
					if have then 
						index[j] = i
						j = j + 1
					end 
				end
				if #index == 1 then 
					data = targData[index[1]]	
					gameData._staticCacheData[tableName][key] = data			
				elseif #index > 1 then  
                    -- dump(index, "wm---sortBefore")
                    table.sort(index, function(a, b)
                        local _a = tonumber(a) or 0
                        local _b = tonumber(b) or 0
                        return _a < _b
                    end)
                    -- dump(index, "wm---sortAfter")
					for i = 1,#index do 
						data[i] = targData[index[i]]
					end
					gameData._staticCacheData[tableName][key] = data		
				end  
				-- dump(index)
			end
		end 
	end 	
	return data and clone(data) or {}
end

function gameData.getDataFromCacheWithPrimaryKey(tableName, keyId, needClone)
    if not keyId then
        return {}
    end
    gameData.checkJoinDb(tableName) 
    local data = gameData._tables[tableName]
    if not data then
        return {}
    end
    local _needClone = needClone == nil and false or needClone
    local _keyId = tostring(keyId)
    local _data = data[_keyId] or {}
    if _needClone then
        return clone(_data)
    end
    return _data
end

