-- FileName: RechargeFirstLayer.lua
-- Author: wangming
-- Date: 2016-10-17
-- Purpose: 新主线章节列表界面
--[[TODO List]]

local RechargeFirstLayer = class("RechargeFirstLayer", function()
	local layer = cc.Sprite:create()
    layer:setContentSize( 720, 463 )
	return layer
end)

function RechargeFirstLayer:create( params )
	return RechargeFirstLayer.new( params )
end

function RechargeFirstLayer:ctor( params )
	self._type = 5001
	self._table = params.table or {}

	self._size = self:getContentSize()
	-- 背景
	local bg = zc.createSprite("res/Main/activity/rechargeFirst/mainBg.jpg")
	bg:setAnchorPoint( 0.5, 1 )
	bg:setPosition( self._size.width*0.5, self._size.height )
	self:addChild( bg )


	local _firstInfo = {}
	local _cumulativeInfos = {}
	for k,v in pairs(self._table) do
		if tonumber(v.type) == self._type then
			local _subtype = tonumber(v.subtype) or 0
			if _subtype == 1001 then
				_firstInfo = v
			elseif _subtype == 1002 then
				_cumulativeInfos[#_cumulativeInfos + 1] = v
			end
		end
	end
	do -- 首充
		-- local _firstInfo = gameData.getDataFromCache("recharge_activity", {type=self._type, subtype=1001})
		self._firstDbInfo = _firstInfo
		if next(_firstInfo) ~= nil then
			local _datas = {}
			for i=1, 4 do
				local __data =_firstInfo["reward" .. i]
				if __data and __data ~= "" then
					_datas[#_datas + 1] = string.split(__data, "|")
				end
			end
			local _length = #_datas
			if _length > 0 then
				local _onePartWidth = 65
				local _oneHeight = 70
				local dropScrollView = zc.createScrollview({
			        pos = cc.p(51, 84),
			        size = cc.size(251, _oneHeight),
			        innerSize = cc.size(_onePartWidth*_length, _oneHeight),
			        dir = ccui.ScrollViewDir.horizontal,
			        bar = false,
			        bounceEnable = true,
			    })
			    bg:addChild(dropScrollView)
				for i=1, _length do
					local __data = _datas[i]
					local _item = zc.createIconByData({
			            data = {
							mainType = __data[1],
							type = __data[2],
			                id = __data[2],
			                num = __data[3],
						}, 
			            pos = cc.p((i-1/2)*_onePartWidth, _oneHeight*0.5), 
			        })
			        _item:setTouchEndedShowTip()
			        _item:setScale(0.5)
			        dropScrollView:addChild(_item)

			        if i == 1 and tonumber(__data[1]) == 2 then
			        	local _heroInfo = gameData.getDataFromCacheWithPrimaryKey("hero", __data[2])
			        	local _armature = zc.createArmature({
			        		fileName = _heroInfo.modelId, 
			        		async = true, 
			        		asyncCallback = function( _armature )
						        if tolua.isnull(_armature) then
						        	return
						        end
							    _armature:setScaleX(-1)
					            _armature:getAnimation():play("idle", -1, 1) 
					    	end
					    })  
					    _armature:setPosition(cc.p(210, 230))
					    bg:addChild(_armature)

					    local _weaponSp = zc.getSprite({
					    	src = zc.getHeroTypeBigImg(_heroInfo.weaponType),
					    	scale = 0.5,
					    })
					    _weaponSp:setPosition(cc.p(165, 200))
					    bg:addChild(_weaponSp)
					    local _heroName = zc.createLabel({
							text = _heroInfo.name,
					        fontSize = 20,
					        pos = cc.p(220, 200),
					        outLine = true,
					    })
					    bg:addChild(_heroName)


						local _detailBtn = zc.createPushButton({
					        normalFile = "res/Main/activity/rechargeFirst/detailBtn.png",
					        anchor = cc.p(0.5, 0.5),
					        pos = cc.p(300, 360),
					        endCallback = function()
						        --武将详细信息界面
						        zc.createHeroInfoPop({heroId = _heroInfo.id, showHero = true})
					        end,
					    })
					    bg:addChild(_detailBtn, 1)	
					    local _label = zc.createLabel({
					    	text = zc.lang("country_look_detial"),
					    	fontSize = 22,
					    	width = 50,
					    	color = cc.c3b(75, 53, 29),
					    	pos = cc.p(_detailBtn:getContentSize().width*0.5 + 5, _detailBtn:getContentSize().height*0.5),
					    })			    
					    _detailBtn:addChild(_label)
			        end
				end
		    end
		end
		local _rechargeBtn = zc.createCommomBtn({
			tag = 1,
			text = LANGUAGE_RECHARGE.recharge_space,
			pos = cc.p(148, 47),
			endCallback = function() 
				if tonumber(self._firstDbInfo.status) == 0 then
					LayerManager.backToMainCity(false)
					zc.createRechargePop()
				elseif tonumber(self._firstDbInfo.status) == 1 then
					self:doRecieve(self._firstDbInfo.id)
				end
			end,
		})
		bg:addChild(_rechargeBtn)
		self._rechargeBtn = _rechargeBtn
	end
	
	do -- 累计充值
		self._cumulativeInfos = _cumulativeInfos
		-- self._cumulativeInfos = gameData.getDataFromCache("recharge_activity", {type=self._type, subtype=1002})
		table.sort(self._cumulativeInfos, function( a, b )
			if not a or not b then
				return false
			end
			local _parameterA = tonumber(a.parameter) or 0
			local _parameterB = tonumber(b.parameter) or 0
			return _parameterA < _parameterB
		end)

		local _tableSize = cc.size(375, 400)
		local tableView = zc.ZCTableView:create(_tableSize)
	    tableView:setDirection(cc.SCROLLVIEW_DIRECTION_VERTICAL)
	    tableView:setVerticalFillOrder(cc.TABLEVIEW_FILL_TOPDOWN)
	    tableView:setBounceable(true)
	    tableView:setInertia(false)
	    tableView:setAutoAlign(true)
	    tableView:setDelegate()
	    tableView:setPosition(325, 15)
	    bg:addChild(tableView)

	    local _cellSize = cc.size(_tableSize.width, 240)
	    local _partX = 110
	    local _partXX = 15
	    local _partY1 = 220
	    local _partY2 = 160
	    local _partY3 = -240

	    local function scorllviewScriptScroll( table, isForce ) --这里只对卷轴相对中心位置调整scale
		    local _offSet = table:getContentOffset().y
		   	if not isForce and self._lastOffSet == _offSet then
		   		return
		   	end
		   	self._lastOffSet = _offSet
		   	for i = 1, #self._cumulativeInfos do
		        local _cell = table:cellAtIndex(i-1)
		        if _cell then
		        	local _posY = _cell:getPositionY() + _offSet
		        	if _posY >= _partY1 then
		        		_cell._di:setPositionX(_cellSize.width + _partXX)
		        	elseif _posY > _partY2 then
		        		local _tmpY = _posY - _partY2
		        		local _tmpX = (_tmpY/(_partY1 - _partY2))*_partXX
		        		_cell._di:setPositionX(_cellSize.width + _tmpX)
		        	elseif _posY == _partY2 then
		        		_cell._di:setPositionX(_cellSize.width)
		        	elseif _posY <= _partY3 then
		        		_cell._di:setPositionX(_cellSize.width - _partX)
		        	else
		        		local _tmpY = _posY - _partY3
		        		local _tmpX = (1-(_tmpY/_tableSize.height))*_partX
		        		_cell._di:setPositionX(_cellSize.width - _tmpX)
		        	end
		        end
		   	end
	    end
	    self._scorllviewScriptScroll = scorllviewScriptScroll

	    local function numberOfCellsInTableView( table )
	        return #self._cumulativeInfos
	    end
	    local function cellSizeForTable( table, idx )
	        return _cellSize.height, _cellSize.width  
	    end
	    
	    local function tableCellAtIndex( table, idx )
	        local _cell = table:dequeueCell()
	        if _cell == nil then
	            _cell = zc.ZCTableViewCell:new()
	            _cell:setContentSize(cc.size(_cellSize.width, _cellSize.height))
	        end
	        local _index = idx + 1
	        self:dealWithCell(_cell, _index)
	        return _cell
	    end
	    tableView:registerScriptHandler(numberOfCellsInTableView,zctech.NUMBER_OF_CELLS_IN_TABLEVIEW)  
	    tableView:registerScriptHandler(cellSizeForTable,zctech.TABLECELL_SIZE_FOR_INDEX)
	    tableView:registerScriptHandler(tableCellAtIndex,zctech.TABLECELL_SIZE_AT_INDEX)
	    tableView:registerScriptHandler(scorllviewScriptScroll,zctech.SCROLLVIEW_SCRIPT_SCROLL)

	    self._pubLayer = tableView
	end
	
	do -- 底
		local _diSize = cc.size(728, 68)
		local bottom = ccui.Scale9Sprite:create( cc.rect( 20, 10, 549, 71 ), "res/Main/role/trinket/sellDi.png" )
	    bottom:setContentSize(_diSize)
	    bottom:setAnchorPoint( 0, 0 )
	    bottom:setPosition( -2, -5 )
	    self:addChild( bottom, 1)

		local _leftTipSize = cc.size(360, 30)
	    local _leftTipDi = zc.getScaleNode("res/Main/role/common/name_bg.png", _leftTipSize)
		_leftTipDi:setPosition(210, _diSize.height*0.5)
		bottom:addChild(_leftTipDi)
		self._leftTipDi = _leftTipDi
		cc.SpriteFrameCache:getInstance():addSpriteFrames("res/Main/home/homeUI.plist", "res/Main/home/homeUI.pvr.ccz")
	    local _pScale = 0.5
	    self._infoTb = {}
	    local _leftTipImg1 = zc.getSprite({
	        src = "home_icon_info.png",
	        plist = true,
	        ap = cc.p(0, 0.5),
	        pos = cc.p(0, _leftTipSize.height*0.5),
	        scale = _pScale,
	    })
	    _leftTipDi:addChild(_leftTipImg1)
	    self._infoTb[1] = {
	    	target = _leftTipImg1,
	    	scale = _pScale,
		}
		local _leftTipLab1 = zc.createLabel({
			text = LANGUAGE_RECHARGE.recharge_more,
	        fontSize = 20,
	        ap = cc.p(0, 0.5),
	        pos = cc.p(0, _leftTipSize.height*0.5),
	        color = cc.c3b(255, 229, 200),
	        outLine = true,
	    })
	    _leftTipDi:addChild(_leftTipLab1)
	    self._infoTb[2] = {
	    	target = _leftTipLab1,
	    	scale = 1,
		}
	    local _leftTipLab2 = zc.createLabel({
			text = "0",
	        fontSize = 20,
	        ap = cc.p(0, 0.5),
	        pos = cc.p(0, _leftTipSize.height*0.5),
	        outLine = true,
	    })
	    _leftTipDi:addChild(_leftTipLab2)
	    self._infoTb[3] = {
	    	target = _leftTipLab2,
	    	scale = 1,
		}
		self._leftTipLab2 = _leftTipLab2
	    local _leftTipImg2 = zc.createLabel({
			text = zc.lang("gold"),
	        fontSize = 20,
	        ap = cc.p(0, 0.5),
	        pos = cc.p(0, _leftTipSize.height*0.5),
	        color = cc.c3b(255, 229, 200),
	        outLine = true,
	    })
	    _leftTipDi:addChild(_leftTipImg2)
	    self._infoTb[4] = {
	    	target = _leftTipImg2,
	    	scale = 1,
		}
	    local _leftTipLab3 = zc.createLabel({
			text = zc.lang("can_get_next_reward"),
	        fontSize = 20,
	        ap = cc.p(0, 0.5),
	        pos = cc.p(0, _leftTipSize.height*0.5),
	        color = cc.c3b(255, 229, 200),
	        outLine = true,
	    })
	    _leftTipDi:addChild(_leftTipLab3)
	    self._infoTb[5] = {
	    	target = _leftTipLab3,
	    	scale = 1,
		}
		
	   	local _leftTipDi2 = zc.getScaleNode("res/Main/role/common/name_bg.png", _leftTipSize)
		_leftTipDi2:setPosition(210, _diSize.height*0.5)
		bottom:addChild(_leftTipDi2)
		self._leftTipDi2 = _leftTipDi2
		_leftTipDi2:setVisible(false)
	    local _leftTipLab4 = zc.createLabel({
			text = zc.lang("recharge_count_achieve_all"),
	        fontSize = 20,
	        ap = cc.p(0.5, 0.5),
	        pos = cc.p(_leftTipSize.width*0.5, _leftTipSize.height*0.5),
	        color = cc.c3b(255, 229, 200),
	    })
	    _leftTipDi2:addChild(_leftTipLab4)

		local _rightTipSize = cc.size(180, 30)
	    local _rightTipDi = zc.getScaleNode("res/Main/role/common/name_bg.png", _rightTipSize)
		_rightTipDi:setAnchorPoint(1, 0.5)
		_rightTipDi:setPosition(_diSize.width - 30, _diSize.height*0.5)
		bottom:addChild(_rightTipDi)
		
		local _rightTipLab1 = zc.createLabel({
			text = zc.lang("have_recharged"),
	        fontSize = 20,
	        ap = cc.p(0, 0.5),
	        pos = cc.p(0, _rightTipSize.height*0.5),
	        color = cc.c3b(255, 229, 200),
	        outLine = true,
	    })
	    _rightTipDi:addChild(_rightTipLab1)
	    self._nowRechargedNum = tonumber(params.rechargeMoney) or 0
	    self._nowRechargedNum = math.modf(self._nowRechargedNum/100)
	    local _rightTipLab2 = zc.createLabel({
			text = self._nowRechargedNum,
	        fontSize = 20,
	        ap = cc.p(0, 0.5),
	        pos = cc.p(0, _rightTipSize.height*0.5),
	        outLine = true,
	    })
	    _rightTipDi:addChild(_rightTipLab2)
	    local _rightTipImg = zc.createLabel({
			text = zc.lang("gold"),
	        fontSize = 20,
	        ap = cc.p(0, 0.5),
	        pos = cc.p(0, _rightTipSize.height*0.5),
	        color = cc.c3b(255, 229, 200),
	        outLine = true,
	    })
	    _rightTipDi:addChild(_rightTipImg)
	    local _partW = 20
	    local __width = _rightTipLab1:getContentSize().width + _rightTipLab2:getContentSize().width + _rightTipImg:getContentSize().width
	    __width = __width + _partW
	    local __startPosX = (_rightTipSize.width - __width + _partW) * 0.5

	    if __width > _rightTipSize.width then
	    	__startPosX = _partW*0.5
	    end
	    _rightTipLab1:setPositionX(__startPosX)
	    _rightTipLab2:setPositionX(__startPosX + _rightTipLab1:getContentSize().width)
	    _rightTipImg:setPositionX(__startPosX + _rightTipLab1:getContentSize().width + _rightTipLab2:getContentSize().width)
		_rightTipSize.width = __width > _rightTipSize.width and __width or _rightTipSize.width
    	_rightTipDi:setContentSize(_rightTipSize)
    end

    self:freshInfo(params, true)
end


function RechargeFirstLayer:udpateRedDot(params)
	local _params = params or {}
	local _status = _params.status or {}

	for k,v in pairs(_status) do
		if tonumber(v) == 1 then
			PlayerData:updateRedDotData(7,1)
			zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_ACTIVITY_REDDOT, data = {id = 9}})
			return
		end
	end
	PlayerData:updateRedDotData(7,0)

	zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_ACTIVITY_REDDOT, data = {id = 9}})
end

function RechargeFirstLayer:freshInfo( params, isInit )
	local _params = params or {}
	local _status = _params.status or {}
	self._fisrtData = {}
	for k,v in pairs(_status) do
		if tonumber(k) == tonumber(self._firstDbInfo.id) then
			self._firstDbInfo.status = tonumber(v) or 0
			break
		end
	end

	local _nextNum, _haveNext, _haveUnFinish
	for k,v in pairs(self._cumulativeInfos) do
		for key,value in pairs(_status) do
			if tonumber(key) == tonumber(v.id) then
				v.status = tonumber(value) or 0
				if v.status == 0 then
					_haveUnFinish = true
					local _parameter = tonumber(v.parameter) or 0
					local _pNum = _parameter - self._nowRechargedNum
					_pNum = _pNum > 0 and _pNum or 0
					if not _nextNum or _pNum < _nextNum then
						_nextNum = _pNum
						_haveNext = k
					end
				elseif v.status == 1 then
					if not _haveNext or _haveNext > k then
						_haveNext = k
					end
				end
			end
		end
	end
	if _nextNum then
		self._leftTipDi:setVisible(true)
		self._leftTipDi2:setVisible(false)
		self._leftTipLab2:setString(_nextNum)
		local _fixWidth = -10
		local __startPosX = 5
		local __width = _fixWidth
		for i,v in ipairs(self._infoTb) do
			local _x = __startPosX + __width
			__width = __width + v.target:getContentSize().width*v.scale
			if i == 2 then
				_x = _x + _fixWidth
				__width = __width + _fixWidth
			end 
			v.target:setPositionX(_x)
		end
		self._leftTipDi:setContentSize(__width + 10, self._leftTipDi:getContentSize().height)
	else
		self._leftTipDi:setVisible(false)
		self._leftTipDi2:setVisible(true)
	end

	if self._firstDbInfo.status == 2 then
		self._rechargeBtn:setEnable(false)
		self._rechargeBtn:setString(LANGUAGE_TOLLGATEHERO.fetched)
	elseif self._firstDbInfo.status == 1 then
		self._rechargeBtn:setEnable(true)
		self._rechargeBtn:setString(zc.lang("fetch_2"))
	else
		self._rechargeBtn:setEnable(true)
		self._rechargeBtn:setString(LANGUAGE_RECHARGE.recharge_space)
	end


	if not _haveNext then
		_haveNext = _haveUnFinish and 1 or #self._cumulativeInfos
	end
	self._pubLayer:reloadDataAndScrollToCurrentCell()
    self._pubLayer:scrollToCell(_haveNext - 1, not isInit)
    self._scorllviewScriptScroll(self._pubLayer, true)
end

function RechargeFirstLayer:doRecieve( id )
	zc.sendHttp({
        apiName = "RechargeFirst_get",
        params = {type=5001, id = id},
        successCallback = function(backData)
	        backData.noAnimation = true

        	PlayerData:updataData(backData)
        	zc.createShowReward(backData)
        	local _params = {
				status = backData.status,
			}

	        -- 获得兵器武将
	        local _weaponInfo = nil
	        local _heroId = nil
	        for i, v in ipairs( backData.clientItems ) do
	            local _mainType = tonumber( v.type ) or 0
	            if _mainType == 3 then
	                _weaponInfo = PlayerData:getWeaponInfoInfoById( v.model.id )
	                break
	            elseif _mainType == zc.mainTypeSoldier then
	                _heroId = v.model.heroId
	                break
	            end
	        end
	        if _weaponInfo then
	            zc.createPop("makeGodWeapon", {info = _weaponInfo, onlyShow = true})
	        elseif _heroId then
	            zc.createPubShowGetHero({id=_heroId})
	        end
	        self:udpateRedDot(_params)
        	self:freshInfo(_params)
        end
    })
end

function RechargeFirstLayer:dealWithCell( _cell, _index )
	if not _cell._di then
		local _di = zc.getSprite({
			src = "res/Main/activity/rechargeFirst/cellBg.png",
			ap = cc.p(1, 0.5),
			pos = cc.p(_cell:getContentSize().width, _cell:getContentSize().height - 90)
		})
		_cell:addChild(_di)
		_cell._di = _di
		local _diSize = _di:getContentSize()
		local _label1 = zc.createLabel({
			text = zc.lang("recharge_count"),
	        fontSize = 20,
	        ap = cc.p(0, 0.5),
	        pos = cc.p(90, 110),
	        color = cc.c3b(255, 229, 200),
	        outLine = true,
	    })
	    _di:addChild(_label1)
		local _label2 = zc.createLabel({
			text = "",
	        fontSize = 20,
	        ap = cc.p(0, 0.5),
	        pos = cc.p(_label1:getPositionX() + _label1:getContentSize().width, _label1:getPositionY()),
	        color = display.COLOR_YELLOW,
	        outLine = true,
		})
	    _di:addChild(_label2)
		_cell._label2 = _label2
		local _label3 = zc.createLabel({
			text = zc.lang("gold"),
	        fontSize = 20,
	        ap = cc.p(0, 0.5),
	        pos = cc.p(_label2:getPositionX() + _label2:getContentSize().width, _label1:getPositionY()),
	        color = cc.c3b(255, 229, 200),
	        outLine = true,
	    })
	    _di:addChild(_label3)
		_cell._label3 = _label3

		local _rechargeBtn = zc.createCommomBtn({
			tag = 3,
			text = LANGUAGE_RECHARGE.recharge_space,
			scale = 0.7,
			fontSize = 28,
			needSwallow = false,
			needEnableWhenMoving = true,
			pos = cc.p(_diSize.width*0.5, -25),
			endCallback = function() end,
		})
		_di:addChild(_rechargeBtn)
	    _cell._rechargeBtn = _rechargeBtn

	    local _line = zc.getSprite({
			src = "res/Main/activity/rechargeFirst/cutLine.png",
			pos = cc.p(_diSize.width*0.5 - 10, -60)
		})
		_di:addChild(_line)
	    _cell._line = _line
	end
	local _data = self._cumulativeInfos[_index]

	local _parameter = tonumber(_data.parameter) or 0
	_cell._label2:setString(_parameter)
	_cell._label3:setPositionX(_cell._label2:getPositionX() + _cell._label2:getContentSize().width)

	if _cell.scorllView then
		_cell.scorllView:removeFromParent()
		_cell.scorllView = nil
	end
	local _itemDatas = {}
	for i=1, 4 do
		local __data = _data["reward" .. i]
		if __data and __data ~= "" then
			_itemDatas[#_itemDatas + 1] = string.split(__data, "|")
		end
	end
	local _length = #_itemDatas
	if _length > 0 then
		local _onePartWidth = 65
		local _oneHeight = 70
		local dropScrollView = zc.createScrollview({
	        pos = cc.p(4, 1),
	        size = cc.size(254, _oneHeight),
	        innerSize = cc.size(_onePartWidth*_length, _oneHeight),
	        dir = ccui.ScrollViewDir.horizontal,
	        bar = false,
	        bounceEnable = true,
	    })
	    dropScrollView:setSwallowTouches(false)
	    _cell.scorllView = dropScrollView
	    _cell._di:addChild(dropScrollView)
		for i=1, _length do
			local __data = _itemDatas[i]
			local _item = zc.createIconByData({
	            data = {
					mainType = __data[1],
					type = __data[2],
	                id = __data[2],
	                num = __data[3],
				},
	            pos = cc.p((i-1/2)*_onePartWidth, _oneHeight*0.5), 
	        })
	        _item:setTouchEndedShowTip()
	        _item:setScale(0.5)
	        dropScrollView:addChild(_item)
		end
	end

	local _status = tonumber(_data.status) or 0
	if _status == 2 then
		_cell._rechargeBtn:setEnable(false)
		_cell._rechargeBtn:setString(LANGUAGE_TOLLGATEHERO.fetched)
	elseif _status == 1 then
		_cell._rechargeBtn:setEnable(true)
		_cell._rechargeBtn:setString(zc.lang("fetch_2"))
	else
		_cell._rechargeBtn:setEnable(true)
		_cell._rechargeBtn:setString(LANGUAGE_RECHARGE.recharge_space)
	end
	_cell._rechargeBtn:setTouchEndedCall(function()
		if _status == 0 then
			LayerManager.backToMainCity(false)
			zc.createRechargePop()
		elseif _status == 1 then
			self:doRecieve(_data.id)
		end
	end)
	if _index == #self._cumulativeInfos then
		_cell._line:setVisible(false)
	else
		_cell._line:setVisible(true)
	end
end

return RechargeFirstLayer