--[[
	演武榜名人堂
	唐实聪
	2016.3.18
]]
local ArenaHallFamePop = class("ArenaHallFamePop", function()
	return ZCPopLayer:create()
end)

function ArenaHallFamePop:create( params )
	local _pop = ArenaHallFamePop.new( params.data )
	_pop:show()
	return _pop
end

function ArenaHallFamePop:ctor( data )
	self:initData( data )
	self:initUI()
	self:refresh()
end

function ArenaHallFamePop:initData( data )
	-- dump( data, "ArenaHallFamePop" )
	self._index = data.index or 1
	self._hallFameData = data.hallFames
	table.sort(self._hallFameData, function( a, b )
		return a.time < b.time
	end)

	self._scale = 1

	self._size = self:getContentSize()
end

function ArenaHallFamePop:initUI()
	-- 标题背景云
	local titleCloud = zc.createSprite( "res/Main/common/title_bg_cloud.png" )
	self:addContent( titleCloud )
	-- 背景
	-- local background = zc.createSprite( "res/Main/common/popBg/popBg_red_big.png" )
	local background = zc.createNormalPop({
		src = "res/Main/common/popBg/popBg_red_big.png",
		bianZOrder = 0,
		height = 558,
	})
	background:setPosition( self._size.width/2, self._size.height/2 )
	self:addContent( background )
	self._bg = background
	self._bgSize = background:getContentSize()

	titleCloud:setAnchorPoint( 0, 0.5 )
	titleCloud:setPosition( self._size.width/2 - background:getContentSize().width/2 - 80, self._size.height/2 + background:getContentSize().height/2 )
	-- 标题背景
	local titleBg = zc.createSprite( "res/Main/common/title_bg_shadow.png" )
	titleBg:setAnchorPoint( 0, 0.5 )
	titleBg:setPosition( -30, self._bgSize.height )
	self._bg:addChild( titleBg )
	-- 标题
	local title = zc.createSprite( "res/Main/arena/hallFame/title.png" )
	title:setAnchorPoint( 0, 0.5 )
	title:setPosition( -5, self._bgSize.height )
	self._bg:addChild( title )

	-- 名人堂背景
	local hallFameBg = zc.createSprite( "res/Main/arena/hallFame/background.jpg" )
	hallFameBg:setPosition( self._bgSize.width/2, 245 )
	self._bg:addChild( hallFameBg )
	self._hallFameBg = hallFameBg
	-- 人物大图
	local heroSp = cc.Sprite:create()
	-- heroSp:setContentSize( 900, 595 )
	heroSp:setAnchorPoint( 0.5, 0)
	heroSp:setScale(0.7)
	heroSp:setPosition( self._hallFameBg:getContentSize().width - 220, 0)
	self._hallFameBg:addChild( heroSp )
	self._heroSp = heroSp

	-- 第
	local title_di = zc.createSprite( "res/Main/arena/hallFame/title_di.png" )
	title_di:setPosition( 105, 380 )
	self._hallFameBg:addChild( title_di )
	-- 几
	local title_num = zc.createFntLabel({
		fnt = "res/Main/arena/hallFame/fnt/arenaHallFame_num.fnt",
        text = 100,
        ap = cc.p(0, 0.5),
        pos = cc.p( title_di:getPositionX() + title_di:getContentSize().width*0.5 - 20, 430 ),
        addwidth = -6,
	})
	self._hallFameBg:addChild( title_num )
	self._title_num = title_num
	-- 届
	local title_jie = zc.createSprite( "res/Main/arena/hallFame/title_jie.png" )
	title_jie:setAnchorPoint(0, 0.5)
	title_jie:setPosition( 360, 380 )
	self._hallFameBg:addChild( title_jie )
	self._title_jie = title_jie

	-- 玩家tableview
	local heroSize = cc.size( 335, 240 )
	local heroTableview = zc.ZCTableView:create( heroSize )
	heroTableview:setAutoAlign( true )
    heroTableview:setBounceable( true )
    heroTableview:setInertia( true )
    heroTableview:setDirection( cc.SCROLLVIEW_DIRECTION_HORIZONTAL )
    heroTableview:setPosition( 70, 70 )
    heroTableview:setDelegate()
    heroTableview:setVerticalFillOrder( cc.TABLEVIEW_FILL_TOPDOWN )

    local function cellSizeForTable(table, idx) 
        return heroSize.height, heroSize.width
    end
    local function tableCellAtIndex(table, cellIndex)
        local cell = table:dequeueCell()
        -- 创建模板
        if cell == nil then
            cell = zc.ZCTableViewCell:new()
        end
        cell:removeAllChildren()
		local data = self._hallFameData[cellIndex + 1]

		local genderLightPath = nil
		local modelId = nil
		if data.seigniorId == 1 then
			-- 光圈
			genderLightPath = "res/Main/arena/maleLight.png"
			-- 英雄
			modelId = gameData.getDataFromCacheWithPrimaryKey("hero", 101).modelId
		else
			-- 光圈
			genderLightPath = "res/Main/arena/femaleLight.png"
			-- 英雄
			modelId = gameData.getDataFromCacheWithPrimaryKey("hero", 102).modelId
		end
		-- 光圈
		local genderLight = cc.Sprite:create( genderLightPath )
		genderLight:setPosition( 180, 80 )
		cell:addChild( genderLight )
		-- 英雄
		local armature = zc.battle.createHeroArmatureWithResId( modelId, data.weaponId )
        armature:setPosition( genderLight:getPosition() )
        armature:setScale( self._scale )
        armature:getAnimation():play("idle")
		cell:addChild( armature )

		zc.soldierChangeWeapon( armature, data.weaponId or 0 )

        return cell
    end
    local function numberOfCellsInTableView()
        return #self._hallFameData
    end
    local function tablePageAfterSliding( table, cell )
        local _index = table:getCurrentPage() + 1
        if _index ~= self._index then
        	self._index = _index
        	self:refresh()
        end
    end
    heroTableview:registerScriptHandler(cellSizeForTable, cc.TABLECELL_SIZE_FOR_INDEX)
    heroTableview:registerScriptHandler(tableCellAtIndex, cc.TABLECELL_SIZE_AT_INDEX)
    heroTableview:registerScriptHandler(numberOfCellsInTableView, cc.NUMBER_OF_CELLS_IN_TABLEVIEW)
    heroTableview:registerScriptHandler(tablePageAfterSliding,zctech.TABLECELL_AFTER_SLIDING)
    self._hallFameBg:addChild(heroTableview)
    heroTableview:reloadData()
    self._heroTableview = heroTableview
    -- 左按钮
	local leftBtn = zc.createPushButton({
		normalFile = "res/Main/arena/hallFame/arrow_up.png",
		selectedFile = "res/Main/arena/hallFame/arrow_down.png",
		needSwallow = false,
		endCallback = function()
			if self._index > 1 then
				heroTableview:scrollToCell( heroTableview:getCurrentPage() - 1, true )
			end
		end,
		pos = cc.p( 30, 200 ),
	})
	self._hallFameBg:addChild( leftBtn, 1 )

	-- 右按钮
	local _normal_r = cc.Sprite:create( "res/Main/arena/hallFame/arrow_up.png" )
	_normal_r:setFlippedX( true )
	local _selected_r = cc.Sprite:create( "res/Main/arena/hallFame/arrow_down.png" )
	_selected_r:setFlippedX( true )
	local rightBtn = zc.createPushButton({
		normalNode = _normal_r,
		selectedNode = _selected_r,
		needSwallow = false,
		endCallback = function()
			if self._index < #self._hallFameData then
				heroTableview:scrollToCell( heroTableview:getCurrentPage() + 1, true )
			end
		end,
		pos = cc.p( 445, 200 ),
	})
	self._hallFameBg:addChild( rightBtn, 1 )

    -- 兵器图标
    local weaponIcon = cc.Sprite:create()
    weaponIcon:setContentSize( 39, 39 )
    weaponIcon:setPosition( 143, 75 )
    self._hallFameBg:addChild( weaponIcon, 1 )
    self._weaponIcon = weaponIcon
    -- 名字背景
    local nameBg = zc.createSprite( "res/Main/arena/hallFame/nameBg.png" )
    nameBg:setAnchorPoint( 0, 0.5 )
    nameBg:setPosition( weaponIcon:getPositionX() - 7, weaponIcon:getPositionY() )
    self._hallFameBg:addChild( nameBg )
	-- 名字
	local name = zc.createLabel({
        fontSize = 20,
        stroke = true,
        pixel = 2,
        alignment = cc.TEXT_ALIGNMENT_CENTER,
        pos = cc.p( nameBg:getContentSize().width/2, nameBg:getContentSize().height/2 ),
	})
	nameBg:addChild( name )
	self._name = name
	-- 至当前届
	local toCurrent = zc.createLabel({
		text = LANGUAGE_ARENA.to_current,
		fontSize = 18,
        stroke = true,
        color = display.COLOR_YELLOW,
        pixel = 2,
        alignment = cc.TEXT_ALIGNMENT_CENTER,
        pos = cc.p( 55, 25 ),
	})
	self._hallFameBg:addChild( toCurrent )
	-- 下划线
	local downLine_text = ""
	for i = 1, zc.stringLen( LANGUAGE_ARENA.to_current ) do
		downLine_text = downLine_text.."_"
	end
	local downLine = zc.createLabel({
		text = downLine_text,
		fontSize = 18,
        stroke = true,
        color = display.COLOR_YELLOW,
        pixel = 2,
        -- alignment = cc.TEXT_ALIGNMENT_LEFT,
        ap = cc.p( 0, 0 ),
        pos = cc.p( 0, -3 ),
	})
	toCurrent:addChild( downLine )
	-- 接收触摸
	local toCurrentBtn = zc.createPushButton({
		touchSize = toCurrent:getContentSize(),
		pos = cc.p( toCurrent:getPosition() ),
		endCallback = function()
			if self._index ~= #self._hallFameData then
				self._heroTableview:scrollToCell( #self._hallFameData - 1 )
			end
		end
	})
	self._hallFameBg:addChild( toCurrentBtn )

	-- 总届数
	local totalNum = zc.createLabel({
		fontSize = 18,
        stroke = true,
        pixel = 2,
        alignment = cc.TEXT_ALIGNMENT_CENTER,
        pos = cc.p( 164, 25 ),
	})
	self._hallFameBg:addChild( totalNum )
	self._totalNum = totalNum

	-- 分享
	local shareBg = zc.createSprite( "res/Main/arena/hallFame/shareBg.png" )
    shareBg:setAnchorPoint( 1, 0 )
    shareBg:setPosition( self._hallFameBg:getContentSize().width, 0 )
    self._hallFameBg:addChild( shareBg )
    -- 分享按钮背景
	local shareBtnBg = zc.createSprite( "res/Main/arena/btnBg.png" )
	shareBtnBg:setPosition( shareBg:getContentSize().width/2 + 10, shareBg:getContentSize().height/2 - 13 )
	shareBg:addChild( shareBtnBg )
    -- 分享按钮
	local shareBtn = zc.createPushButton({
		normalFile = "res/Main/arena/hallFame/share_up.png",
		selectedFile = "res/Main/arena/hallFame/share_down.png",
		needSwallow = false,
		endCallback = function()
			-- zc.createArenaHallFamePop()
		end,
		pos = cc.p( shareBtnBg:getContentSize().width/2, shareBtnBg:getContentSize().height/2 ),
	})
	shareBtnBg:addChild( shareBtn )
	-- 分享文字
	local shareLabel = zc.createLabel({
        text = LANGUAGE_ARENA.share,
        fontSize = 20,
        stroke = true,
        pixel = 2,
        ap = cc.p( 0.5, 0 ),
        pos = cc.p( shareBtnBg:getContentSize().width/2, 0 ),
	})
	shareBtnBg:addChild( shareLabel )

	-- 关闭按钮
	local closeBtn = zc.createBackButton({
		pos = cc.p( self._bgSize.width, self._bgSize.height ),
		listener = function ()
			self:hide()
		end
	})
	self._bg:addChild( closeBtn )

	--
	heroTableview:scrollToCell( 100000, false )

end
function ArenaHallFamePop:refresh()
	local data = self._hallFameData[self._index]

	self._title_num:setString( self._index )
	self._title_jie:setPositionX(self._title_num:getPositionX() + self._title_num:getContentSize().width - 30)
	self._name:setText( data.userName )
	local _weaponData = gameData.getDataFromCacheWithPrimaryKey("weapon", data.weaponId)
	self._weaponIcon:setTexture( zc.getHeroTypeImg( _weaponData.type ) )
	self._totalNum:setText( LANGUAGE_ARENA_PERIOD( self._index, #self._hallFameData ) )
	-- 人物
	local iconId = tonumber( data.iconId ) or 1
	iconId = iconId + 100
	
	self._heroSp:runAction(
		cc.Sequence:create(
			cc.EaseExponentialIn:create(
				cc.MoveTo:create(
					0.5, cc.p( self._hallFameBg:getContentSize().width + self._heroSp:getContentSize().width - 220, 0)
				)
			),
			cc.CallFunc:create(
				function()
					local heroPath = string.format( "res/Main/hero/body/%s.png", iconId )
				    if not zc.checkFileExist(heroPath) then
				        heroPath = "res/Main/hero/body/101.png"
				    end  
				    self._heroSp:setTexture( heroPath )
				end
			),
			cc.EaseExponentialOut:create(
				cc.MoveTo:create(
					0.5, cc.p( self._hallFameBg:getContentSize().width - 220, 0)
				)
			)
		)
	)
end

return ArenaHallFamePop