--  Created by zhangchao on 16-04-29.
local caocao = class("caocao", function ( params )
	local hero = BattleHero.new(params)
	return hero
end)

function caocao:create(params)
	return caocao.new(params)
end

local csbs = nil
function caocao:ctor(params)
	csbs = {"caocao_atk3"}
	self:preloadCsbs(csbs)
end

function caocao:getCsbFiles()
	return csbs
end
function caocao:shouldMoveAttack(atkName)
	local ret = true
	if atkName == BATTLE_ANIMATION_ACTION.ATK0 then
		ret = false
	end
	return ret
end


function caocao:doAnimationEvent(evt)
	if evt == "change" then
		local armature = self:getArmature()
		if armature:getBone("weapons") then
			do
				local _bone = armature:getBone("change")
				local armature = zc.battle.createBattleEffect({fileName = "change" , actName = "change" , autoRemove = true, completeCallback = function()					
				end})
			    _bone:addDisplay(armature, 0)
                _bone:changeDisplayWithIndex( 0, true )
                _bone:getDisplayRenderNode():setCascadeOpacityEnabled( false )
                _bone:setOpacity( 255 )
			end

			local weaponId = 18
			zc.soldierChangeWeapon(armature, weaponId)
		else
	    	print(self._heroName.."不存在weapons******************************************")
	    end
	end
end


function caocao:getAttackPoint(skillType,targetHero)
	local rect 			= BATTLE_BONE_NAME.RECT_ATK
	if skillType == 1 then --1.普通攻击
    elseif skillType == 2 then --2.小技能 
        rect 			= BATTLE_BONE_NAME.RECT_ATK0
    elseif skillType == 3 then--3.士气技能 大招
        rect 			= BATTLE_BONE_NAME.RECT_SUPER
    elseif skillType == 4 then
        --4.合体技
    end
    local runningScene 		= cc.Director:getInstance():getRunningScene()
	local y 				= targetHero:getPositionY()
	local denfenser_point 	= targetHero:getSlotPositionInNode(BATTLE_BONE_NAME.MID,runningScene)
	-- dump(denfenser_point,"denfenser_point")
	local attackerMidBox	= self:getBoneBoundingBoxByName(rect)
	local x 				= denfenser_point.x - attackerMidBox.width / 2
	if self:getSide() == BATTLE_SIDE.RIGHT then
		x 					= denfenser_point.x + attackerMidBox.width / 2
	end
	local pos 				= cc.p(x,y)
	--[[大招单独处理]]
	if skillType == 3 then
	    local tmp_side 	= self:getSide()
	    pos 			= zc.battle.getInitialMatrixPoint({side = tmp_side , position = 2})
	    local x 		= cc.Director:getInstance():getWinSize().width / 2
	    
	    local diff_x 	= 100
	    if tmp_side == BATTLE_SIDE.LEFT then
	    	diff_x 		= -100
	    end
	    pos.x 			= x + diff_x
	end
	return pos
end

function caocao:preAttack(params)
	local skillType 	= params.skillType
	local firstTarget   = params.firstTarget
	local fileName = nil
	local actName = nil
	if skillType == 3 then--
		fileName = "caocao_atk3"
		actName  = "atk3"
    end

    if fileName and actName then
		local armature = zc.battle.createBattleEffect({fileName = fileName , actName = actName})
	    -- armature:setPosition(self:getPosition())
	    if self:getSide() == BATTLE_SIDE.LEFT then
	    	armature:setScaleX(-1 * armature:getScaleX())
	    end
	 --    zc.dispatchEvent({
		-- 	name = EVENT_NAME_BATTLE_PLAY_EFFECT,
		-- 	data = {node = armature , zorder = self:getLocalZOrder() + 10},
		-- })
		self:addChild(armature)
    end
end

function caocao:isSkillEventAllDone(skillType,evt)
	local ret = true
	if skillType == 3 then
		if not string.find(evt,"hit3") then
			ret = false
	    end 
	end
	return ret
end

function caocao:getSkillHurtCount(skillType)
	local count = 1
	if skillType == 3 then
		count = 3
	end
	return count
end

return caocao




