--  Created by zhangchao on 16-03-29.
local caohong = class("caohong", function ( params )
	local hero = BattleHero.new(params)
	return hero
end)

function caohong:create(params)
	return caohong.new(params)
end

local csbs = nil
function caohong:ctor(params)
	csbs = {"caohong_atk3"}
	self:preloadCsbs(csbs)
end

function caohong:getCsbFiles()
	return csbs
end

function caohong:doAnimationEvent(evt)
	if evt == "do_atk3_hit1" then
		local armature = self:getRectEffectNode():getChildByTag(10086)
		if armature then
			local animation = armature:getAnimation()
			if animation then
				animation:play("atk3_1",-1,0)
			end
		end
	end
end
function caohong:isAttackEvent(evt)
	local attackEvt = false
	if string.find(evt,"hit") then
		attackEvt = true
	end
	if evt == "do_atk3_hit1" then
		attackEvt = false
	end
	return attackEvt
end
function caohong:doAttack(params)
	local skillType 	= params.skillType
	local process 		= params.process
	local evt     		= params.evt
	local hurtTargets   = params.hurtTargets
	if skillType ~= BATTLE_SKILL_TYPE.SUPER then
		self:doHurt(params)
	end
end

function caohong:getAttackPoint(skillType,targetHero)
	local rect 			= BATTLE_BONE_NAME.RECT_ATK
	if skillType == 1 then --1.普通攻击
    elseif skillType == 2 then --2.小技能 
        rect 			= BATTLE_BONE_NAME.RECT_ATK0
    elseif skillType == 3 then--3.士气技能 大招
        rect 			= BATTLE_BONE_NAME.RECT_SUPER
    elseif skillType == 4 then
        --4.合体技
    end
    local runningScene 		= cc.Director:getInstance():getRunningScene()
	local y 				= targetHero:getPositionY()
	local denfenser_point 	= targetHero:getSlotPositionInNode(BATTLE_BONE_NAME.MID,runningScene)
	local tmp_side = BATTLE_SIDE.RIGHT
	if self:getSide() == BATTLE_SIDE.RIGHT then
		tmp_side = BATTLE_SIDE.LEFT
	end
	if skillType == 3 then
		denfenser_point = zc.battle.getInitialMatrixPoint({side = tmp_side , position = 2})
		y = denfenser_point.y
	end
	-- dump(denfenser_point,"denfenser_point")
	local attackerMidBox	= self:getBoneBoundingBoxByName(rect)
	local x 				= denfenser_point.x - attackerMidBox.width / 2
	local tmp_side = BATTLE_SIDE.RIGHT
	if self:getSide() == BATTLE_SIDE.RIGHT then
		x 					= denfenser_point.x + attackerMidBox.width / 2
		tmp_side = BATTLE_SIDE.LEFT
	end
	local pos 				= cc.p(x,y)
	return pos
end

function caohong:preAttack(params)
	local skillType 	= params.skillType
	if skillType == 3 then--3.士气技能 大招
		local armature = zc.battle.createBattleEffect({
			fileName = "caohong_atk3",
			actName = "atk3",
			autoRemove = false,
			eventCallback = function(bone, evt, originFrameIndex, currentFrameIndex)
		        zc.battle.doShockAndFlash(evt)
		        if string.find(evt,"hit") then
					self:doHurt(params)
			    end
		    end,
	    })
        armature:getAnimation():setMovementEventCallFunc(function (armatureBack,movementType,movementID)
            if movementType == ccs.MovementEventType.complete and movementID == "atk3_1" then
				xpcall(
                	function()
                		armatureBack:removeFromParent()
                	end,
                	function()
                        print("armatureBack已被删除")
                    end
                )
			end
        end)
	    if self:getSide() == BATTLE_SIDE.LEFT then
	    	armature:setScaleX(-1 * armature:getScaleX())
	    end
	    self:getRectEffectNode():addChild(armature,0,10086)
    end
end


function caohong:getSkillHurtCount(skillType)
	local count = 1
	if skillType == 2 then
		count = 2
	elseif skillType == 3 then
		count = 7
	end
	return count
end

return caohong




