--  Created by zhangchao on 16-03-29.
local guanyu = class("guanyu", function ( params )
	local hero = BattleHero.new(params)
	return hero
end)
local csbs = nil
function guanyu:ctor(params)
	csbs = {"guanyu_Fit2","guanyu_atk0_1","guanyu_atk3"}
	self:preloadCsbs(csbs)
	self._fit2SkillId = 338
end

function guanyu:getCsbFiles()
	return csbs
end

function guanyu:create(params)
	return guanyu.new(params)
end

function guanyu:getFitSkillSrc()
	local fitSrc = {
		-- 技能名动画
		beijing = "bejing",
		skeletonActName = "guanyu",
		name = "guanyujuese",
		-- 合体技特效
		fileName = "guanyu_Fit2",
		actName = "Fit2",
	}
	if self._isFit2 then
		fitSrc.fileName = "guanyu_Fit2_A2"
		fitSrc.skeletonActName = fitSrc.skeletonActName .. "_fit2"
	end
	return fitSrc
end

function guanyu:getFitSkillPos( params )
	local armature = params.armature
	local firstTarget = params.firstTarget

    local tmp_side 	= self:getSide()
	local pos 		= zc.battle.getInitialMatrixPoint({side = tmp_side , position = 4})
	pos.x 			= pos.x + 50
    armature:setPosition(pos)
    if self:getSide() == BATTLE_SIDE.LEFT then
    	armature:setScaleX(-1 * armature:getScaleX())
    end
end

function guanyu:doAttack(params)
	local skillType 	= params.skillType
	local process 		= params.process
	local evt     		= params.evt
	local hurtTargets   = params.hurtTargets
	local firstTarget   = params.firstTarget

	local runningScene 	= cc.Director:getInstance():getRunningScene()
	if skillType == BATTLE_SKILL_TYPE.ATK0 and firstTarget then
		local fileName = "guanyu_atk0_1"
		local actName  = "atk0_1"
		local armature = zc.battle.createBattleEffect({fileName = fileName , actName = actName})
		local point  		= firstTarget:getSlotPositionInNode(BATTLE_BONE_NAME.MID,runningScene)
	    armature:setPosition(point)
	    zc.dispatchEvent({
			name = EVENT_NAME_BATTLE_PLAY_EFFECT,
			data = {node = armature , zorder = self:getLocalZOrder() + 10},
		})
		self:doHurt(params)
	else
		self:doHurt(params)
	end
end

function guanyu:getAttackPoint(skillType,targetHero)
	local rect 			= BATTLE_BONE_NAME.RECT_ATK
	if skillType == 1 then --1.普通攻击
    elseif skillType == 2 then --2.小技能 
        rect 			= BATTLE_BONE_NAME.RECT_ATK0
    elseif skillType == 3 then--3.士气技能 大招
        rect 			= BATTLE_BONE_NAME.RECT_SUPER
    elseif skillType == 4 then
        --4.合体技
    end
    local runningScene 		= cc.Director:getInstance():getRunningScene()
	local y 				= targetHero:getPositionY()
	local denfenser_point 	= targetHero:getSlotPositionInNode(BATTLE_BONE_NAME.MID,runningScene)
	-- dump(denfenser_point,"denfenser_point")
	local attackerMidBox	= self:getBoneBoundingBoxByName(rect)
	local x 				= denfenser_point.x - attackerMidBox.width / 2
	if self:getSide() == BATTLE_SIDE.RIGHT then
		x 					= denfenser_point.x + attackerMidBox.width / 2
	end
	local pos 				= cc.p(x,y)
	--[[大招单独处理]]
	if skillType == 3 then
	    local tmp_side 	= self:getSide()
	    pos 			= zc.battle.getInitialMatrixPoint({side = tmp_side , position = 2})
	    local x 		= cc.Director:getInstance():getWinSize().width / 2
	    
	    local diff_x 	= 180
	    if tmp_side == BATTLE_SIDE.LEFT then
	    	diff_x 		= -diff_x
	    end
	    pos.x 			= x + diff_x
	end
	return pos
end

function guanyu:showDefenseEffect(params)
	local skillType 	= params.skillType
	local hero 			= params.hero
	local runningScene 	= cc.Director:getInstance():getRunningScene()
	local point  		= hero:getSlotPositionInNode(BATTLE_BONE_NAME.MID,runningScene)
	if skillType == BATTLE_SKILL_TYPE.ATK0 then
		-- local armature = zc.battle.createBattleEffect({fileName = "guanyu_atk0_2" , actName = "atk0_2"})
	 --    armature:setPosition(point)
	 --    if hero:getSide() == BATTLE_SIDE.LEFT then
	 --    	armature:setScaleX(-1 * hero:getScaleX())
	 --    end
	 --    zc.dispatchEvent({
		-- 	name = EVENT_NAME_BATTLE_PLAY_EFFECT,
		-- 	data = {node = armature , zorder = hero:getLocalZOrder() + 15},
		-- })
	    hero:playAction(BATTLE_ANIMATION_ACTION.DEFENSE)
	elseif skillType == BATTLE_SKILL_TYPE.ATK then
		local armature = zc.battle.createBattleEffect({fileName = "guanyu_atk0_1" , actName = "atk_1"})
	    armature:setPosition(point)
	    if hero:getSide() == BATTLE_SIDE.LEFT then
	    	armature:setScaleX(-1 * hero:getScaleX())
	    end
	    zc.dispatchEvent({
			name = EVENT_NAME_BATTLE_PLAY_EFFECT,
			data = {node = armature , zorder = hero:getLocalZOrder() + 15},
		})
	    hero:playAction(BATTLE_ANIMATION_ACTION.DEFENSE)
	else
		self:showCommonDefenseEffect(params)
	end
end

function guanyu:preAttack(params)
	local skillType 	= params.skillType
	local firstTarget   = params.firstTarget
	local fileName = nil
	local actName = nil

	if skillType == 2 and firstTarget ~= nil then--
	elseif skillType == 3 then--
		fileName = "guanyu_atk3"
		actName  = "atk3"
		local armature = zc.battle.createBattleEffect({fileName = fileName , actName = actName})


	    local tmp_side 	= self:getSide()
	    local pos 		= zc.battle.getInitialMatrixPoint({side = tmp_side , position = 2})
	    local x 		= cc.Director:getInstance():getWinSize().width / 2
	    
	    local diff_x 	= 180
	    if tmp_side == BATTLE_SIDE.LEFT then
	    	diff_x 		= -diff_x
	    end
	    pos.x 			= x + diff_x
	    armature:setPosition(pos)
	    if self:getSide() == BATTLE_SIDE.LEFT then
	    	armature:setScaleX(-1 * armature:getScaleX())
	    end

		-- self:getRectEffectNode():addChild(armature)
	    zc.dispatchEvent({
			name = EVENT_NAME_BATTLE_PLAY_EFFECT,
			data = {node = armature , zorder = self:getLocalZOrder() + 10},
		})
    end
end
function guanyu:shouldMoveAttack(atkName)
	local ret = true
	if atkName == BATTLE_ANIMATION_ACTION.ATK0 then
		-- ret = false
	elseif atkName == BATTLE_ANIMATION_ACTION.SUPER then
		-- ret = false
	elseif atkName == BATTLE_ANIMATION_ACTION.FIT_START then
		ret = false
	end
	return ret
end

function guanyu:getSkillHurtCount(skillType)
	local count = 1
	if skillType == BATTLE_SKILL_TYPE.FIT then
		count = self._isFit2 and 3 or 7
	end
	return count
end

function guanyu:doFitSkillHitEff(params)
	if not self._isFit2 then
		self:_doNormalFitEff(params)
		return
	end
	local _targets_ = params.targets
	local skillType = params.skillType
	local process = params.process
	local evt = params.evt
	local hurtTargets = params.hurtTargets
	local firstTarget 	= params.firstTarget
	local all_heroes = params.all_heroes
	local fitSrc = params.fitSrc
	local fit_bg = params.fit_bg
	performWithDelay(self, function()
		local _actName = BATTLE_ANIMATION_ACTION.FIT_END
		if self._isFit2 then
			_actName = _actName .. "_A2"
		end
		self:playAction(_actName)
		for k,hero in pairs(_targets_) do
			hero:playAction(_actName)
		end

		local armature_fit2 = zc.battle.createBattleEffect({fileName = fitSrc.fileName, actName = fitSrc.actName, completeCallback = function( )						
			zc.dispatchEvent({ name = EVENT_NAME_BATTLE_SCREEN_DIM_DISMISS })
			fit_bg:removeFromParent()
		end})

	    if self:getSide() == BATTLE_SIDE.RIGHT then
	    	armature_fit2:setScaleX(-1 * armature_fit2:getScaleX())
	    end
	    armature_fit2:getAnimation():setFrameEventCallFunc(function ( bone, evt, originFrameIndex, currentFrameIndex)
	    	zc.battle.doShockAndFlash(evt)
	    	--[[每次受击]]
	        if string.find(evt,"do_fit_hit") then
				self:doAttack({skillType = skillType, process = process, evt = evt})
			elseif string.find(evt,"back") then
				self:_endFitSkill(all_heroes, _targets_)
	        end
	    end)

		local _position = firstTarget:getBattlePosition()
		if inArray(_position, {1,2,3}) then
			_position = 2
		elseif inArray(_position, {4,5, 6}) then
			_position = 5
		else
			_position = 8
		end
    	local _pos = zc.battle.getInitialMatrixPoint({side = firstTarget:getSide(), position = _position})

	    armature_fit2:setPosition(_pos)

		zc.dispatchEvent({
			name = EVENT_NAME_BATTLE_PLAY_EFFECT,
			data = {node = armature_fit2 , zorder = self:getLocalZOrder() + 30},
		})
	end,0)
end

return guanyu




