--  Created by wangming on 17-02-24.
local kuangnuzhimen = class("kuangnuzhimen", function ( params )
	local hero = BattleHero.new(params)
	return hero
end)

function kuangnuzhimen:create(params)
	return kuangnuzhimen.new(params)
end

function kuangnuzhimen:doAttack(params)
	local skillType 	= params.skillType
	local process 		= params.process
	local evt     		= params.evt
	local hurtTargets   = params.hurtTargets

	local runningScene 	= cc.Director:getInstance():getRunningScene()

	local runningScene 	= cc.Director:getInstance():getRunningScene()
	if skillType == BATTLE_SKILL_TYPE.ATK then
		for k,hero in pairs(hurtTargets) do
			local point = hero:getSlotPositionInNode(BATTLE_BONE_NAME.MID, runningScene)
		    local armature = zc.battle.createBattleEffect({fileName = "kuangnuzhimen", actName = "atk_1", loop = true, moveCallback = function (armatureBack,movementType,movementID)
                if movementType == ccs.MovementEventType.complete and (movementID == "atk_2") then
                    xpcall(function() armatureBack:removeFromParent() end, function ()
                        print("armatureBack已被删除")
                    end)
                end
            end, eventCallback = function(bone, evt, originFrameIndex, currentFrameIndex)
            	if self:isAttackEvent(evt) then
            		params.evt = evt
					self:doHurt(params)
            	end
            end})
		    armature:setPosition(self:getSlotPositionInNode(BATTLE_BONE_NAME.MID, runningScene))
		    if self:getSide() == BATTLE_SIDE.LEFT then
		    	armature:setScaleX(-1 * armature:getScaleX())
		    end
		    local _arrow = armature
			--起始位置
			local _targetSlot    	= cc.p(self:getPositionX(),self:getPositionY())
			--目标位置
			local endPos 			= point
			--计算角度
			-- 判定斜率,非弓箭状态
			local deltaY = endPos.y - _targetSlot.y;
			local deltaX = endPos.x - _targetSlot.x;
			local angel = deltaX > 0 and 0 or 180;
			local K = deltaY / deltaX;
			if deltaX ~= 0 then
				-- _arrow:setRotation(angel-CC_RADIANS_TO_DEGREES(math.atan(K)));
			end
			local pos_delta = cc.pGetDistance(endPos, _targetSlot)
			local dt = zc.getDynamicTime(pos_delta, 4000)

			_arrow:runAction(cc.Sequence:create(cc.MoveTo:create(dt,endPos),cc.CallFunc:create(function()
				armature:getAnimation():play("atk_2")
			end)))
			zc.dispatchEvent({
				name = EVENT_NAME_BATTLE_PLAY_EFFECT,
				data = {node = _arrow, zorder = hero:getLocalZOrder() + 1},
			})
		end
	elseif skillType == BATTLE_SKILL_TYPE.SUPER then
		local _side = self:getSide()
		if self:getSide() == BATTLE_SIDE.RIGHT then
			_side = BATTLE_SIDE.LEFT
		else
			_side = BATTLE_SIDE.RIGHT
		end
		local pos = zc.battle.getInitialMatrixPoint({side = _side, position = 5})
		local armature = zc.battle.createBattleEffect({fileName = "kuangnuzhimen", actName = "atk3_1", loop = false, moveCallback = function (armatureBack,movementType,movementID)
            if movementType == ccs.MovementEventType.complete and (movementID == "atk3_1") then
                xpcall(function() armatureBack:removeFromParent() end, function ()
                    print("armatureBack已被删除")
                end)
            end
        end, eventCallback = function(bone, evt, originFrameIndex, currentFrameIndex)
        	zc.battle.doShockAndFlash(evt)
        	if self:isAttackEvent(evt) then
        		params.evt = evt
				self:doHurt(params)
        	end
        end})
	    armature:setPosition(pos)
	    if self:getSide() == BATTLE_SIDE.LEFT then
	    	armature:setScaleX(-1 * armature:getScaleX())
	    end
	    local _zorder = 1
		for k,hero in pairs(hurtTargets) do
			if _zorder < hero:getLocalZOrder() then
				_zorder = hero:getLocalZOrder()
			end
		end
		zc.dispatchEvent({
			name = EVENT_NAME_BATTLE_PLAY_EFFECT,
			data = {node = armature, zorder = _zorder + 2},
		})
	else
		self:doHurt(params)
	end
end

function kuangnuzhimen:showDefenseEffect(params)
	local hero = params.hero
	hero:playAction(BATTLE_ANIMATION_ACTION.DEFENSE)
end

function kuangnuzhimen:getSkillHurtCount(skillType)
	local count = 1
	if skillType == 1 then
		count = 2
	elseif skillType == 3 then
		count = 4
	end
	return count
end

function kuangnuzhimen:shouldMoveAttack(atkName)
	local ret = false
	return ret
end

return kuangnuzhimen




