--  Created by zhangchao on 16-03-29.
local taishici = class("taishici", function ( params )
	local hero = BattleHero.new(params)
	return hero
end)

function taishici:create(params)
	return taishici.new(params)
end


function taishici:getSkillHurtCount(skillType)
	local count = 1
	if skillType == BATTLE_SKILL_TYPE.ATK0 then
		count = 8
	elseif skillType == BATTLE_SKILL_TYPE.SUPER then
		count = 10
	elseif skillType == BATTLE_SKILL_TYPE.FIT then
		count = 11
	end
	return count
end

function taishici:shouldMoveAttack(atkName)
	local ret = true
	if atkName == BATTLE_ANIMATION_ACTION.SUPER then
		ret = false
	end
	return ret
end

function taishici:showDefenseEffect(params)
	local skillType = params.skillType
	local hero 		= params.hero
    
    if skillType == BATTLE_SKILL_TYPE.SUPER then
    	hero:playAction(BATTLE_ANIMATION_ACTION.DEFENSE)
	else
		self:showCommonDefenseEffect(params)
    end
end

function taishici:preAttack(params)
	local skillType 	= params.skillType
	local firstTarget   = params.firstTarget
	local fileName = nil
	local actName = nil
	
	if skillType == BATTLE_SKILL_TYPE.SUPER and firstTarget ~= nil then--
		local armature  = zc.battle.createBattleEffect({fileName = "taishici" , actName = "atk3_1"})
	    local pos 		= cc.p(firstTarget:getPositionX(),firstTarget:getPositionY())
		local tmp_side 	= firstTarget:getSide()
    	-- pos 			= firstTarget:getPosition()
    	-- local diff_x 	= 10
	    -- if tmp_side == BATTLE_SIDE.RIGHT then
	    -- 	diff_x 		= -10
	    -- end
	    -- pos.x 			= pos.x + diff_x
	    armature:setPosition(pos)
	    if self:getSide() == BATTLE_SIDE.LEFT then
	    	armature:setScaleX(-1 * armature:getScaleX())
	    end
		zc.dispatchEvent({
			name = EVENT_NAME_BATTLE_PLAY_EFFECT,
			data = {node = armature, zorder = firstTarget:getLocalZOrder() + 1},
		})
    end
end
function taishici:doAttack(params)
	local skillType 	= params.skillType
	local process 		= params.process
	local evt     		= params.evt
	local hurtTargets   = params.hurtTargets
	local _targets_   	= params._targets_
	local endFunction   = params.endFunction

	local runningScene 	= cc.Director:getInstance():getRunningScene()
	if skillType == BATTLE_SKILL_TYPE.FIT then
		local oneTarget = hurtTargets[1]
		local endPosX
		if oneTarget then
			endPosX = oneTarget:getPositionX()
		else
			endPosX = zc.width / 2
		end
		local eight_pos  	= zc.battle.getInitialMatrixPoint({side=self:getSide(), position=8})
		local endPosY   = eight_pos.y
		local point  	= cc.p(endPosX, endPosY)
		local armature_fit2 = zc.battle.createBattleEffect({fileName = "taishici_fit2", actName = "Fit2", completeCallback = function( )						
			zc.dispatchEvent({ name = EVENT_NAME_BATTLE_SCREEN_DIM_DISMISS })
		end})
	    armature_fit2:getAnimation():setFrameEventCallFunc(function ( bone, evt, originFrameIndex, currentFrameIndex)
	    	zc.battle.doShockAndFlash(evt)
	    	--[[每次受击]]
	        if string.find(evt,"do_fit_hit") then
				self:doHurt(params)
				if evt == "do_fit_hit11" then
					if endFunction then
						performWithDelay(self, function()
							endFunction()
						end, 0.5 )
					end
				end
	        end
	    end)
	    armature_fit2:setPosition( point )
	    if self:getSide() == BATTLE_SIDE.LEFT then
    		armature_fit2:setScaleX(-1)
	    end

	    zc.dispatchEvent({
			name = EVENT_NAME_BATTLE_PLAY_EFFECT,
			data = {node = armature_fit2 , zorder = self:getLocalZOrder() + 100},
		})

	else
		self:doHurt(params)
	end
end
function taishici:getAttackPoint(skillType,targetHero)
	if skillType == BATTLE_SKILL_TYPE.FIT then
		return cc.p(self:getPositionX(), self:getPositionY())
	else
		return self:getAttackNormalPoint(skillType,targetHero)
	end
end
function taishici:getFitSkillSrc()
	local fitSrc = {
		-- 技能名动画
		beijing  = "bejing",
		skeletonActName = "taishici",
		name = "taishici",
		heroActName = "animation6",
		-- 合体技特效
		fileName = "taishici_fit2",
		actName = "Fit2",
		specialHandle = true,
	}
	return fitSrc
end
function taishici:showCommonDefenseEffect(params)
	local hero 		= params.hero
	--[[如果是自身，那么就不需要播放受击效果]]
	if hero ~= self then
		-- local point  	= hero:getSlotPositionInNode(BATTLE_BONE_NAME.MID,hero)
	    -- local effect 	= zc.createArmature({parentPath = "res/image/battle/ef_hit_jizhong/", fileName = "ef_hit_jizhong" , actName = "hit"})
	    -- effect:getAnimation():play("hit", -1, 0)
	    -- effect:setPosition(point)
	    -- hero:addChild(effect)
	 --    if hero:getSide() == BATTLE_SIDE.LEFT then
	 --    	effect:setScaleX(-1)
	 --    end
	 --    performWithDelay(effect,function()
	 --    	effect:removeFromParent()
		-- end,2)
	    --[[如果是攻击自身，那就会打断自身动作，会导致动作结束，特效可能还在播放(显示上不合理，所以如果是自身就不需要播放受击)]]
		hero:playAction(BATTLE_ANIMATION_ACTION.DEFENSE)
	end
end

return taishici




