--  Created by zhangchao on 16-03-29.
local wangyun = class("wangyun", function ( params )
	local hero = BattleHero.new(params)
	return hero
end)

function wangyun:create(params)
	return wangyun.new(params)
end

local csbs = nil
function wangyun:ctor(params)
	csbs = {"wy_atk3"}
	self:preloadCsbs(csbs)
end

function wangyun:getCsbFiles()
	return csbs
end


function wangyun:shouldMoveAttack(atkName)
	local ret = false
	return ret
end

function wangyun:doAttack(params)
	local skillType 	= params.skillType
	local process 		= params.process
	local evt     		= params.evt
	local hurtTargets   = params.hurtTargets

	local runningScene 	= cc.Director:getInstance():getRunningScene()
	if skillType == BATTLE_SKILL_TYPE.ATK and evt == "do_atk_hit1" then
		local flag = 0
		local ret = self:isSkillEventAllDone(skillType,evt)
		for k,hero in pairs(hurtTargets) do
			local point  		= hero:getSlotPositionInNode(BATTLE_BONE_NAME.MID,runningScene)
			local armature = zc.battle.createBattleEffect({fileName = "wangyun", actName = "atk_1", loop = true})
		    armature:setPosition(self:getSlotPositionInNode(BATTLE_BONE_NAME.MID,runningScene))
		    local _arrow = armature
			--起始位置
			local _targetSlot    	= cc.p(self:getPositionX(),self:getPositionY())
			--目标位置
			local endPos 			= point
			--计算角度
			-- 判定斜率,非弓箭状态
			local deltaY = endPos.y - _targetSlot.y;
			local deltaX = endPos.x - _targetSlot.x;
			local angel = deltaX > 0 and 0 or 180;
			local K = deltaY / deltaX;
			if deltaX ~= 0 then
				_arrow:setRotation(angel-CC_RADIANS_TO_DEGREES(math.atan(K)) + 180);
			end
			local pos_delta = cc.pGetDistance(endPos, _targetSlot)
			local dt = zc.getDynamicTime(pos_delta, 2000)
			flag = flag + 1
			local _tmp_ = flag
			_arrow:runAction(
				cc.Sequence:create(
					cc.MoveTo:create(dt,endPos),
					cc.CallFunc:create(function()
						local _armature = zc.battle.createBattleEffect({
							fileName = "wangyun",
							actName = "atk_2",
							moveCallback = function(armatureBack,movementType,movementID)
				                if movementType == ccs.MovementEventType.complete and (movementID == "atk_2" ) then
				                    xpcall(
				                    	function()
				                    		armatureBack:removeFromParent()
				                    	end,
				                    	function()
				                            print("armatureBack已被删除")
				                        end
			                        )
				                end
				            end
			            })
		    			_armature:setPosition(hero:getSlotPositionInNode(BATTLE_BONE_NAME.MID,runningScene))
						zc.dispatchEvent({
							name = EVENT_NAME_BATTLE_PLAY_EFFECT,
							data = {node = _armature, zorder = hero:getLocalZOrder() + 1},
						})
			    		if ret and _tmp_ == 1 then
			    			self:doHurt(params)
			    		end
					end),
					cc.RemoveSelf:create(true)
				)
			)
			zc.dispatchEvent({
				name = EVENT_NAME_BATTLE_PLAY_EFFECT,
				data = {node = _arrow, zorder = hero:getLocalZOrder() + 1},
			})
		end
	elseif skillType == BATTLE_SKILL_TYPE.SUPER and evt == "do_atk3_hit1" then
		local _delay = 0
		local flag = 0
		local ret = self:isSkillEventAllDone(skillType,evt)
		for k,hero in pairs(hurtTargets) do
			flag = flag + 1
			local _tmp_ = flag
			self:runAction(
				cc.Sequence:create(
					cc.DelayTime:create( _delay ),
					cc.CallFunc:create(function()
						local armature = zc.battle.createBattleEffect({
							fileName = "wangyun",
							actName = "atk3_1",
							moveCallback = function(armatureBack,movementType,movementID)
				                if movementType == ccs.MovementEventType.complete and (movementID == "atk3_1" ) then
				                    xpcall(
				                    	function()
				                    		armatureBack:removeFromParent()
				                    	end,
				                    	function()
				                            print("armatureBack已被删除")
				                        end
			                        )
				                end
				            end,
				            eventCallback = function(bone, evt)
				            	if evt == "do_atk3_hit1" then
						    		if ret and _tmp_ == 1 then
						    			self:doHurt(params)
						    		end
				            	end
				            end,
			            })
						armature:setPosition(hero:getSlotPositionInNode(BATTLE_BONE_NAME.ROOT,runningScene))
			            if self:getSide() == BATTLE_SIDE.LEFT then
							armature:setScaleX(-1)
						end
						zc.dispatchEvent({
							name = EVENT_NAME_BATTLE_PLAY_EFFECT,
							data = {node = armature, zorder = hero:getLocalZOrder() + 1},
						})
					end)
				)
			)
			_delay = _delay + 0.2
		end
	else
		self:doHurt(params)
	end
end

function wangyun:preAttack(params)
	local skillType 	= params.skillType
	local process 		= params.process
	if skillType == BATTLE_SKILL_TYPE.ATK0 and process then
		for i,process_item in pairs(process) do
			local action_type 			= tonumber(process_item[1])
			local action_model_id 		= process_item[2]
			local data 					= {id = action_model_id}
			zc.dispatchEvent({
				name = EVENT_NAME_BATTLE_GET_TARGET_BY_ID,
				data = data,
			})
			local hero = data.target
			--[[所有即将受到伤害的人物都需要高亮突出]]
			if BATTLE_ANIMATION_EVENT.DIM_SHOW == evt then
				hero:setColor(cc.c3b(255,255,255))
				-- print(self:getHeroName().."*******************".."变白")
			end
			--[[--第一项是固定格式，用于确定攻击者]]
			if action_type == 5 then
				local skillId 				= process_item[3]
				local skill_cover_targets	= process_item[7]--技能所覆盖的目标(战斗单元id列表) 
				local skill_mix_targets		= process_item[8]--参与辅助组合技能的战斗单元列表(战斗单元id列表)
				for i=1,#skill_cover_targets do
					local id 				= skill_cover_targets[i]
					if id ~= nil then
						local data 			= {id = id}
						zc.dispatchEvent({
							name = EVENT_NAME_BATTLE_GET_TARGET_BY_ID,
							data = data,
						})
						local target 		= data.target
						local armature = zc.battle.createBattleEffect({fileName = "wy_atk3" , actName = "atk0"})
					    target:getRectEffectNode():addChild(armature)
					end
				end
			end
		end--[[--for end]]
	end
end
function wangyun:showDefenseEffect(params)
	local skillType = params.skillType
	local hero 		= params.hero
    
    hero:playAction(BATTLE_ANIMATION_ACTION.DEFENSE)
end

return wangyun




