--  Created by zhangchao on 16-11-26.
local xushu = class("xushu", function ( params )
	local hero = BattleHero.new(params)
	return hero
end)

function xushu:create(params)
	return xushu.new(params)
end

local armature = nil
local csbs = nil
function xushu:ctor(params)
	armature = nil
	csbs = {"xushu_atk3"}
	self:preloadCsbs(csbs)
end

function xushu:getCsbFiles()
	return csbs
end
function xushu:doAttack(params)
	local skillType 	= params.skillType
	local process 		= params.process
	local evt     		= params.evt
	local hurtTargets   = params.hurtTargets

	local runningScene 	= cc.Director:getInstance():getRunningScene()
	if skillType == BATTLE_SKILL_TYPE.ATK then
		local _fileName = "xushu"
		local _actName  = "atk_1"
		-- if skillType == BATTLE_SKILL_TYPE.SUPER then
		-- 	_actName  = "atk3"
		-- end
		local flag = 0
		local ret = self:isSkillEventAllDone(skillType,evt)
		for k,hero in pairs(hurtTargets) do
			local point  		= hero:getSlotPositionInNode(BATTLE_BONE_NAME.MID,runningScene)
		    local armature = zc.battle.createBattleEffect({fileName = _fileName , actName = _actName , loop = true, moveCallback = function (armatureBack,movementType,movementID)
                if movementType == ccs.MovementEventType.complete and (movementID == "atk3_1" or movementID == "atk_2" ) then
                    xpcall(function() armatureBack:removeFromParent() end, function ()
                            print("armatureBack已被删除")
                        end)
                end
            end})
		    armature:setPosition(self:getSlotPositionInNode(BATTLE_BONE_NAME.MID,runningScene))
		    if self:getSide() == BATTLE_SIDE.LEFT then
		    	armature:setScaleX(-1 * armature:getScaleX())
		    end
		    local _arrow = armature
			--起始位置
			local _targetSlot    	= cc.p(self:getPositionX(),self:getPositionY())
			--目标位置
			local endPos 			= point
			--计算角度
			-- 判定斜率,非弓箭状态
			local deltaY = endPos.y - _targetSlot.y;
			local deltaX = endPos.x - _targetSlot.x;
			local angel = deltaX > 0 and 0 or 180;
			local K = deltaY / deltaX;
			if deltaX ~= 0 then
				-- _arrow:setRotation(angel-CC_RADIANS_TO_DEGREES(math.atan(K)));
			end
			local pos_delta = cc.pGetDistance(endPos, _targetSlot)
			local dt = zc.getDynamicTime(pos_delta, 3000)
			flag = flag + 1
			local _tmp_ = flag
			_arrow:runAction(cc.Sequence:create(cc.MoveTo:create(dt,endPos),cc.CallFunc:create(function()
				if skillType == BATTLE_SKILL_TYPE.SUPER then
					armature:getAnimation():play("atk3_1")
				elseif skillType == BATTLE_SKILL_TYPE.ATK then
					armature:getAnimation():play("atk_2")
				end
	    		hero:playAction(BATTLE_ANIMATION_ACTION.DEFENSE)
	    		if ret and _tmp_ == 1 then
	    			print("结束"..tostring(math.random(0,10)))
	    			self:doHurt(params)
	    		end
			end)))
			zc.dispatchEvent({
				name = EVENT_NAME_BATTLE_PLAY_EFFECT,
				data = {node = _arrow, zorder = hero:getLocalZOrder() + 2},
			})
		end
	else
		self:doHurt(params)
	end
end

function xushu:getAttackPoint(skillType,targetHero)
	local rect 			= BATTLE_BONE_NAME.RECT_ATK
	if skillType == 1 then --1.普通攻击
    elseif skillType == 2 then --2.小技能 
        rect 			= BATTLE_BONE_NAME.RECT_ATK0
    elseif skillType == 3 then--3.士气技能 大招
        rect 			= BATTLE_BONE_NAME.RECT_SUPER
    elseif skillType == 4 then
        --4.合体技
    end
    local pos 		= nil
	local tmp_side 	= self:getSide()
    pos 			= zc.battle.getInitialMatrixPoint({side = tmp_side , position = 5})
    local x 		= cc.Director:getInstance():getWinSize().width / 2
    
    local diff_x 	= 380
    if tmp_side == BATTLE_SIDE.LEFT then
    	diff_x 		= -380
    end
    pos.x 			= x + diff_x
    pos.y           = 50 + pos.y
	return pos
end

function xushu:shouldMoveAttack(atkName)
	local ret = false
	if atkName == BATTLE_ANIMATION_ACTION.SUPER then
		ret = true
	end
	return ret
end
function xushu:getSkillHurtCount(skillType)
	local count = 1
	if skillType == BATTLE_SKILL_TYPE.ATK0 then
		count = 3
	elseif skillType == BATTLE_SKILL_TYPE.SUPER then
		count = 9
	end
	return count
end

function xushu:showDefenseEffect(params)
	local skillType = params.skillType
	local hero 		= params.hero
    
    if skillType == BATTLE_SKILL_TYPE.ATK0 then
    	hero:playAction(BATTLE_ANIMATION_ACTION.DEFENSE)
	else
		self:showCommonDefenseEffect(params)
    end
end

function xushu:preAttack(params)
	local skillType 	= params.skillType
	local firstTarget   = params.firstTarget
	local fileName = nil
	local actName = nil

	if skillType == BATTLE_SKILL_TYPE.ATK0 and firstTarget ~= nil then--
		local armature  = zc.battle.createBattleEffect({fileName = "xushu" , actName = "atk0_1"})
	    local pos 		= nil
		local tmp_side 	= firstTarget:getSide()
    	pos 			= zc.battle.getInitialMatrixPoint({side = tmp_side , position = 5})
    	pos.x 			= firstTarget:getPositionX()
    	pos.y 			= pos.y + 30
    	local diff_x 	= 10
	    if tmp_side == BATTLE_SIDE.RIGHT then
	    	diff_x 		= -10
	    end
	    pos.x 			= pos.x + diff_x
	    armature:setPosition(pos)
	    if self:getSide() == BATTLE_SIDE.LEFT then
	    	armature:setScaleX(-1 * armature:getScaleX())
	    end
		zc.dispatchEvent({
			name = EVENT_NAME_BATTLE_PLAY_EFFECT,
			data = {node = armature, zorder = self:getLocalZOrder() + 1},
		})
	elseif skillType == 3 then--
		fileName = "xushu_atk3"
		actName  = "atk3"
		local armature = zc.battle.createBattleEffect({fileName = fileName , actName = actName})
	    -- armature:setPosition(self:getPosition())
	    if self:getSide() == BATTLE_SIDE.LEFT then
	    	armature:setScaleX(-1 * armature:getScaleX())
	    end
		self:addChild(armature)
    end
end
return xushu