--  Created by zhangchao on 16-03-29.
local zhangjiao = class("zhangjiao", function ( params )
	local hero = BattleHero.new(params)
	return hero
end)

function zhangjiao:create(params)
	return zhangjiao.new(params)
end

local csbs = nil
function zhangjiao:ctor(params)
	csbs = {"zhangjiao_atk3"}
	self:preloadCsbs(csbs)
end

function zhangjiao:getCsbFiles()
	return csbs
end

function zhangjiao:doAnimationEvent(evt)
	if evt == "change" then
		local armature = self:getArmature()
		if armature:getBone("weapons") then
			do
				local _bone = armature:getBone("change")
				local armature = zc.battle.createBattleEffect({fileName = "change" , actName = "change" , autoRemove = true, completeCallback = function()					
				end})
			    _bone:addDisplay(armature, 0)
                _bone:changeDisplayWithIndex( 0, true )
                _bone:getDisplayRenderNode():setCascadeOpacityEnabled( false )
                _bone:setOpacity( 255 )
			end

			local weaponId = 34
			zc.soldierChangeWeapon(armature, weaponId)
		else
	    	print(self._heroName.."不存在weapons******************************************")
	    end
	end
end

function zhangjiao:doAttack(params)
	local skillType 	= params.skillType
	local evt     		= params.evt
	local hurtTargets   = params.hurtTargets

	local runningScene 	= cc.Director:getInstance():getRunningScene()
	if skillType == BATTLE_SKILL_TYPE.SUPER then
		local armature = zc.battle.createBattleEffect({fileName = "zhangjiao_atk3" , actName = "atk3" , eventCallback = function(bone, _evt, originFrameIndex, currentFrameIndex)
	        zc.battle.doShockAndFlash(_evt)
	        if string.find(_evt,"hit") then
	        	params.evt = _evt
				self:doHurt(params)
		    end
	    end})
	    local tmp_side = self:getSide()
	    if tmp_side == BATTLE_SIDE.LEFT then
	    	tmp_side = BATTLE_SIDE.RIGHT
	    else
	    	tmp_side = BATTLE_SIDE.LEFT
	    end
	    local pos = zc.battle.getInitialMatrixPoint({side = tmp_side , position = 6})
	    local diff_x = -80
	    if tmp_side == BATTLE_SIDE.RIGHT then
	    	diff_x = -200
	    end
	    pos.x = pos.x + diff_x
	    armature:setPosition(pos)
	    
	    zc.dispatchEvent({
			name = EVENT_NAME_BATTLE_PLAY_EFFECT,
			data = {node = armature , zorder = self:getLocalZOrder() + 41},
		})
	else
		self:doHurt(params)
	end

end

function zhangjiao:getSkillHurtCount(skillType)
	local count = 1
	if skillType == 3 then
		count = 13
	end
	return count
end

function zhangjiao:showDefenseEffect(params)
	local skillType = params.skillType
	local hero 		= params.hero
	local point  	= hero:getSlotPositionInNode(BATTLE_BONE_NAME.MID,hero)
    
    if skillType == BATTLE_SKILL_TYPE.ATK0 then
		local armature = zc.battle.createBattleEffect({fileName = "zhangjiao_atk3" , actName = "atk0"})
	    armature:setPosition(hero:getPosition())
	    zc.dispatchEvent({
			name = EVENT_NAME_BATTLE_PLAY_EFFECT,
			data = {node = armature , zorder = hero:getLocalZOrder() + 1},
		})
    	hero:playAction(BATTLE_ANIMATION_ACTION.DEFENSE)
    elseif skillType == BATTLE_SKILL_TYPE.ATK then
    	local effect 	= zc.battle.createBattleEffect({fileName = "zhangjiao_atk3" , actName = "atk_2"})
	    effect:setPosition(point)
	    hero:addChild(effect)
    	hero:playAction(BATTLE_ANIMATION_ACTION.DEFENSE)
	else
		self:showCommonDefenseEffect(params)
    end
end

function zhangjiao:preAttack(params)
	local skillType 	= params.skillType
	local firstTarget   = params.firstTarget
	-- skillType = 2
	if skillType == 1 and firstTarget ~= nil then--
		do
			local armature = zc.battle.createBattleEffect({fileName = "zhangjiao_atk3" , actName = "atk_1"})
		    if self:getSide() == BATTLE_SIDE.LEFT then
		    	armature:setScaleX(-1 * armature:getScaleX())
		    	armature:setPosition(cc.p(self:getPositionX(),self:getPositionY() - 50))
		    else
		    	armature:setPosition(cc.p(self:getPositionX(),self:getPositionY() + 50))
		    end
		    local _arrow = armature
			-- _arrow:setScaleX(self:getScaleX())
			-- _arrow:setScaleY(self:getScaleY())
			--起始位置
		    local runningScene 		= cc.Director:getInstance():getRunningScene()
			local _targetSlot    	= cc.p(self:getPositionX(),self:getPositionY())
			--目标位置
			local endPos 			= firstTarget:getSlotPositionInNode(BATTLE_BONE_NAME.MID,runningScene)
			--计算角度
			-- 判定斜率,非弓箭状态
			local deltaY = endPos.y - _targetSlot.y;
			local deltaX = endPos.x - _targetSlot.x;
			local angel = deltaX > 0 and 0 or 180;
			local K = deltaY / deltaX;
			if deltaX ~= 0 then
				_arrow:setRotation(angel-CC_RADIANS_TO_DEGREES(math.atan(K)));
			end
			local _abs_x = math.abs(deltaX)
			-- zc.tipInfo(_abs_x.."---"..tostring(_arrow:getBoundingBox().width))
			_arrow:setScaleX(-_abs_x / 680)

			zc.dispatchEvent({
				name = EVENT_NAME_BATTLE_PLAY_EFFECT,
				data = {node = _arrow, zorder = self:getLocalZOrder() + 1},
			})
		end
	elseif skillType == 2 then--
	elseif skillType == 3 then--
    end
end

return zhangjiao




