--[[
布阵界面（修改）
andong
2016/05/10
]]
local BuzhenLayer = class("BuzhenLayer", function ()
    return zc.createNormalDialog()
end)

function BuzhenLayer:create(params)--静态创建函数
    return BuzhenLayer.new(params)
end
function BuzhenLayer:ctor(params)
    self._record = {}
    self:initData(params)
    self:initUI()
end

function BuzhenLayer:onCleanup()
    self:removeAllChildren()
    local textureCache = cc.Director:getInstance():getTextureCache()
    textureCache:removeTextureForKey("res/Main/matrix/matrix_kuang.jpg")
    textureCache:removeTextureForKey("res/Main/common/popBg/popBg_blue.png")
    textureCache:removeTextureForKey("res/Main/matrix/matrix_title.png")
    textureCache:removeTextureForKey("res/Main/matrix/matrix_title2.png")
    textureCache:removeTextureForKey("res/Main/matrix/matrix_generalbg.png")
    textureCache:removeTextureForKey("res/Main/matrix/matrix_bar1.png")
    textureCache:removeTextureForKey("res/Main/matrix/matrix_bg1.png")
    textureCache:removeTextureForKey("res/Main/matrixBattle/formation_open.png")
    
    local _forms = PlayerData:getNowFormationFiles()
    for k, v in pairs( self._record ) do
        -- 如果已上阵，不删除
        local _path, _resId = zc.battle.getHeroArmaturePathByResId( k )
        if not _forms[_resId] then
            ccs.ArmatureDataManager:getInstance():removeArmatureFileInfo( _path )
        end
    end
    helper.collectMemory(true)

    local _currentGID = getGuideManager():getCurrentGID()
    if _currentGID == GuideKey.KEY_14401 or (_currentGID >= GuideKey.KEY_12810 and _currentGID <= GuideKey.KEY_12814) then
        getGuideManager():setCurrentGID(GuideKey.KEY_14401, true)
        local _mainCity = zc.getScene("mainCity")
        _mainCity:guideFunc()
    end
end

function BuzhenLayer:initData(params)
    self._touchPosY = 20
    local _subX = 147
    local _subXX = 37
    local _subY = 87
    local _maxX = 700
    local _maxY = 380

    self._posList = {
        --从下到上的排列
        cc.p(_maxX, _maxY), cc.p(_maxX-_subXX, _maxY-_subY),cc.p(_maxX-_subXX*2, _maxY-_subY*2),
        cc.p(_maxX - _subX, _maxY),cc.p(_maxX-_subX-_subXX, _maxY-_subY),cc.p(_maxX-_subX-_subXX*2, _maxY-_subY*2),
        cc.p(_maxX - _subX*2, _maxY),cc.p(_maxX-_subX*2-_subXX, _maxY-_subY),cc.p(_maxX-_subX*2-_subXX*2, _maxY-_subY*2),
    }


    -- 阵法数据
    self._nowEmbattleInfo = {}--当前布阵信息
    self._ninePos = {}--9个布阵位置信息
    self._fiveHand = {}--五个第几手
    self._fiveHero = {}--5个英雄
    self._localEmbattleList = {}--初始布阵位置，判断阵法是否改变
    self._itemMatrix  = {}--阵法信息
    local formationInfo = PlayerData:getFormationsInfo() --阵法信息

    local playerLevel = tonumber(PlayerData.info["level"])
    local playerVip   = tonumber(PlayerData.info["vip"])
    local newForm = {}
    local levelOne = true
    local vipOne = true
    for i = 1, table.nums(formationInfo) do
        local v = formationInfo[i]
        local _needLevel = tonumber(v.needLevel) or 0
        local _needVip = tonumber(v.needVip) or 0
        if _needLevel <= playerLevel and _needVip <= playerVip then
            v["open"] = 1
            newForm[#newForm+1] = v
        else
            if _needVip > playerVip then
                if vipOne then
                    newForm[#newForm+1] = v
                end
                vipOne = false
            elseif _needLevel > playerLevel then
                if levelOne then
                    newForm[#newForm+1] = v
                end
                levelOne = false
            end
        end
        --当前开启
        if v.status == 1 then
            self._nowEmbattleInfo = v
            self._localEmbattleList = table.copy( v ) --初始布阵位置
        end
    end
    self._formationInfo = table.copy(newForm)

    -- 布阵类型，1：普通，2：演武榜设置防守
    self._matrixType = params.type or MatrixType.Default
    if self._matrixType == MatrixType.Default then

    elseif self._matrixType == MatrixType.ArenaDefence then
        -- 演武榜防守阵容，数据需要传入
        if params.data.matrix ~= 0 then
            -- 设置过防守阵容
            --演武榜阵法前端没有保存，每次需要清空
            for k,v in pairs(self._formationInfo) do
                if v.formationId == params.data.matrix then
                    v.status = 1
                    -- 修改开启阵法的数据
                    -- 先清空
                    for j = 1, 9 do
                        v["location"..j] = 0
                    end
                    -- 再重新赋值
                    for j, u in ipairs( params.data.hero ) do
                        v["location"..u.location] = tonumber( u.id )
                    end
                    self._nowEmbattleInfo = v
                    self._localEmbattleList = table.copy( v ) --初始布阵位置
                else
                    v.status = 0
                end
            end
        else
            --找到状态为1的阵型，若没有状态为一的，即初始化时候阵容上没有武将，默认为5，表示初始化的阵型
            for i, v in ipairs( self._formationInfo ) do
                if v.status == 1 then
                    self._nowEmbattleInfo = v
                    self._localEmbattleList = table.copy( v ) --初始布阵位置
                    break
                end
            end
        end
    end
    --容错处理
    if not self._nowEmbattleInfo["map"] then
        for i = 1,table.nums(formationInfo) do
            local v = formationInfo[i]
            if v.status == 1 then
                self._formationInfo[#self._formationInfo+1] = v
                self._nowEmbattleInfo = v
                self._localEmbattleList = table.copy( v ) --初始布阵位置
                break
            end
        end
    end

    -- 英雄数据
    self._heroList = {}
    --是否上阵
    local upTable = {}
    for i=1,9 do
        local heroId = tonumber( self._nowEmbattleInfo["location"..i] ) or 0
        if heroId ~= 0 then
            upTable[#upTable + 1] = tostring(heroId)
            -- upTable[tostring( heroId )] = true
        end
    end

    self._callback = params.callback
    
    self:reloadGeneralList(upTable)--排序
end


function BuzhenLayer:initUI()
    -- 背景图
    local bg = zc.createNormalPop({
        tag = 2,
        src = "",
        bianZOrder = 1,
    })
    bg:setPosition(zc.width*0.5, zc.height*0.5 - 10)
    self:addChild(bg)
    self._bg = bg

    local _bgSize = bg:getContentSize()

    local titlePath = "res/Main/matrix/matrix_title.png"
    if self._matrixType == MatrixType.ArenaDefence then
        titlePath = "res/Main/matrix/matrix_title2.png"
    end
    local _titleImg = bg:getChildByName("titleImg")
    local title = zc.getSprite({
        src = titlePath,
        ap = cc.p(0.5, 0),
        pos = cc.p(120, _bgSize.height - _titleImg:getContentSize().height - 15)
    })
    bg:addChild(title, 1)
    
    --触摸layer
    local touchLayer = cc.Layer:create()
    bg:addChild(touchLayer)
    self:initTouchEvent(touchLayer)

    --关闭（这时保存阵法）
    self._closeCallBack = function ()
        --新手引导
        local function _guideDo( ... )
            local _currentGID = getGuideManager():getCurrentGID()
            if inArray(_currentGID, GuideGroup.BTN_BACK_MAINCITY)  then
                getGuideManager():setObjTarget(nil)
                getGuideManager():setNextGID(_currentGID)
                local _lay = zc.getScene("tollgate")
                if _lay then
                    _lay:createTollgateInfo()
                end
            end
        end
        
        if self:needUpdata() then 
            local infoData = tostring(self._nowEmbattleInfo["formationId"])..":"..self:getNineHeroString()
            if self._matrixType == MatrixType.Default then
                -- 普通布阵
                zc.sendHttp({
                    apiName = "Formation_saveFormation",
                    params = {info = infoData,type=self._matrixType},
                    successCallback = function(data)
                        PlayerData:setFormationsInfo(data.formations)
                        _guideDo()
                        LayerManager.removeLayout(nil, nil, false)
                    end,
                })
            elseif self._matrixType == MatrixType.ArenaDefence then
                local _callback = self._callback
                -- 演武榜
                zc.sendHttp({
                    apiName = "Arena_defensive",
                    params = {info = infoData},
                    successCallback = function(data)
                        if _callback then
                            _callback(data)
                        end
                        LayerManager.removeLayout(nil, nil, false)
                    end,
                })
            else
                LayerManager.removeLayout(nil, nil, false)
            end
        else
            print("不需要保存阵法信息")
            LayerManager.removeLayout(nil, nil, false)
        end
    end

    ------------------------------------左侧布局
    local leftBg = zc.getSprite({
        src = "res/Main/matrix/matrix_generalbg.png",
        ap = cc.p(0, 0),
        pos = cc.p(-6, 0)
    })
    bg:addChild(leftBg)
    self._leftlayer = leftBg

    local leftTitleBg = zc.getSprite({
        src = "res/Main/matrix/matrix_bar1.png",
        ap = cc.p(0, 1),
        pos = cc.p(15, leftBg:getContentSize().height - 20),
    })
    leftBg:addChild(leftTitleBg)

    local _label = zc.createRichLabel({
        text = zc.lang("role_choose"),
        fontSize = 20,
        anchor = cc.p(0, 0.5),
        pos = cc.p(15, leftTitleBg:getContentSize().height*0.5 + 5),
    })
    _label:setGradientColor(cc.c4b(244, 159, 8, 255), cc.c4b(255, 255, 124, 255), cc.p(0, -1))
    leftTitleBg:addChild(_label)

    self:initLeftTableView()

    self._leftImg = ccui.Scale9Sprite:create( cc.rect(10,10,3,3), "res/Main/common/common_select_box.png" )
    self._leftImg:setContentSize( 653, 447)
    self._leftImg:setPosition( bg:getContentSize().width/2 + 98, leftBg:getContentSize().height/2 - 3)
    self._leftImg:setVisible(false)
    bg:addChild(self._leftImg, 9)
    ------------------------------------右侧布局
    local _width = 666
    local rightBg = zc.createNormalPop({
        width = _width,
        height  = _bgSize.height - 15,
        showSide = false,
    })
    rightBg:setAnchorPoint(0, 0)
    rightBg:setPosition(198, 0)
    bg:addChild(rightBg)
    self._rightBg = rightBg
    
    local _rightBg2 = zc.createSprite("res/Main/matrix/matrix_kuang.jpg")
    _rightBg2:setPosition(_width*0.5, 0)
    _rightBg2:setAnchorPoint(0.5, 0)
    rightBg:addChild(_rightBg2)
    self:initRightLayer()
    ------------------------------------下侧布局
    self:initDownLayer()
    
end

function BuzhenLayer:initDownLayer()
    local _downSize = cc.size(672, 100) 
    local downBg = zc.getScaleNode("res/Main/matrix/matrix_bg1.png", _downSize)
    downBg:setAnchorPoint(0, 0)
    downBg:setPosition(10, 5)
    self._rightBg:addChild(downBg)

    local acct = self:getMatrixInDB(self._nowEmbattleInfo, self._nowEmbattleInfo.level)
    print("acct --- > ", acct)

    local downTitleLab = zc.createLabel({
        text = zc.lang("matrix_effect") .. "：",
        outLine = true,
        fontSize = 18,
        ap = cc.p(0, 0.5),
        pos = cc.p(5, _downSize.height + 11),
        color = display.COLOR_BTNFONTYELLOW,
        pixel = 1.3
    })
    downBg:addChild(downTitleLab, -1)
    local downTitleLab2 = zc.createLabel({
        text = acct,
        outLine = true,
        fontSize = 18,
        ap = cc.p(0, 0.5),
        pos = cc.p(downTitleLab:getContentSize().width+downTitleLab:getPositionX(), downTitleLab:getPositionY()),
        color = display.COLOR_BTNFONTYELLOW,
        pixel = 1.3
    })
    downBg:addChild(downTitleLab2)
    self._downTitleLab = downTitleLab2

    local innerWidth = 90 * (#self._formationInfo)
    local scroWith = innerWidth
    local canBounce = false
    if scroWith > 630 then
        canBounce = true
        scroWith = 630
    end
    local downScrollView = zc.createScrollview({
        pos = cc.p(5, 0),
        size = cc.size(scroWith, 106),
        innerSize = cc.size(innerWidth, 106),
        dir = ccui.ScrollViewDir.horizontal,
        bar = false,
        bounceEnable = canBounce,
    })
    downBg:addChild(downScrollView)

    local _handFlag = false
    local _mainCity = zc.getScene("mainCity")
    if _mainCity and _mainCity._buzhenHandFlag then
        _handFlag = true
    end

    for i=1,#self._formationInfo do 
        local scaleSize = cc.size(91, 91)
        -- local myScale9 = zc.getScaleNode("res/Main/setting/scale9_1.png", scaleSize)
        local myScale9 = zc.getScaleNode("res/Main/common/img_empty.png", scaleSize)
        myScale9:setPosition(cc.p((i-1+1/2)*90, 100/2))
        downScrollView:addChild(myScale9)
        myScale9:setTag(i)

        local itemMatrix = zc.createPushButton({
            needSwallow = false,
            needEnableWhenMoving = true,
            endCallback = function()
                local _innerX = downScrollView:getInnerContainerPosition().x
                if myScale9:getPositionX() + _innerX  >= scroWith 
                  or myScale9:getPositionX() + _innerX <= 0
                  then
                    return
                end

                --新手引导
                self:guideFunc()

                local _flag = false
                if self._guideHand then
                    self._guideHand:removeFromParent()
                    self._guideHand = nil
                    if i == tonumber(self._nowEmbattleInfo["formationId"]) then
                        _flag = true
                    end
                end
                local function _callback(data, _newFormId)
                    -- 保存阵法后换阵
                    local _nineHeroString = ""
                    for i = 1, table.nums(data) do
                        local v = data[i]
                        if v.formationId and tonumber(v.formationId) == _newFormId then
                            for j = 1, 8 do
                                _nineHeroString = _nineHeroString..v["location"..j].."_"
                            end
                            _nineHeroString = _nineHeroString..v["location9"]
                            break
                        end
                    end
                    self:changeMatrix(_newFormId, _nineHeroString)
                end
                zc.createSourcePop("BuzhenSelect", "src/layer/buzhen/BuzhenSelectPop.lua", {
                    curMatrix = self._formationInfo[i], 
                    useMatrixId = self._nowEmbattleInfo["formationId"],
                    nineHeroString = self:getNineHeroString(),
                    callback = _callback,
                    handFlag = _flag,
                    parent = self,
                    _type = self._matrixType,
                })
            end,
            pos = cc.p(scaleSize.width/2, scaleSize.height/2),
        })
        itemMatrix:setContentSize(88,88)
        myScale9:addChild(itemMatrix)
        myScale9.formationId = self._formationInfo[i].formationId

        self._itemMatrix[#self._itemMatrix+1] = myScale9
        self:initPointLocation(myScale9, self._formationInfo[i], self._formationInfo[i]["color"])
        if tonumber(self._formationInfo[i].status) == 1 then 
            self._oldSelected = myScale9

            --滑动到指定的位置
            if canBounce and i > 5 then
                local moveX = (i-1)*90
                if moveX >= #self._formationInfo*90 - 7*90 then 
                    moveX = #self._formationInfo*90 - 7*90
                end
                local coner = downScrollView:getInnerContainer()
                coner:setPosition( cc.p(-moveX, 0) )
            end
        end

        --新手引导
        if i == 1 then
            local _currentGID = getGuideManager():getCurrentGID()
            if _currentGID == GuideKey.KEY_2010 then
                self._guideBtn = itemMatrix
                self._scale = 88/138
            end
        end
        if tonumber(self._formationInfo[i].status) == 1 then
            local _currentGID = getGuideManager():getCurrentGID()
            if _currentGID == GuideKey.KEY_12811 then
                self._guideBtn = itemMatrix
                self._scale = 88/138
            end
        end

        if _handFlag and i == tonumber(self._nowEmbattleInfo["formationId"]) then
            local _level = tonumber(self._formationInfo[i].level) or 0
            if _level == 2 then
                self._handBtn1 = myScale9
            end
        end
    end  
end

--等级 全体加成
function BuzhenLayer:getMatrixInDB(formationInfo, level)
    local level = tonumber(level)
    local attTable = {}
    for j=1,4 do 
        if formationInfo["effect"..j] ~= "" and formationInfo["effect"..j] ~= nil then 
            local _isBase = false
            if formationInfo["effectLayer"..j] and (tonumber(formationInfo["effectLayer"..j])==1 or tonumber(formationInfo["effectLayer"..j])==2) then
                _isBase = true
            end
            local _target = nil
            if formationInfo["effectTarget"..j] and type(formationInfo["effectTarget"..j]) == "number" then
                _target = formationInfo["effectTarget"..j]
            end
            local array = string.split(formationInfo["effect"..j],"|")
            local newindex = #attTable+1
            attTable[newindex] = {}
            local effectStr = LANGUAGE_getAttributeTextById(array[1], _isBase)
            if _target then
                effectStr = LANGUAGE_getTargetTextById(_target)..effectStr
            end
            attTable[newindex].attname = effectStr
            attTable[newindex].startatt = tonumber(array[2])
            attTable[newindex].addatt = tonumber(array[3])
            attTable[newindex].id = tonumber(array[1])
        end
    end

    local str = ""
    for i = 1, #attTable do
        local curEff = tonumber(attTable[i].startatt) + (tonumber(level)-1)*tonumber(attTable[i].addatt)
        if i == 1 then
            str = attTable[i].attname.."+"..zc.getAttributeNumById(attTable[i]["id"], curEff)
        else
            str = str .. " " .. attTable[i].attname.."+"..zc.getAttributeNumById(attTable[i]["id"], curEff)
        end
    end
    return str
end

function BuzhenLayer:initPointLocation(itemMatrix, info, color)
    if itemMatrix:getChildByName("blockBgImg") then
        itemMatrix:getChildByName("blockBgImg"):removeFromParent()
    end
    local _needVip = 2
    local _isOpen = false
    local _qiYong = "noSelected"
    if info["needVip"] and tonumber(info["needVip"]) > 0 then
        _needVip = 1
    end
    if info["open"] and tonumber(info["open"]) == 1 then
        _isOpen = true
    end
    if info["status"] and tonumber(info["status"]) == 1 then
        _qiYong = "selected"
    end

    local imgPath = {
        [1] = { --需要vip的
            selected = {
                bgImg = "res/Main/matrix/select_bg.png",
                posHave = "res/Main/matrix/liang_lan.png",
                posNo = "res/Main/matrix/an_lan.png",
            },
            noSelected = {
                bgImg = "res/Main/matrix/weixuan_lan.png",
                posHave = "res/Main/matrix/an_lan_block.png",
                posNo = "res/Main/matrix/an_lan.png",    
            }
        },
        [2] = { --不需要vip的
            selected = {
                bgImg = "res/Main/matrix/select_bg.png",
                posHave = "res/Main/matrix/liang_huang.png",
                posNo = "res/Main/matrix/an_hui.png",
            },
            noSelected = {
                bgImg = "res/Main/matrix/weixuan_hui.png",
                posHave = "res/Main/matrix/an_hui_block.png",
                posNo = "res/Main/matrix/an_hui.png",    
            }
        },
    }
    
    local imgTable = imgPath[_needVip][_qiYong]
    local bgImg = zc.createSprite(imgTable["bgImg"])
    bgImg:setAnchorPoint(0.5, 0.5)
    bgImg:setPosition(itemMatrix:getContentSize().width/2, itemMatrix:getContentSize().height/2)
    itemMatrix:addChild(bgImg)
    bgImg:setName("blockBgImg")

    local mapInfo = string.split(info["map"],"|")
    local map = {}
    for i = 1,#mapInfo do
        map[tonumber(mapInfo[i])] = "true"
    end
    local itemWidth = itemMatrix:getContentSize().width
    local itemHeight = itemMatrix:getContentSize().height
    for i = 1, 9 do
        local posx = itemWidth - 20 - math.floor((i-1)/3) * 25
        local posy = itemHeight - 20 - (i - math.floor((i-1)/3) * 3 - 1) * 25
        if map[i] then
            local posHave = zc.createSprite(imgTable["posHave"])
            posHave:setAnchorPoint(0.5, 0.5)
            posHave:setPosition(posx, posy)
            itemMatrix:addChild(posHave)
        else
            local posNo = zc.createSprite(imgTable["posNo"])
            posNo:setAnchorPoint(0.5, 0.5)
            posNo:setPosition(posx, posy)
            itemMatrix:addChild(posNo)
        end
    end

    if not _isOpen then
        local mask = zc.createSprite("res/Main/matrix/mask.png")
        mask:setAnchorPoint(0.5, 0.5)
        mask:setPosition(itemWidth/2, itemHeight/2)
        itemMatrix:addChild(mask)
    end

end
--返回  0_10_0_0_0_0_0_0_0
function BuzhenLayer:getNineHeroString()
    local heroString = ""
    for i=1,9 do 
        local heroID = 0
        for j=1,#self._fiveHero do 
            if self._fiveHero[j].weizhi == i then 
                heroID = self._fiveHero[j].id
                break
            end
        end
        if i == 9 then 
            heroString = heroString .. heroID 
        else
            heroString = heroString .. heroID .. "_"
        end
    end
    return heroString
end
------------------------------------左侧布局
--排序  id存在是下阵 更换阵法时将上阵的武将排在前面
function BuzhenLayer:reloadGeneralList(upTable) 
    local _mHeroId = tonumber(PlayerData.info["heroId"]) or 0
    local info = PlayerData:getGeneralInfo()
    -- self._heroList = PlayerData:getGeneralInfo()
    self._heroList = {}
    for k,v in pairs(info) do
        if tonumber(v.tactics.tactics) ~= 1 then
            table.insert(self._heroList,v)
        end
    end
    --添加英雄（武将的信息表）
    for k,v in pairs(self._heroList) do
        if inArray(tostring(v.id), upTable) then
            v._upMatrix = 1
        else
            v._upMatrix = 0
        end
        if _mHeroId == tonumber(v.id) then
            v._islead = 1
        else
            v._islead = 0
        end
    end
    local _currentGID = getGuideManager():getCurrentGID()
    local _flag = (_currentGID >= GuideKey.KEY_12810 and _currentGID <= GuideKey.KEY_12814)
    --_islead表示主角， _upMatrix表示当前启用的阵法，该武将否在阵上
    table.sort(self._heroList,function(a,b)
        if _flag then
            local _aHeroId = tonumber(a.heroId)
            local _bHeroId = tonumber(b.heroId)
            if _aHeroId == GuideHeroId.KEY_12814 then
                return true
            elseif _bHeroId == GuideHeroId.KEY_12814 then
                return false
            end
        end
        local aLead = tonumber(a["_islead"]) or 0
        local bLead = tonumber(b["_islead"]) or 0
        local aUp = tonumber(a["_upMatrix"]) or 0
        local bUp = tonumber(b["_upMatrix"]) or 0
        if aLead == bLead then
            if aUp == bUp then
                return tonumber(a.fighting) > tonumber(b.fighting)
            else
                return aUp > bUp
            end
        else
            return aLead > bLead
        end
    end)
end
--[[
只刷新一行数据，不reloadtableview  updateCellAtIndex
]]
function BuzhenLayer:reloadTableView(matrixtype, index)
    local indexHang = math.floor((index+1)/2)
    if matrixtype == "up" then 
        --上阵·
        self._heroList[index]["_upMatrix"] = 1
        self._tableView:updateCellAtIndex(indexHang-1)
    elseif matrixtype == "down" then
        --下阵
        self._heroList[index]["_upMatrix"] = 0
        self._tableView:updateCellAtIndex(indexHang-1)
    end
end

function BuzhenLayer:initLeftTableView()
    local tableView = cc.TableView:create(cc.size(200, 450 - 50))--185, 435
    tableView:setDirection(cc.SCROLLVIEW_DIRECTION_VERTICAL)
    tableView:setVerticalFillOrder(cc.TABLEVIEW_FILL_TOPDOWN)
    tableView:setPosition(cc.p(0, 10))
    tableView:setDelegate()
    self._leftlayer:addChild(tableView)

    local function cellSizeForTable(table, idx) 
        return 200, 98--98, 200--
    end
    local function tableCellAtIndex(table, cellIndex) 
        cellIndex = cellIndex + 1
        local cell = tableView:dequeueCell()
        -- 创建模板
        if cell == nil then
            cell = cc.TableViewCell:new()
            self:buildCell(cell, cellIndex)
        end
        -- 更新界面
        self:updateCell(cell, cellIndex)
        return cell
    end
    local _num = math.floor((#self._heroList+1)/2)
    local function numberOfCellsInTableView()
        return _num 
    end

    tableView:registerScriptHandler(numberOfCellsInTableView, cc.NUMBER_OF_CELLS_IN_TABLEVIEW)  
    tableView:registerScriptHandler(cellSizeForTable, cc.TABLECELL_SIZE_FOR_INDEX)
    tableView:registerScriptHandler(tableCellAtIndex, cc.TABLECELL_SIZE_AT_INDEX)
    tableView:reloadData()
    self._tableView = tableView
end

function BuzhenLayer:buildCell(cell, cellIndex)
    cell._itemArray  ={}
    for i=1,2 do 
        local newIndex = (cellIndex-1)*2+i
        cell._itemArray[i] = {}
        local item = zc.createIconByData({
            data = {
                mainType = zc.mainTypeSoldier,
                type = 1, 
                id = 1,
                quality = 1,
                num = 1,
                level = 1,
            }, 
            showLevel = true,
            pos = cc.p(15 + (i-1+1/2) * 92, 55), 
            listener = function ()  end
        })
        item:setScale(0.6)
        cell:addChild(item)
        cell._itemArray[i].item = item
        --名字
        local heroName = zc.createLabel({
            fontSize = 20,
            ap = cc.p(0.5, 0.5),
            pos = cc.p(item:getContentSize().width/2, -15),
            outLine = true,
            color = display.COLOR_WHITE,
        })
        heroName:setScale(1.4)
        item:addChild(heroName)
        cell._itemArray[i].heroName = heroName
        --是否上阵
        local isup = zc.createSprite("res/Main/home/home_reachCondition.png")
        isup:setAnchorPoint(1, 0)
        isup:setPosition(item:getContentSize().width+5, 3)
        isup:setScale(1.4)
        item:addChild(isup)
        cell._itemArray[i].isup = isup
    end
end
function BuzhenLayer:updateCell(cell, cellIndex)
    --
    for i=1,2 do 
        local newIndex = (cellIndex-1)*2+i
        -- dump(self._heroList[newIndex],"self._heroList[newIndex]")
        if #self._heroList >= newIndex then
            -- dump(self._heroList[newIndex], "====")
            cell._itemArray[i].item:setVisible(true) 
            cell._itemArray[i].item:setTouchEnabled(true)
            local newParams = {
                data = {
                    mainType = zc.mainTypeSoldier,
                    type = 1, 
                    id = self._heroList[newIndex].heroId,
                    level = zc.getLevelTipShow()..self._heroList[newIndex].level,
                    reincarnate = self._heroList[newIndex]["reincarnate"]
                },
                quality = self._heroList[newIndex].quality,
                showLevel = true,
                listener = function ()
                    --新手引导
                    self:guideFunc_1()
                    self:_upMatrixFunc(newIndex)
                end
            }
            zc.updateIconByData(cell._itemArray[i].item, newParams )
            local heroName = self._heroList[newIndex]["name"]
            if tonumber(PlayerData.info["heroId"]) == tonumber(self._heroList[newIndex]["id"]) then
                heroName = PlayerData.info.userName
            end
            cell._itemArray[i].heroName:setText(heroName)
            if tonumber(self._heroList[newIndex]["_upMatrix"]) == 1 then 
                cell._itemArray[i].isup:setVisible(true) 
            else
                cell._itemArray[i].isup:setVisible(false) 
            end
            --新手引导
            local _heroId = tonumber(self._heroList[newIndex].heroId) or 0
            if _heroId == GuideHeroId.KEY_2016 then
                self._guideBtnItem = cell._itemArray[i].item
            elseif _heroId == GuideHeroId.KEY_12814 then
                self._guideBtnItem2 = cell._itemArray[i].item
            end
        else
            cell._itemArray[i].item:setVisible(false) 
            cell._itemArray[i].item:setTouchEnabled(false)
        end
    end
end
------------------------------------右侧布局
function BuzhenLayer:initRightLayer()
    --初始化五个英雄
    self._ninePos = {}
    for i=1,9 do
        --默认背景
        local positionBg = zc.createSprite("res/Main/matrixBattle/matrix_disable.png")
        positionBg:setPosition(self._posList[i].x, self._posList[i].y - 30)
        self._bg:addChild(positionBg, 1)
        --加锁背景
        local lockBg = zc.createSprite("res/Main/matrixBattle/matrix_lock.png")
        lockBg:setPosition(self._posList[i].x, self._posList[i].y - 30)
        self._bg:addChild(lockBg, 1)
        --正常背景
        local normalBg = zc.createSprite("res/Main/matrixBattle/matrix_normal.png")
        normalBg:setPosition(self._posList[i].x, self._posList[i].y - 30)
        self._bg:addChild(normalBg, 1)
        --选择背景
        local selectBg = zc.createSprite("res/Main/matrixBattle/matrix_select.png")
        selectBg:setPosition(self._posList[i].x, self._posList[i].y - 30)
        self._bg:addChild(selectBg, 1)
        --出手顺序
        local hand = zc.createSprite("res/Main/matrixBattle/order_1.png")
        hand:setPosition(self._posList[i].x-50, self._posList[i].y - 60)
        self._bg:addChild(hand, 1)
        --设置触摸区域
        local touchninePos = zc.createScale9Sprite({
            size = cc.size(80, 80),
            file = "res/Main/common/img_empty.png",
            pos = cc.p(self._posList[i].x, self._posList[i].y - 30),
        })
        self._bg:addChild(touchninePos, 1)

        self._ninePos[i] = {}
        self._ninePos[i]["positionBg"] = positionBg
        self._ninePos[i]["lockBg"] = lockBg
        self._ninePos[i]["normalBg"] = normalBg
        self._ninePos[i]["selectBg"] = selectBg
        self._ninePos[i]["touchninePos"] = touchninePos
        self._ninePos[i]["hand"] = hand
        self._ninePos[i]["canMove"] = false
    end

    self:reloadRightLayer()
end
--更新布阵
function BuzhenLayer:reloadRightLayer()
    --重置
    --生成物将位置  先移除  重新加载
    if self._fiveHero and next(self._fiveHero) then
        for i=1,#self._fiveHero do 
            self._fiveHero[i]:removeFromParent()
            self._fiveHero[i] = nil
        end
    end
    local array = string.split(self._nowEmbattleInfo["map"],"|")
    local zhenwei = {} --当前阵法排列的位置
    for k,v in pairs(array) do
        zhenwei[tonumber(v)] = "canUpPos"
    end
    if not self._nowEmbattleInfo["openmap"] then
        self._nowEmbattleInfo["openmap"]  = PlayerData:getFormationsOpenMap( self._nowEmbattleInfo.formationId, self._nowEmbattleInfo.level )
    end
    local alreadyOpen = string.split(self._nowEmbattleInfo["openmap"],"|")
    local openPos = {} --当前阵法开启的位置 
    for k,v in pairs(alreadyOpen) do
        openPos[tonumber(v)] = "open"
    end
    for i = 1, 9 do
        local positionBg    = self._ninePos[i]["positionBg"]
        local lockBg        = self._ninePos[i]["lockBg"]
        local normalBg      = self._ninePos[i]["normalBg"]
        local selectBg      = self._ninePos[i]["selectBg"]
        local touchninePos  = self._ninePos[i]["touchninePos"]
        local hand          = self._ninePos[i]["hand"]
        local canMove       = self._ninePos[i]["canMove"]
        --默认设置
        positionBg:setVisible(false)
        lockBg:setVisible(false)
        normalBg:setVisible(false)
        selectBg:setVisible(false)
        touchninePos:setVisible(false)
        hand:setVisible(false)
        self._ninePos[i]["canMove"] = false  

        if zhenwei[i] then--当前阵法有这个位置
            if openPos[i] then --已经开启
                normalBg:setVisible(true)
                touchninePos:setVisible(true)
                self._ninePos[i]["canMove"] = true  
                --如果这个位置有武将
                if tonumber(self._nowEmbattleInfo["location"..i]) ~= 0 then
                    hand:setVisible(true)
                    local modelId = self:getNameByHeroId( tonumber(self._nowEmbattleInfo["location"..i]) ).modelId
                    --加载武将
                    self:AddArmatureById(tonumber(self._nowEmbattleInfo["location"..i]), modelId, i, false, false, false) 
                end
            else --这个位置还没有开启
                lockBg:setVisible(true)
            end
        else --没有这个位置
            positionBg:setVisible(true)
        end
    end   

    self:resetHandVis()
end
--刷新第几手
function BuzhenLayer:resetHandVis()
    local whichHand = 0
    for i = 1, 9 do
        local hand = self._ninePos[i]["hand"]
        if hand:isVisible() then
            whichHand = whichHand + 1
            hand:setTexture("res/Main/matrixBattle/order_"..whichHand..".png")
        end
    end
end
function BuzhenLayer:levelUpRefresh(_fid, level)
    local newEmbattleInfo = PlayerData:getFormationsOpenMap(_fid, level)
    for i = 1, #self._formationInfo do
        local v = self._formationInfo[i]
        if tonumber(v.formationId) == tonumber(_fid) then
            v.openmap = newEmbattleInfo
            v.level = level
            if tonumber(self._nowEmbattleInfo["formationId"]) == tonumber(_fid) then
                self._nowEmbattleInfo.openmap = newEmbattleInfo
                self._nowEmbattleInfo.level = level
            end
            break
        end
    end
    if tonumber(self._nowEmbattleInfo["formationId"]) == tonumber(_fid) then
        self:reloadRightLayer()
        local acct = self:getMatrixInDB(self._nowEmbattleInfo, self._nowEmbattleInfo.level)
        self._downTitleLab:setText(acct) 
    end
end
function BuzhenLayer:AddArmatureById(hid, modelId, i, index, isJudgeArmatureFinish, resetHand)
    if modelId == nil then
        zc.tipInfo("武将资源不存在")
        return
    end
    --加载完动画后采能刷新界面
    if isJudgeArmatureFinish == true then 
        if self._loadArmatureFinish == false then
            return 
        end
        self._loadArmatureFinish = false
    end
    -- zc.getHeroArmature(modelId, function(bAsync)
        self._loadArmatureFinish = true
        if index then 
            self:reloadTableView("up", index)
        end
        -- 高速滚动时很可能没加载完就释放了
        -- local heroLayer = zc.getScaleNode("res/Main/setting/scale9_1.png", cc.size(110, 90))
        local heroLayer = zc.getScaleNode("res/Main/common/img_empty.png", cc.size(110, 90))
        heroLayer:setPosition(cc.p(self._posList[i].x, self._posList[i].y + self._touchPosY ))
        heroLayer:setLocalZOrder(self:getZorder(i))
        self._bg:addChild(heroLayer, self:getZorder(i))
        
        heroLayer.id = hid--武将id
        heroLayer.weizhi = i
        if tonumber(heroLayer.id) == tonumber(PlayerData.info["heroId"]) then
            heroLayer._islead = 1
        else
            heroLayer._islead = 0
        end
        self._fiveHero[#self._fiveHero + 1] = heroLayer

        local armature = zc.battle.createHeroArmature({fileName = modelId , async = true, asyncCallback = function ( _armature )
            if not tolua.isnull(heroLayer) then
                if _armature then
                    _armature:setOpacity(0)
                    _armature:runAction(cc.Sequence:create(cc.FadeIn:create(0.2),cc.CallFunc:create(function()  
                        _armature:getAnimation():play("idle", -1, 1) 
                    end )))

                    --更换兵器
                    local _weaponData = PlayerData:getWeaponsInfoById(self:getNameByHeroId(hid).id)
                    local _weaponId = 0
                    if _weaponData then
                        _weaponId = _weaponData.weaponId
                    end
                    zc.soldierChangeWeapon(_armature,_weaponId)
                end
            end
        end}) 
        self._record[modelId] = true
        armature:setPosition(cc.p(heroLayer:getContentSize().width/2, -5))
        armature:setScale(1.0)
        armature:setScaleX( - armature:getScale())
        heroLayer:addChild(armature)
        if resetHand then
            self._ninePos[i]["hand"]:setVisible(true)
            self:resetHandVis()
        end

    -- end)
end
function BuzhenLayer:getNameByHeroId(hID)
    for i=1,#self._heroList do 
        if tonumber(hID) == tonumber(self._heroList[i]["id"]) then 
            return self._heroList[i]
        end
    end
    return ""
end
--根据位置获取英雄的骨骼
function BuzhenLayer:getHeroByPos(pos)
    for i=1,#self._fiveHero do
        if self._fiveHero[i] and tonumber(pos) == tonumber(self._fiveHero[i].weizhi) then
            return self._fiveHero[i], i
        end
    end
    return nil, nil
end
--上阵
function BuzhenLayer:_upMatrixFunc(index)
    if tonumber(self._heroList[index]["_upMatrix"]) == 1 then 
        return 
    end
    --判断是不是有相同的上阵
    for i=1,#self._heroList do 
        if tonumber(self._heroList[i]._upMatrix) == 1 and  tonumber(self._heroList[i].heroId) == tonumber(self._heroList[index]["heroId"]) then 
            zc.tipInfo(zc.lang("tips_same_hero_online"))
            return 
        end
    end
    --判断有没有阵位  可以上阵
    local hasUp = string.split(self._nowEmbattleInfo["openmap"],"|")
    if #self._fiveHero > #hasUp - 1 then 
        zc.tipInfo(zc.lang("tips_no_position_online"))
        return 
    end

    if #self._fiveHero >= 5 then
        zc.tipInfo(zc.lang("tips_online_num_limit"))
        return 
    end
    --放置的位置
    local pos = 0
    local array = string.split(self._nowEmbattleInfo["map"],"|")
    for i=1,9 do 
        if tonumber(self._nowEmbattleInfo["location"..i]) == 0 and inArray(tostring(i), array) then
            pos = i
            break
        end 
    end
    self._nowEmbattleInfo["location"..pos] = self._heroList[index]["id"]
    --刷新tableview
    local modelId = self._heroList[index].modelId
    --(hid, modelId, i, index, isJudgeArmatureFinish, resetHand)
    self:AddArmatureById(self._heroList[index].id, modelId, pos, index, true, true)
end
function BuzhenLayer:initTouchEvent(touchLayer)

    local moveFromPos = nil
    local moveToPos = nil
    local canMove = false
    local downHero = false
    local canNextMove = true--能不能进行下次滑动
    local isTouch = nil
    local _pred = nil
    touchLayer:onTouch(function(event)
        -- dump(event)
        local _locationPos = cc.p(event.x, event.y)
        if event.name == "began" then
            if canNextMove == false then 
                return
            end
            isTouch = false
            --上阵还是下阵
            --说明碰的右边，交换武将位置
            for i=9,1,-1 do 
                local hero = self:getHeroByPos(i)
                if hero and zc.isTouchContainsPoint(hero, _locationPos) then 
                    isTouch = true
                    moveFromPos = hero.weizhi
                    self._ninePos[moveFromPos].selectBg:setVisible(true)
                    hero:setLocalZOrder(100)
                    _pred = _locationPos
                    canNextMove = false
                    break
                end
            end
            return isTouch
        elseif event.name == "moved" then
            --移动英雄
            if moveFromPos ~= nil then  
                local px = self:getHeroByPos(moveFromPos):getPositionX()
                local py = self:getHeroByPos(moveFromPos):getPositionY()
                --判断是否  出框
                local moveToX = px - _pred.x + _locationPos.x
                local moveToY = py - _pred.y + _locationPos.y
                self:getHeroByPos(moveFromPos):setPosition(cc.p(moveToX, moveToY))
                _pred = _locationPos
                --判断是不是下阵
                if zc.isTouchContainsPoint(self._leftImg, _locationPos) then 
                    self._leftImg:setVisible(false)
                else
                    self._leftImg:setVisible(true)
                end
                --判断能不能换
                for i = #self._ninePos, 1, -1 do
                    if self._ninePos[i].canMove and 
                        zc.collisionDetection(self._ninePos[i].touchninePos,self:getHeroByPos(moveFromPos)) then
                        if moveToPos then 
                            self._ninePos[moveToPos].selectBg:setVisible(false)
                        end
                        if moveFromPos then 
                            self._ninePos[moveFromPos].selectBg:setVisible(false)
                        end
                        
                        if i == moveFromPos then 
                            --移动造自己的位置
                            moveToPos = i
                            canMove = false
                            self._ninePos[moveToPos].selectBg:setVisible(true)
                        else
                            moveToPos = i
                            canMove = true
                            self._ninePos[moveToPos].selectBg:setVisible(true)
                        end
                        break
                    end
                end
            end
        elseif event.name == "ended" then
            local function canMoveFunc()
                canNextMove = true
            end
            for i=1,#self._ninePos do
                if self._ninePos[i]["canMove"] == true then
                    self._ninePos[i].selectBg:setVisible(false)
                end
            end
            local function heroMove()
                if canMove == false then 
                    local moveFromHero  = self:getHeroByPos(moveFromPos)
                    moveFromHero:runAction(cc.Sequence:create(
                        cc.MoveTo:create(0.2, cc.p(self._posList[moveFromPos].x, self._posList[moveFromPos].y + self._touchPosY )),
                        cc.CallFunc:create(canMoveFunc)
                    ))
                    moveFromHero:setLocalZOrder(self:getZorder(moveFromPos))
                else
                    --能交换
                    --移动到非空的位置
                    local moveFromHero = self:getHeroByPos(moveFromPos)
                    local moveToHero = self:getHeroByPos(moveToPos)
                    if moveToHero then 
                        moveToHero:runAction(cc.Sequence:create(
                            cc.MoveTo:create(0.2, cc.p(self._posList[moveFromPos].x, self._posList[moveFromPos].y + self._touchPosY )),
                            cc.CallFunc:create(canMoveFunc)
                        ))
                        moveFromHero:runAction(
                            cc.MoveTo:create(0.2, cc.p(self._posList[moveToPos].x, self._posList[moveToPos].y + self._touchPosY ))
                        )
                        --交换坐标
                        moveToHero.weizhi =  moveFromPos
                        moveToHero:setLocalZOrder(self:getZorder(moveFromPos))
                        moveFromHero.weizhi = moveToPos
                        moveFromHero:setLocalZOrder(self:getZorder(moveToPos))
                        --修改布阵的信息
                        local locationtmp = self._nowEmbattleInfo["location"..moveToPos]
                        self._nowEmbattleInfo["location"..moveToPos] = self._nowEmbattleInfo["location"..moveFromPos]
                        self._nowEmbattleInfo["location"..moveFromPos] = locationtmp
                    else
                        moveFromHero:runAction(cc.Sequence:create(
                            cc.MoveTo:create(0.2, cc.p(self._posList[moveToPos].x, self._posList[moveToPos].y + self._touchPosY )),
                            cc.CallFunc:create(canMoveFunc)
                        ))
                        moveFromHero.weizhi = moveToPos
                        moveFromHero:setLocalZOrder(self:getZorder(moveToPos))
                        --修改布阵的信息
                        self._nowEmbattleInfo["location"..moveToPos] = self._nowEmbattleInfo["location"..moveFromPos]
                        self._nowEmbattleInfo["location"..moveFromPos] = "0"
                        self._ninePos[moveFromPos]["hand"]:setVisible(false)
                        self._ninePos[moveToPos]["hand"]:setVisible(true)
                    end

                    self:resetHandVis()
                end
            end
            if moveFromPos ~= nil and not zc.isTouchContainsPoint(self._leftImg, _locationPos) then 
                downHero = true
                local moveFromHero, iInFiveHero  = self:getHeroByPos(moveFromPos)
                --下阵
                --判断是主角吗
                local downIndexInData = nil
                local _islead = 0
                for i=1,#self._heroList do
                    if tonumber(self._heroList[i]["id"]) == tonumber(self:getHeroByPos(moveFromPos).id) then 
                        downIndexInData = i
                        _islead = tonumber(self._heroList[i]["_islead"])
                        break
                    end
                end
                if _islead == 1 then 
                    zc.tipInfo(zc.lang("tips_mainrole_cannot_offline"))
                    self._leftImg:setVisible(false)
                    moveFromHero:runAction(
                        cc.MoveTo:create(0.2, cc.p(self._posList[moveFromPos].x, self._posList[moveFromPos].y + self._touchPosY ))
                    )
                    moveFromHero:setLocalZOrder(self:getZorder(moveFromPos))
                    moveFromPos = nil
                    downHero = false
                    canMoveFunc()
                    return
                end
                self._leftImg:setVisible(false)
                --刷新第几手
                self._ninePos[moveFromPos]["hand"]:setVisible(false)
                --下阵刷新数据
                self._nowEmbattleInfo["location"..moveFromPos] = "0"
                --刷新tableview
                self:reloadTableView("down", downIndexInData)
                local function removeFunc(sender)
                    downHero = false
                    canMoveFunc()
                    sender:removeFromParent()
                    self:resetHandVis()
                end
                moveFromHero:runAction(cc.Sequence:create(
                    cc.CallFunc:create(function() table.remove(self._fiveHero, iInFiveHero) end),
                    cc.Spawn:create(
                        cc.ScaleTo:create(0.5, 0.01),
                        cc.MoveTo:create(0.5, cc.p(100, 200))
                    ),
                    -- cc.DelayTime:create(0.2),
                    cc.CallFunc:create(removeFunc)
                ))
                moveFromHero = nil
            end
            if moveFromPos ~= nil and downHero == false then 
                heroMove()
            end
            
            moveFromPos = nil
            moveToPos = nil
            canMove = false
            downHero = false
            self._leftImg:setVisible(false)
            self._tableView:setTouchEnabled(true)
        end
    end, false, true)
end
--判断是否需要保存 true需要保存数据
function BuzhenLayer:needUpdata()
    --判断2个表中的内容是否相同？
    for i=1,9 do
        if tonumber(self._nowEmbattleInfo["location"..i]) ~= tonumber(self._localEmbattleList["location"..i]) then
            return true
        end
    end
    return false
end
--换阵
function BuzhenLayer:changeMatrix(newMatrixID, newMatrixString)
    --改变列表状态
    for i=1,#self._formationInfo do 
        if tonumber(newMatrixID) == tonumber(self._formationInfo[i]["formationId"]) then 
            self._formationInfo[i]["status"] = 1
            self._nowEmbattleInfo = self._formationInfo[i]
        else
            self._formationInfo[i]["status"] = 0
        end
    end
    local newMatrixArray = string.split(newMatrixString, "_")
    for i=1,#newMatrixArray do 
        if tonumber(newMatrixArray[i]) ~= 0 then 
            self._nowEmbattleInfo["location"..i] = newMatrixArray[i]
        else
            self._nowEmbattleInfo["location"..i] = "0"
        end
    end
    local array = string.split(self._nowEmbattleInfo["map"],"|")
    self:reloadRightLayer()
    local acct = self:getMatrixInDB(self._nowEmbattleInfo, self._nowEmbattleInfo.level)
    self._downTitleLab:setText(acct)
    
    --刷新tableview
    self:reloadGeneralList(newMatrixArray)
    self._tableView:reloadData()

    --
    self:initPointLocation(self._oldSelected, self._formationInfo[self._oldSelected:getTag()])
    --选中
    for i=1,#self._itemMatrix do 
        if tonumber(self._itemMatrix[i].formationId) == tonumber(newMatrixID) then 
            -- local posx = self._itemMatrix[i]:getPositionX()
            -- self._matrix_itemlight:setPositionX(posx)
            self:initPointLocation(self._itemMatrix[i], self._formationInfo[i])
            self._oldSelected = self._itemMatrix[i]
        end
    end
end
--根据位置判断zorer
function BuzhenLayer:getZorder(matrixPos)
    matrixPos = tonumber(matrixPos)
    local orders = {1,4,7,2,5,8,3,6,9}
    if matrixPos <= #orders then 
        return orders[matrixPos] + 10
    else
        return 1 + 10
    end
end

function BuzhenLayer:onEnter() 
    if self._handBtn1 then
        local _mainCity = zc.getScene("mainCity")
        if _mainCity then
            _mainCity:setBuzhenHandFlag(false)
            _mainCity:checkShowFuben()
        end
        self._guideHand = zc.createSpine({
            fileName = "shou",
            actName = "shou",
            scale = 0.5
        })
        -- self._guideHand:setScaleX(-1)
        local _btn = self._handBtn1
        self._guideHand:setPosition(cc.pMul(cc.pFromSize(_btn:getContentSize()), 0.5))
        _btn:addChild(self._guideHand, 10)
    end
    --新手引导
    getGuideManager():addMaskLayer()
    performWithDelay(self, function ()
        getGuideManager():removeMaskLayer()
        zc.addGuideBtn(self._guideBtn, self._scale)
        self:addGuide_1()
    end,0.3)
end

--新手引导
function BuzhenLayer:guideFunc()
    local _currentGID = getGuideManager():getCurrentGID()
    if _currentGID == GuideKey.KEY_2010 or _currentGID == GuideKey.KEY_12811 then
        getGuideManager():guideOver()
        getGuideManager():setNextGID(_currentGID)
    end
end

--新手引导
function BuzhenLayer:addGuide_1()
    local _currentGID = getGuideManager():getCurrentGID()
    if _currentGID == GuideKey.KEY_2016 then
        getGuideManager():setObjTarget(self._guideBtnItem)
        getGuideManager():startGuide()
    elseif _currentGID == GuideKey.KEY_12814 then
        getGuideManager():setObjTarget(self._guideBtnItem2)
        getGuideManager():startGuide()
    end
end
--新手引导
function BuzhenLayer:guideFunc_1()
    local _currentGID = getGuideManager():getCurrentGID()
    if _currentGID == GuideKey.KEY_2016 then
        getGuideManager():setNextGID(_currentGID)
        self:addGuide_2()
    elseif _currentGID == GuideKey.KEY_12814 then
        zc.setGuideFuncNextStep(_currentGID)
    end
end

--新手引导
function BuzhenLayer:addGuide_2()
    local _currentGID = getGuideManager():getCurrentGID()
    if inArray(_currentGID, GuideGroup.BTN_BACK_MAINCITY)  then
        getGuideManager():setObjTarget(self._closeBtn)
        getGuideManager():startGuide()
    end
end



return BuzhenLayer