--[[
	押镖通缉弹窗
	唐实聪
	2016.8.6
]]
local CountryDartWantedPop = class("CountryDartWantedPop", function()
	return ZCPopLayer:create({opacityValue = 150})
end)

function CountryDartWantedPop:create( params )
	return CountryDartWantedPop.new( params )
end

function CountryDartWantedPop:ctor( params )
	self:initData()
	self:initUI()
    self:buildData( params )
    self:show()
end

function CountryDartWantedPop:initData()
    self._list = {}

	local _size = self:getContentSize()
	self._width = _size.width
	self._height = _size.height
end

function CountryDartWantedPop:initUI()
	local _sp = cc.Sprite:create()
	_sp:setContentSize( self._width, self._height )
	_sp:setPosition( self._width/2, self._height/2 )
	self:addContent( _sp )
	-- 背景
	-- local _bg = cc.Sprite:create( "res/Main/country/countryDart/wantedBg.png" )
    local _bg = zc.createNormalPop({
        src = "res/Main/country/countryDart/wantedBg.png",
        bianZOrder = 0,
        height = 515 + 31,
    })
	_bg:setPosition( self._width/2, self._height/2 )
	_sp:addChild( _bg )
	self._bg = _bg
	local _bgSize = _bg:getContentSize()
	local _bgWidth = _bgSize.width
	local _bgHeight = _bgSize.height
	-- tableview
	local _tableview = zc.ZCTableView:create( cc.size( 668, 428 ) )
    _tableview:setBounceable( true )
    _tableview:setInertia( true )
    _tableview:setDirection( cc.SCROLLVIEW_DIRECTION_VERTICAL )
    _tableview:setPosition( 28, 26 )
    _tableview:setDelegate()
    _tableview:setVerticalFillOrder( cc.TABLEVIEW_FILL_TOPDOWN )
    local cellWidth = 668
    local cellHeight = 100
    local function cellSizeForTable(table, index) 
        return cellHeight, cellWidth
    end
    local function tableCellAtIndex(table, index)
        local cell = _tableview:dequeueCell()
        -- 创建模板
        if cell == nil then
            cell = zc.ZCTableViewCell:new()
            self:buildCell( cell, index, cellWidth, cellHeight )
        end
        -- 更新界面
        self:updateCell( cell, index )

        return cell
    end
    local function numberOfCellsInTableView()
    	return #self._list
    end
    _tableview:registerScriptHandler( cellSizeForTable, cc.TABLECELL_SIZE_FOR_INDEX )
    _tableview:registerScriptHandler( tableCellAtIndex, cc.TABLECELL_SIZE_AT_INDEX )
    _tableview:registerScriptHandler( numberOfCellsInTableView, cc.NUMBER_OF_CELLS_IN_TABLEVIEW )
    _bg:addChild( _tableview )
    self._tableview = _tableview
    -- 没有玩家
    local _emptyBg = cc.Sprite:create( "res/Main/country/countryDart/emptyBg.png" )
    _emptyBg:setPosition( _bgWidth/2, 288 )
    _bg:addChild( _emptyBg )
    self._emptyBg = _emptyBg
    local _emptyIcon = cc.Sprite:create( "res/Main/country/countryDart/emptyIcon.png" )
    _emptyIcon:setPosition( 30, 24 )
    _emptyBg:addChild( _emptyIcon )
    local _emptyLabel = zc.createLabel({
        text = zc.lang("now_have_no_dartwanted_player"),
        fontSize = 20,
        color = cc.c3b( 76, 18, 18 ),
        ap = cc.p( 0, 0.5 ),
        pos = cc.p( 50, 24 ),
    })
    _emptyBg:addChild( _emptyLabel )
	-- 标题
	local _title = cc.Sprite:create( "res/Main/country/countryDart/wantedTitle.png" )
	_title:setPosition( 63, _bgHeight - 13 )
	_bg:addChild( _title )
	-- 关闭按钮
	local _close = zc.createBackButton({
		pos = cc.p( _bgWidth - 10, _bgHeight ),
		listener = function ()
			self:hide()
		end
	})
	_bg:addChild( _close )
end

function CountryDartWantedPop:buildCell( cell, index, cellWidth, cellHeight )
	-- cellBg
	local _cellBg = cc.Sprite:create( "res/Main/country/countryDart/wantedCellBg.png" )
	_cellBg:setPosition( cellWidth/2, cellHeight/2 )
	cell:addChild( _cellBg )
    cell._cellBg = _cellBg
	local _cellHeight = _cellBg:getContentSize().height
    -- 名字背景
    local _nameBg = cc.Sprite:create( "res/Main/wushenTower/name_bg_1.png" )
	_nameBg:setPosition( 203, _cellHeight/2 - 5 )
	_cellBg:addChild( _nameBg )
	local _nameBgSize = _nameBg:getContentSize()
	local _nameBgWidth = _nameBgSize.width
	local _nameBgHeight = _nameBgSize.height
	-- 国家
    local _countryName = zc.createLabel({
        fontSize = 20,
		color = cc.c3b( 76, 18, 18 ),
        pos = cc.p( _nameBgWidth/2, _nameBgHeight ),
    })
    _nameBg:addChild( _countryName )
    cell._countryName = _countryName
    -- 名字
    local _userName = zc.createLabel({
        fontSize = 20,
        pos = cc.p( _nameBgWidth/2, _nameBgHeight/2 - 10 ),
    })
    _nameBg:addChild( _userName )
    cell._userName = _userName
    -- 兵器
    local _weaponSp = cc.Sprite:create()
    _weaponSp:setPosition( 0, _nameBgHeight/2 - 10 )
    _nameBg:addChild( _weaponSp )
    cell._weaponSp = _weaponSp
    -- 战斗力图片
    local _fightingSp = cc.Sprite:create( "res/Main/hero/hero_zdl.png" )
    _fightingSp:setAnchorPoint( 0, 0.5 )
    _fightingSp:setPosition( 316, _cellHeight/2 )
	_cellBg:addChild( _fightingSp )
	-- 战斗力数字
	local _fightingNum = zc.createFntLabel({
        fnt = "res/Main/common/fnt/fight.fnt",
        ap = cc.p( 0, 0.5 ),
        pos = cc.p( 80, _fightingSp:getContentSize().height/2 - 7 ),
        addwidth = -5,
    })
    _fightingSp:addChild( _fightingNum )
    cell._fightingNum = _fightingNum
    -- 攻击复仇
    local _atkBtn = zc.createPushButton({
    	touchScale = 0.95,
    	pos = cc.p( 573, 47 ),
    	endCallback = function()
            if cell.userId then
        		zc.sendHttp({
    		        apiName = "CountryDart_wantedChallenge",
    		        params = {targetUserId = cell.userId},
    		        successCallback = function (result)
    		        	-- dump(result, "CountryDart_wantedChallenge")
                        self:buildData( result.list or {} )
                        zc.saveData( result )
                        local _data = {}
                        _data.data = result
                        _data.battleType = BattleType.CountryDartWanted
                        zc.initBattleHeroInfo( _data )
    		        end,
    		    })
            end
    	end
	})
    _cellBg:addChild( _atkBtn )
    cell._atkBtn = _atkBtn
	-- 仇人
	local _enemyTitle = cc.Sprite:create( "res/Main/country/countryDart/enemyTitle.png" )
	_enemyTitle:setPosition( 25, _cellHeight - 17 )
	_cellBg:addChild( _enemyTitle, 1 )
	cell._enemyTitle = _enemyTitle
end

function CountryDartWantedPop:updateCell( cell, index )
	local _data = self._list[index + 1]
    if not _data then
        cell.userId = nil
        return
    end

    cell.userId = _data.userId

    if cell._head then
        cell._head:removeFromParent()
        cell._head = nil
    end
    local _head = zc.createPlayerHead({iconId = _data.iconId, level = _data.level})
    _head:setPosition( 50, cell._cellBg:getContentSize().height/2 )
    _head:setScale( 0.8 )
    cell._cellBg:addChild( _head )
    cell._head = _head

    cell._countryName:setText( _data.countryName )
    cell._userName:setText( _data.userName )
    local _weaponData = gameData.getDataFromCacheWithPrimaryKey("weapon", _data.weaponId)
    cell._weaponSp:setTexture( zc.getHeroTypeImg( _weaponData.type ) )
    
    cell._fightingNum:setString( _data.fighting )

    if _data.isEnemy then
        -- 复仇
        cell._atkBtn:setStateNormal( "res/Main/country/countryDart/revenge_u.png" )
        cell._atkBtn:setStateSelected( "res/Main/country/countryDart/revenge_u.png" )
        cell._atkBtn:setStateDisable( "res/Main/country/countryDart/revenge_g.png" )
        cell._enemyTitle:setVisible( true )
    else
        -- 攻击
        cell._atkBtn:setStateNormal( "res/Main/country/countryDart/atk_u.png" )
        cell._atkBtn:setStateSelected( "res/Main/country/countryDart/atk_u.png" )
        cell._atkBtn:setStateDisable( "res/Main/country/countryDart/atk_g.png" )
        cell._enemyTitle:setVisible( false )
    end

    cell._atkBtn:setScale( 1 )
end

function CountryDartWantedPop:buildData( data )
    local _enemy = {}
    for i, v in ipairs( data.lootedUsers or {} ) do
        _enemy[tonumber( v )] = true
    end
    self._list = {}
    for k, v in pairs( data.list or {} ) do
        v.isEnemy = _enemy[tonumber( v.userId )] or false
        self._list[#self._list + 1] = v
    end
    table.sort(self._list, function( a, b )
        return a.isEnemy and not b.isEnemy
    end)
    self._tableview:reloadData()
    if #self._list == 0 then
        self._emptyBg:setVisible( true )
    else
        self._emptyBg:setVisible( false )
    end
end

return CountryDartWantedPop