 --[[
	世界boss奖励弹窗
	唐实聪
	2016.6.16
]]
local WorldBossRankRewardPop = class("WorldBossRankRewardPop", function()
	return ZCPopLayer:create()
end)

function WorldBossRankRewardPop:create( params )
	return WorldBossRankRewardPop.new( params )
end

function WorldBossRankRewardPop:ctor( params )
	self:initData( params )
	self:initUI()
	self:startTimer()
	zc.addEventListener({
		name = CUSTOM_EVENT.EVENT_REFRESH_WORLDBOSS_REWARD,
		callback = function(event)
			self._bossReward = event.data.status
			self:tick()
		end,
	})
	self:show()
end

function WorldBossRankRewardPop:initData( params )
	-- dump( params )
	-- 排行数据
	self._rankInfo = params.rankInfo
	-- 伤害数据
	self._userInfo = params.userInfo
	-- id数据
	self._bossModels = params.bossModels

	self._rewardCD = params.rewardCD

	self._unlockStatus = params.unlockStatus

	self._bossReward = params.bossReward
	-- dump(self._bossReward,"self._bossReward")

	self._fetchCallback = params.fetchCallback

	self:initTabData()

	-- boss类型，不一定是按钮顺序
	self._bossType = 1

	-- 排行类型，1表示个人，2表示国家
	self._rankType = 1

	-- 奖励
	local _rewardList = {}
	for k, v in pairs( gameData.getDataFromCache("bossPve_award") ) do
		local _groupId = string.split( v.groupId, "|" )
		v._begin = tonumber( _groupId[1] ) or 0
		v._end = tonumber( _groupId[2] ) or 0
		_rewardList[#_rewardList + 1] = v
	end
	self._rewardList = {}
	for i, v in ipairs( params.groupInfo ) do
		self._rewardList[i] = {
			[1] = {},
			[2] = {},
		}
		local _groupId = tonumber( v.groupId ) or 0
		local _data = {}
		for i, v in ipairs( _rewardList ) do
			if _groupId >= v._begin and _groupId <= v._end then
				_data[#_data + 1] = v
			end
		end
		for j, u in ipairs( _data ) do
			-- 奖励
			local _reward = {}
			local _tmp_1 = string.split( u.awards, "," )
			for k, w in ipairs( _tmp_1 ) do
				local _tmp_2 = string.split( w, "|" )
				_reward[#_reward + 1] = {
					itemType = tonumber( _tmp_2[1] ) or 0,
					itemId = tonumber( _tmp_2[2] ) or 0,
					itemNum = tonumber( _tmp_2[3] ) or 0,
				}
			end
			-- 排名
			local _rank = {}
			local _tmp = string.split( tostring( u.rank ), "|" )
			_rank[1] = tonumber( _tmp[1] ) or 0
			_rank[2] = tonumber( _tmp[2] ) or tonumber( _tmp[1] ) or 0
			self._rewardList[i][tonumber( u.type )][#self._rewardList[i][tonumber( u.type )] + 1] = {
				reward = _reward,
				rank = _rank,
			}
		end
	end
	-- dump( self._rewardList )

	-- 奖励ui
	self._reward = {}

	self._size = self:getContentSize()
	self._rightSize = cc.size( 700, 450 )
end

function WorldBossRankRewardPop:initTabData()
	-- 按照boss的顺序，index是按钮的顺序，预防策划的改顺序需求
	self._tabData = {
		[1] = {
			index = 1,
			name = zc.lang("huangjin_army"),
		},
		[2] = {
			index = 2,
			name = zc.lang("xiliang_army"),
		},
		[3] = {
			index = 3,
			name = zc.lang("shu_army"),
		},
	}
	self._typeBtn = {}
end

function WorldBossRankRewardPop:initUI()
	-- 背景
	-- local background = cc.Sprite:create( "res/Main/common/popBg/popBg_red.png" )
	local background = zc.createNormalPop({
		src = "res/Main/common/popBg/popBg_red.png",
		bianZOrder = 0,
		height = 527 + 31,
	})
	background:setPosition( self._size.width/2, self._size.height/2 )
	self:addContent( background )
	self._bg = background
	local bgWidth = background:getContentSize().width
	local bgHeight = background:getContentSize().height

	-- 标题背景云
	local titleCloud = cc.Sprite:create( "res/Main/common/title_bg_cloud.png" )
	background:addChild( titleCloud, -2)
	titleCloud:setAnchorPoint( 0, 0.5 )
	titleCloud:setPosition( -80, bgHeight )
	-- 标题背景
	local titleBg = cc.Sprite:create( "res/Main/common/title_bg_shadow.png" )
	titleBg:setAnchorPoint( 0, 0.5 )
	titleBg:setPosition( -30, bgHeight )
	background:addChild( titleBg )
	-- 标题
	local title = cc.Sprite:create( "res/Main/arena/rank/title.png" )
	title:setAnchorPoint( 0, 0.5 )
	title:setPosition( -5, bgHeight )
	background:addChild( title )

	-- 奖励提示
	local tip = zc.createLabel({
		text = zc.lang("worldboss_reward_send_tips"),
        fontSize = 18,
        color = zc.COLOR_RED,
        outLine = true,
        pixel = 1.5,
        ap = cc.p( 0, 0.5 ),
        pos = cc.p( 230, bgHeight - 25 ),
	})
	background:addChild( tip )
	-- 选中
	local _check = cc.Sprite:create( "res/Main/home/home_reachCondition.png" )
	background:addChild( _check, 1 )
	local _checkBtn = {}
	-- 个人排名
	local _checkBtn_personal = zc.createPushButton({
		normalFile = "res/Main/smithy/smithy_checkdi.png",
		pos = cc.p( 700, bgHeight - 25 ),
		endCallback = function()
			if self._rankType ~= 1 then
				self._rankType = 1
				_check:setPosition( _checkBtn[self._rankType]:getPosition() )
				self:refreshRankType()
			end
		end
	})
	background:addChild( _checkBtn_personal )
	_checkBtn[#_checkBtn + 1] = _checkBtn_personal
	local _label_personal = zc.createLabel({
		text = zc.lang("personal_rank"),
        fontSize = 22,
        outLine = true,
        ap = cc.p( 0, 0.5 ),
        pos = cc.p( _checkBtn_personal:getPositionX() + 23, _checkBtn_personal:getPositionY() ),
	})
	background:addChild( _label_personal )
	-- 国家排名
	local _checkBtn_country = zc.createPushButton({
		normalFile = "res/Main/smithy/smithy_checkdi.png",
		pos = cc.p( 560, bgHeight - 25 ),
		endCallback = function()
			if self._rankType ~= 2 then
				self._rankType = 2
				_check:setPosition( _checkBtn[self._rankType]:getPosition() )
				self:refreshRankType()
			end
		end
	})
	background:addChild( _checkBtn_country )
	_checkBtn[#_checkBtn + 1] = _checkBtn_country
	local _label_country = zc.createLabel({
		text = zc.lang("country_rank"),
        fontSize = 22,
        outLine = true,
        ap = cc.p( 0, 0.5 ),
        pos = cc.p( _checkBtn_country:getPositionX() + 23, _checkBtn_country:getPositionY() ),
	})
	background:addChild( _label_country )

	_check:setPosition( _checkBtn[self._rankType]:getPosition() )


	-- 左边标签
	self:initTab()
	-- 右边
	self:initRight()
	-- 关闭按钮
	local closeBtn = zc.createBackButton({
		pos = cc.p( bgWidth, bgHeight ),
		listener = function ()
			self:hide()
		end
	})
	background:addChild( closeBtn )

	-- 入场动画
	self:refreshRankType()
end

function WorldBossRankRewardPop:initTab()
	local _height = 500
	for i, v in ipairs( self._tabData ) do
		if self._unlockStatus[v.index] then
			_height = _height - 72
			-- 按钮
			local typeBtn = zc.createTypeBtn({
		        btnText = v.name,
		        pos = cc.p( 86, _height ),
		        endCallback = function()
		        	if self._bossType ~= i then
						self._typeBtn[self._tabData[self._bossType].index]:setSelected( false )
						self._bossType = i
						self._typeBtn[self._tabData[self._bossType].index]:setSelected( true )
		        		self:refreshRankType()
		        	end
		        end
			})
			self._bg:addChild( typeBtn )
			self._typeBtn[v.index] = typeBtn
		end
	end
	self._typeBtn[self._tabData[self._bossType].index]:setSelected( true )
end

function WorldBossRankRewardPop:initRight()
	-- 尺寸
	local topHeight = 40
	local middleHeight = 355
	local bottomHeight = self._rightSize.height - topHeight - middleHeight
	-- 容器
	local rightContainer = cc.Sprite:create()
	rightContainer:setContentSize( self._rightSize )
	rightContainer:setAnchorPoint( 0, 0.5 )
	rightContainer:setPosition( 163, 245 )
	self._bg:addChild( rightContainer )
	self._rightContainer = rightContainer
	-- 背景
    local rightBg = ccui.Scale9Sprite:create( cc.rect( 25, 26, 3, 2 ), "res/Main/common/common_inner20.png" )
    rightBg:setContentSize( self._rightSize.width + 2, self._rightSize.height )
    rightBg:setPosition( self._rightSize.width/2, self._rightSize.height/2 )
    rightContainer:addChild( rightBg )

    -- 顶部
    -- 顶部背景
    local topBg = cc.Sprite:create( "res/Main/arena/rank/topBg.png" )
    topBg:setPosition( self._rightSize.width/2, self._rightSize.height - topHeight/2 )
    rightContainer:addChild( topBg )
    local _topY = topHeight/2 - 3
    -- 排名文字
    local rankText = zc.createLabel({
    	text = LANGUAGE_ARENA.rank,
        fontSize = 20,
        outLine = true,
        ap = cc.p( 0.5, 0.5 ),
        pos = cc.p( 113, _topY ),
	})
	topBg:addChild( rankText )
	-- 名字文字
    local nameText = zc.createLabel({
    	text = LANGUAGE_ARENA.name,
        fontSize = 20,
        outLine = true,
        ap = cc.p( 0.5, 0.5 ),
        pos = cc.p( 268, _topY ),
	})
	topBg:addChild( nameText )
	-- 伤害文字
    local demageText = zc.createLabel({
    	text = zc.lang("hurt"),
        fontSize = 20,
        outLine = true,
        ap = cc.p( 0.5, 0.5 ),
        pos = cc.p( 430, _topY ),
	})
	topBg:addChild( demageText )
	-- 奖励文字
    local rewardText = zc.createLabel({
    	text = zc.lang("reward"),
        fontSize = 20,
        outLine = true,
        ap = cc.p( 0.5, 0.5 ),
        pos = cc.p( 605, _topY ),
	})
	topBg:addChild( rewardText )

    -- 中间
    -- 顶部滑动阴影
    local topShadow = cc.Sprite:create( "res/Main/arena/rank/shadow.png" )
    topShadow:setAnchorPoint( 0.5, 1 )
    topShadow:setPosition( self._rightSize.width/2, self._rightSize.height - topHeight )
    rightContainer:addChild( topShadow, 1 )
    self._topShadow = topShadow
    topShadow:setVisible( false )
    local topArrow = cc.Sprite:create( "res/Main/common/arrow_left.png" )
    topArrow:setRotation( 90 )
    topArrow:setScale( 0.5 )
    topArrow:setAnchorPoint( 0, 0.5 )
    topArrow:setPosition( topShadow:getContentSize().width/2, topShadow:getContentSize().height )
    topShadow:addChild( topArrow )
    topArrow:runAction(
    	cc.RepeatForever:create(
    		cc.Sequence:create(
	    		cc.MoveTo:create(
	    			2, cc.p( topShadow:getContentSize().width/2, topShadow:getContentSize().height - 10 )
				),
	    		cc.MoveTo:create(
	    			2, cc.p( topShadow:getContentSize().width/2, topShadow:getContentSize().height )
				)
			)
		)
	)
    -- 底部滑动阴影
    local bottomShadow = cc.Sprite:create( "res/Main/arena/rank/shadow.png" )
    bottomShadow:setFlippedY( true )
    bottomShadow:setAnchorPoint( 0.5, 0 )
    bottomShadow:setPosition( self._rightSize.width/2, bottomHeight )
    rightContainer:addChild( bottomShadow, 1 )
    self._bottomShadow = bottomShadow
    bottomShadow:setVisible( false )
    local bottomArrow = cc.Sprite:create( "res/Main/common/arrow_left.png" )
    bottomArrow:setRotation( -90 )
    bottomArrow:setScale( 0.5 )
    bottomArrow:setAnchorPoint( 0, 0.5 )
    bottomArrow:setPosition( topShadow:getContentSize().width/2, 0 )
    bottomShadow:addChild( bottomArrow )
    bottomArrow:runAction(
    	cc.RepeatForever:create(
    		cc.Sequence:create(
	    		cc.MoveTo:create(
	    			2, cc.p( topShadow:getContentSize().width/2, 10 )
				),
	    		cc.MoveTo:create(
	    			2, cc.p( topShadow:getContentSize().width/2, 0 )
				)
			)
		)
	)
	-- tableview
	self._tableviewSize = cc.size( self._rightSize.width, middleHeight )
	local rankTabelview = zc.ZCTableView:create( self._tableviewSize )
    rankTabelview:setBounceable( true )
    rankTabelview:setInertia( true )
    rankTabelview:setDirection( cc.SCROLLVIEW_DIRECTION_VERTICAL )
    rankTabelview:setPosition( cc.p( 0, bottomHeight ) )
    rankTabelview:setDelegate()
    rankTabelview:setVerticalFillOrder( cc.TABLEVIEW_FILL_TOPDOWN )
    local cellWidth = self._tableviewSize.width
    local cellHeight = 90
    -- 屏幕上显示的cell数量
    local cellShowNum = math.ceil( self._tableviewSize.height/cellHeight )
    local function cellSizeForTable(table, index) 
        return cellHeight, cellWidth
    end
    local function tableCellAtIndex(table, index)
        local cell = rankTabelview:dequeueCell()
        -- 创建模板
        if cell == nil then
            cell = zc.ZCTableViewCell:new()
            self:buildCell( cell, index, cellWidth, cellHeight )
        end
        cell._cellBg:setScale( 1 )
        -- 更新界面
        self:updateCell( cell, index )
        return cell
    end
    local function numberOfCellsInTableView()
    	return #self._rankInfo[self._bossType][self._rankType]
    end
    local function scorllviewScriptScroll( table )
    	local cellNum = numberOfCellsInTableView()
    	if cellNum > cellShowNum then
        	self:scorllviewScriptScroll( table, cellNum )
        end
    end
    rankTabelview:registerScriptHandler( cellSizeForTable, cc.TABLECELL_SIZE_FOR_INDEX )
    rankTabelview:registerScriptHandler( tableCellAtIndex, cc.TABLECELL_SIZE_AT_INDEX )
    rankTabelview:registerScriptHandler( numberOfCellsInTableView, cc.NUMBER_OF_CELLS_IN_TABLEVIEW )
    rankTabelview:registerScriptHandler( scorllviewScriptScroll, zctech.SCROLLVIEW_SCRIPT_SCROLL )
    rightContainer:addChild(rankTabelview)
    self._rankTabelview = rankTabelview
    
    -- 底部
    -- 我的排名
    local myRankText = zc.createLabel({
    	text = LANGUAGE_ARENA.rank_mine..":",
        fontSize = 20,
        outLine = true,
        ap = cc.p( 1, 0.5 ),
        pos = cc.p( 95, bottomHeight/2 ),
	})
	rightContainer:addChild( myRankText )
    local myRankNum = zc.createLabel({
        fontSize = 20,
        color = zc.COLOR_YELLOW,
        outLine = true,
        ap = cc.p( 0, 0.5 ),
        pos = cc.p( myRankText:getPositionX() + 10, myRankText:getPositionY() - 1 ),
	})
	rightContainer:addChild( myRankNum )
	self._myRankNum = myRankNum
	-- 我的伤害
	local myDemageText = zc.createLabel({
    	text = zc.lang("my_hurt") .. ":",
        fontSize = 20,
        outLine = true,
        ap = cc.p( 1, 0.5 ),
        pos = cc.p( 260, bottomHeight/2 ),
	})
	rightContainer:addChild( myDemageText )
	self._myNameTips = myDemageText
    local myDemageNum = zc.createLabel({
        fontSize = 20,
        color = zc.COLOR_RED,
        outLine = true,
        ap = cc.p( 0, 0.5 ),
        pos = cc.p( myDemageText:getPositionX() + 10, myDemageText:getPositionY() - 1 ),
	})
	rightContainer:addChild( myDemageNum )
	self._myDemageNum = myDemageNum
	-- 奖励
	local myRewardText = zc.createLabel({
    	text = zc.lang("reward") .. ":",
        fontSize = 20,
        outLine = true,
        ap = cc.p( 1, 0.5 ),
        pos = cc.p( 400, bottomHeight/2 ),
	})
	rightContainer:addChild( myRewardText )
	-- 领取
	local fetchBtn = zc.createCommomBtn({
	    tag = 1,
	    scale = 0.8,
	    labScale = true,
        size = cc.size( 100, 40 ),
        fontSize = 20,
        pos = cc.p( 630, bottomHeight/2 ),
        endCallback = function()
			zc.sendHttp({
				apiName = "BossPve_getAward",
				params = {groupId = self._bossModels[self._bossType].groupId},
				successCallback = function(data)
					self._bossReward[self._bossType] = 0
					if self._fetchCallback then
						self._fetchCallback()
					end
					self:tick()
					PlayerData:updataData( data )
				end,
			})
        end
    })
	rightContainer:addChild( fetchBtn )
	self._fetchBtn = fetchBtn
	-- 倒计时
	local timerLabel = zc.createLabel({
		color = zc.COLOR_GREEN,
		fontSize = 22,
		outLine = true,
		pixel = 2,
		pos = cc.p( fetchBtn:getPosition() ),
	})
	rightContainer:addChild( timerLabel )
	self._timerLabel = timerLabel
end

function WorldBossRankRewardPop:buildCell( cell, index, cellWidth, cellHeight )
	local middleY = cellHeight/2
	-- 背景
	local cellBg = cc.Sprite:create()
	cellBg:setContentSize( 694, 87 )
	cellBg:setPosition( cellWidth/2, middleY )
	cell:addChild( cellBg )
	cell._cellBg = cellBg
	-- 排名数字
	local rankNum = zc.createFntLabel({
		fnt = "res/Main/arena/rank/fnt/arenaRank_num.fnt",
        pos = cc.p( 95, middleY ),
	})
	cellBg:addChild( rankNum )
	cell._rankNum = rankNum
	-- 排名图标
	local rankIcon = cc.Sprite:create()
	rankIcon:setContentSize( 72, 67 )
	rankIcon:setPosition( rankNum:getPosition() )
	cellBg:addChild( rankIcon )
	cell._rankIcon = rankIcon
	-- 分隔线
	local split = cc.Sprite:create( "res/Main/arena/rank/split.png" )
	split:setPosition( 177, middleY )
	cellBg:addChild( split )
	-- 名字
	local name = zc.createLabel({
        fontSize = 20,
        outLine = true,
        pixel = 1.3,
        ap = cc.p( 0.5, 0.5 ),
        pos = cc.p( 255, middleY ),
	})
	cellBg:addChild( name )
	cell._name = name
	-- 伤害
	local demage = zc.createLabel({
        fontSize = 20,
        outLine = true,
        pixel = 1.3,
        ap = cc.p( 0.5, 0.5 ),
        pos = cc.p( 427, middleY ),
	})
	cellBg:addChild( demage )
	cell._demage = demage
	-- btn
	local btn = ccui.Widget:create()
	btn:setContentSize( cellBg:getContentSize() )
	btn:setPosition( cellBg:getContentSize().width/2, cellBg:getContentSize().height/2 )
	btn:setTouchEnabled( true )
	btn:setSwallowTouches( false )
	btn:onTouch(function(event)
		if event.name == "began" then
            cellBg:runAction(
                cc.ScaleTo:create( 0.05, 0.9 )
            )
        elseif event.name == "moved" then
        elseif event.name == "ended" then
            cellBg:runAction(
                cc.ScaleTo:create( 0.05, 1 )
            )
            if self._rankType == 1 then
	            local data = self._rankInfo[self._bossType][self._rankType][index + 1]
            	zc.createOtherPlayerSelect( data.userId )
	        end
        elseif event.name == "cancelled" then
            cellBg:runAction(
                cc.ScaleTo:create( 0.05, 1 )
            )
        end
	end)
	cellBg:addChild( btn )

	cell._reward = {}
end

function WorldBossRankRewardPop:updateCell( cell, index )
	cell._index = index + 1
	-- 数据
	local data = self._rankInfo[self._bossType][self._rankType][index + 1]
	-- dump( data, "data" )
	-- 背景，排名图标，排名数字
	if data.rank >= 1 and data.rank <= 3 then
		cell._cellBg:setTexture( "res/Main/arena/rank/bg_"..data.rank..".png" )
		cell._rankIcon:setVisible( true )
		cell._rankIcon:setTexture( "res/Main/arena/rank/icon_"..data.rank..".png" )
		cell._rankNum:setString( "" )
	else
		cell._cellBg:setTexture( "res/Main/arena/rank/bg_4.png" )
		cell._rankIcon:setVisible( false )
		cell._rankNum:setString( data.rank )
	end
	-- 名字
	cell._name:setText(zc.getLevelTipShow()..tostring( data.level ).."  "..tostring( data.userName or data.name ) )
	-- 伤害
	cell._demage:setText( data.damage )
	-- 奖励
	for i, v in ipairs( cell._reward ) do
	 	v:removeFromParent()
	end
	cell._reward = {}
	local _rewardData = {}
	for i, v in ipairs( self._rewardList[self._bossType][self._rankType] ) do
		if data.rank >= v.rank[1] and data.rank <= v.rank[2] then
			_rewardData = v.reward
			break
		end
	end
	-- dump( _rewardData )
	for i, v in ipairs( _rewardData ) do
		local rewardInfo = zc._getIconInfo({data={mainType=v.itemType,type=v.itemId,id=v.itemId,num=v.itemNum}})
		local reward = cc.Sprite:create( rewardInfo.img )
		reward:setScale( 40/reward:getContentSize().width )
		cell._cellBg:addChild( reward )
		cell._reward[#cell._reward + 1] = reward
		local rewardNum = zc.createLabel({
	        text = "x"..zc.getWan( rewardInfo.num ),
	        fontSize = 20,
	        color = zc.COLOR_YELLOW,
	        ap = cc.p( 0, 1 ),
	        outLine = true,
	    })
		cell._cellBg:addChild( rewardNum )
		cell._reward[#cell._reward + 1] = rewardNum
		local _width = reward:getBoundingBox().width/2 + rewardNum:getContentSize().width
		reward:setPosition( ( 2*i - 1 )*100/#_rewardData + 500 - _width/2, cell._cellBg:getContentSize().height/2 )
		rewardNum:setPosition( reward:getPositionX(), reward:getPositionY() )
	end
end

function WorldBossRankRewardPop:scorllviewScriptScroll( table, cellNum )
	local cellHeight = 90
	if table:getContentOffset().y >= 0 then
    	self._topShadow:setVisible( true )
    	self._bottomShadow:setVisible( false )
    elseif table:getContentOffset().y <= self._tableviewSize.height - cellHeight*cellNum then
    	self._topShadow:setVisible( false )
    	self._bottomShadow:setVisible( true )
    else
    	self._topShadow:setVisible( true )
    	self._bottomShadow:setVisible( true )
    end
end

function WorldBossRankRewardPop:refreshRankType()
	-- 动画
	self:initAnimation()
	-- 刷新底部
	self:refreshBottom()
	-- 倒计时
	self:tick()
end

-- 入场动画
function WorldBossRankRewardPop:initAnimation()
	self._topShadow:setVisible( false )
	self._rankTabelview:reloadData()
    local cellHeight = 90
    local cellNum = math.ceil( self._tableviewSize.height/cellHeight )
    for i = 1, cellNum do
    	local cell = self._rankTabelview:cellAtIndex( i - 1 )
    	if cell then
    		cell:stopAllActions()
	    	cell:setPosition( 0, self._rankTabelview:getContentSize().height - cellHeight - self._tableviewSize.height )
	    	cell:runAction(
	    		cc.Sequence:create(
	    			cc.DelayTime:create( i*0.15 ),
					cc.EaseExponentialOut:create( cc.MoveTo:create( 0.8, cc.p( 0, self._rankTabelview:getContentSize().height - cellHeight*i ) ) )
				)
			)
    	end
    end
end

-- 刷新底部
function WorldBossRankRewardPop:refreshBottom()
	self._myRankNum:setText( self._userInfo[self._bossType][self._rankType][1] or "--" )
	local _myDemageNum = self._userInfo[self._bossType][self._rankType][2]
	local _myNameTips = zc.lang("my_hurt")
	if self._rankType == 2 then
		_myNameTips = zc.lang("country") ..  zc.lang("hurt")
	end
	if _myDemageNum then
		_myDemageNum = zc.getWan( _myDemageNum )
	else
		_myDemageNum = "--"
	end
	self._myNameTips:setString(_myNameTips .. ":")
	self._myDemageNum:setText( _myDemageNum )
	-- 奖励
	for i, v in ipairs( self._reward ) do
	 	v:removeFromParent()
	end
	self._reward = {}
	local _myRank = self._userInfo[self._bossType][self._rankType][1] or 0
	local _rewardData = {}
	for i, v in ipairs( self._rewardList[self._bossType][self._rankType] ) do
		if _myRank >= v.rank[1] and _myRank <= v.rank[2] then
			_rewardData = v.reward
			break
		end
	end
	-- dump( _rewardData )
	for i, v in ipairs( _rewardData ) do
		local rewardInfo = zc._getIconInfo({data={mainType=v.itemType,type=v.itemId,id=v.itemId,num=v.itemNum}})
		local reward = cc.Sprite:create( rewardInfo.img )
		reward:setScale( 40/reward:getContentSize().width )
		self._rightContainer:addChild( reward )
		self._reward[#self._reward + 1] = reward
		local rewardNum = zc.createLabel({
	        text = "x"..zc.getWan( rewardInfo.num ),
	        fontSize = 20,
	        ap = cc.p( 0, 1 ),
	        outLine = true,
	    })
		self._rightContainer:addChild( rewardNum )
		self._reward[#self._reward + 1] = rewardNum
		local _width = reward:getBoundingBox().width/2 + rewardNum:getContentSize().width
		reward:setPosition( ( 2*i - 1 )*100/#_rewardData + 400 - _width/2, self._myRankNum:getPositionY() )
		rewardNum:setPosition( reward:getPositionX(), reward:getPositionY() )
	end
	-- 领取按钮
	if self._rankType == 1 then
		-- 个人奖励
		self._fetchBtn:setVisible( true )
		self._timerLabel:setVisible( true )
	elseif self._rankType == 2 then
		-- 国家奖励
		self._fetchBtn:setVisible( false )
		self._timerLabel:setVisible( false )
	end
end
-- 倒计时相关
function WorldBossRankRewardPop:startTimer()
    self._timer = scheduler.scheduleGlobal(function()
		for i, v in ipairs( self._rewardCD ) do
			if v > 0 then
				self._rewardCD[i] = v - 1
			end
		end
		self:tick()
    end, 1)
end

function WorldBossRankRewardPop:tick()
    if self._bossReward[self._bossType] and self._bossReward[self._bossType] == 1 then
    	if #self._reward == 0 then
	        self._fetchBtn:setEnable( false )
	        self._fetchBtn:setText( zc.lang("fetch") )
	        self._timerLabel:setText( "" )
    	else
	        self._fetchBtn:setEnable( true )
	        self._fetchBtn:setText( zc.lang("fetch") )
	        self._timerLabel:setText( "" )
    	end
    else
		if #self._reward == 0 then
			-- 没有奖励
	        self._fetchBtn:setEnable( false )
	        self._fetchBtn:setText( zc.lang("fetch") )
	        self._timerLabel:setText( "" )
		else
	        self._fetchBtn:setEnable( false )
	        self._fetchBtn:setText( "" )
	        if self._rewardCD[self._bossType] <= 0 then
	        	self._timerLabel:setText( LANGUAGE_TOLLGATEHERO.fetched )
	        else
	        	self._timerLabel:setText( zc.getTimeHMS( self._rewardCD[self._bossType] ) )
	        end
	    end
    end
end

function WorldBossRankRewardPop:onCleanup()
    if self._timer then
        scheduler.unscheduleGlobal( self._timer )
        self._timer = nil
    end
    zc.removeEventListener( CUSTOM_EVENT.EVENT_REFRESH_WORLDBOSS_REWARD )
end

return WorldBossRankRewardPop