--[[

]]
local DrillFieldExpSettlementPop = class("DrillFieldExpSettlementPop", function()
	return ZCPopLayer:create()
end)

function DrillFieldExpSettlementPop:create( params )
	return DrillFieldExpSettlementPop.new( params )
end

function DrillFieldExpSettlementPop:ctor( params )
	self:show()
	self:initData( params )
	self:initUI()
end

function DrillFieldExpSettlementPop:initData( params )
    -- dump(params,"params")
	-- 英雄信息
	self._heroData = params.heroData
	-- 经验加成
	self._expAddData = params.expAddData or 0
	-- 训练时间
	self._time = params.time
    -- 获得经验
    self._addExp = params.addExp or 0

	self._size = self:getContentSize()
end

function DrillFieldExpSettlementPop:initUI()
	-- bg
	local bg = cc.Sprite:create( "res/Main/common/popBg/popup_Bg_blue.png" )
	bg:setPosition( self._size.width/2, self._size.height/2 )
	self:addContent( bg )
	local bgWidth = bg:getContentSize().width
	local bgHeight = bg:getContentSize().height

    local middleBg = zc.getScaleNode("res/Main/common/popBg/di_1.png", cc.size(460, 200))
    middleBg:setPosition(bgWidth*0.5, bgHeight*0.5 + 30)
    bg:addChild(middleBg)
    local middleSize = middleBg:getContentSize()
	-- title
	local title = zc.getTipPopTitle( "xunlianjiesuan" )
    title:setPosition( bgWidth/2, bgHeight - 30 )
	bg:addChild( title )
	-- icon
	local icon = zc.createIconByData({
        data = {
            mainType = zc.mainTypeSoldier,
            type = self._heroData.heroId, 
            id = self._heroData.heroId,
            quality = self._heroData.star,
            level = zc.getLevelTipShow()..self._heroData.level,
            reincarnate = self._heroData.reincarnate,
        },
        showLevel = true,
        pos = cc.p(75, middleSize.height/2 - 5), 
    })
    icon:setScale(0.8)
    middleBg:addChild(icon)
    -- 训练位品质
    local qualityLabel = zc.createLabel({
        text = zc.lang("drill_pos_quality")..":",
        fontSize = 20,
        ap = cc.p(0, 0.5),
        pos = cc.p(150, middleSize.height/2 + 35),
        color = cc.c3b( 76, 18, 18 ),
    })
    middleBg:addChild( qualityLabel )
    local qualityDesc = zc.createLabel({
        text = ( 100*( self._expAddData or 1 ) ).."%"..zc.lang("common"),
        fontSize = 20,
        ap = cc.p(0, 0.5),
        pos = cc.p(270, qualityLabel:getPositionY()),
        outLine = true,
        color = display.COLOR_GREEN,
    })
    middleBg:addChild( qualityDesc )
    -- 训练位倒计时
    local timerLabel = zc.createLabel({
        text = zc.lang("drill_pos_time_total")..":",
        fontSize = 20,
        ap = cc.p(0, 0.5),
        pos = cc.p(150, middleSize.height/2 - 5),
        color = cc.c3b( 76, 18, 18 ),
    })
    middleBg:addChild( timerLabel )
    local timerDesc = zc.createLabel({
        text = zc.timeToClock(self._time,false),
        fontSize = 20,
        ap = cc.p(0, 0.5),
        pos = cc.p(270, timerLabel:getPositionY()),
        outLine = true,
        color = zc.COLOR_RED,
    })
    middleBg:addChild( timerDesc )
    --武将经验
    local expLabel = zc.createLabel({
        text = zc.lang("get_exp")..":",
        fontSize = 20,
        ap = cc.p(0, 0.5),
        pos = cc.p(150, middleSize.height/2 - 45),
        color = cc.c3b( 76, 18, 18 ),
    })
    middleBg:addChild( expLabel )
    local expDesc = zc.createLabel({
        text = self._addExp,
        fontSize = 20,
        ap = cc.p(0, 0.5),
        pos = cc.p(270, expLabel:getPositionY()),
        outLine = true,
        color = display.COLOR_GREEN,
    })
    middleBg:addChild( expDesc )
    --确定按钮
    local confirmBtn = zc.createCommomBtn({
        tag = 1,
        text = zc.lang("confirm"),
        pos = cc.p( bgWidth/2, 70), 
        listener = function () 
            self:hide()
        end,
    })
    bg:addChild( confirmBtn )
end

return DrillFieldExpSettlementPop