--[[
	将魂商店
	wangming
	2017.4.12
]]
local HeroSoulShopLayer = class("HeroSoulShopLayer", function()
    return zc.createNormalDialog()
end)

function HeroSoulShopLayer:create( data )
	return HeroSoulShopLayer.new( data )
end

function HeroSoulShopLayer:ctor( data )
	self.seatNum = 0
	self._exchangeData = {}
	local _pictureList = {}
    local rewardMap = {} --记录重复
	local _allDbs = gameData.getAllDataWithNoClone("heroSoul_shop")
	local _typeIdx = 0
	for k,v in pairs(_allDbs) do
		local _shopType = tostring(v.shopType)
		_typeIdx = rewardMap[_shopType]
		if not _typeIdx then
			_typeIdx = #_pictureList + 1
			_pictureList[_typeIdx] = {}
			rewardMap[_shopType] = _typeIdx
		end
		local _db = gameData.getDataFromCacheWithPrimaryKey("heroSoul", v.itemId)
		table.insert(_pictureList[_typeIdx], {
			data = v,
			db = _db,
			quality = tonumber(_db.quality) or 1,
			itemId = tonumber(v.itemId) or 1,
			id = tonumber(v.id)
		})
	end

	table.sort(_pictureList, function( a, b )
		local _numA = tonumber(a[1].shopType) or 0
		local _numB = tonumber(b[1].shopType) or 0
		return _numA < _numB
	end)

	for k,v in pairs(_pictureList) do
		table.sort(v, function( a, b )
			local _numA = tonumber(a.quality) or 0
			local _numB = tonumber(b.quality) or 0
			if _numA ~= _numB then
				return _numA < _numB
			end
			_numA = tonumber(a.id) or 0
			_numB = tonumber(b.id) or 0
			return _numA < _numB
		end)
	end

	self._pictureList = _pictureList
	self.seatNum = #_pictureList

    self:createSecondBg()
    self:createSubTab()
end

function HeroSoulShopLayer:createSecondBg() 
    --背景
    local subbg = zc.createNormalPop({
        srcTag = 1,
        width = 970,
        height = 520+31,
    })
    subbg:setPosition(zc.width*0.5, zc.height/2-21 )
    self:addChild(subbg)

    local _titleImg = zc.getSprite({
        src = "res/Main/common/popBg/titleBg2.jpg",
        ap = cc.p(1, 1),
        name = "titleImg",
    })
    _titleImg:setPosition(cc.p(subbg:getContentSize().width-3, subbg:getContentSize().height-3))
    subbg:addChild(_titleImg,2)

    local titleLeft = zc.createSprite("res/Main/common/popBg/titleBg2.jpg")
    titleLeft:setAnchorPoint(0, 1)
    titleLeft:setPosition(3, _titleImg:getPositionY())
    subbg:addChild(titleLeft,1)

    --标题
    local subbg_title = zc.createImageView({
        src = "res/Main/heroSoul/shopTitle.png",
        pos = cc.p(0, subbg:getPositionY() + subbg:getContentSize().height/2),
        ap = cc.p(0,0.5)
    })
    self:addChild(subbg_title,10)

    local bgImg2 = zc.getScaleNode("res/Main/otherPlayer/otherPlayer_tag_bg.png", cc.size(154, 473))
    bgImg2:setAnchorPoint(cc.p(0, 0))
    bgImg2:setPosition(cc.p(1, 1))
    bgImg2:setName("bgImg2")
    subbg:addChild(bgImg2)
    local splitY = cc.Sprite:create( "res/Main/common/tab_split_y.png" )
    splitY:setPosition(154,473/2+16)
    bgImg2:addChild(splitY)

    self._subTabBg = subbg
end

function HeroSoulShopLayer:createSubTab() --二级tab
    local subTab = self._subTabBg:getChildByName("bgImg2")
    local subTabSize = subTab:getContentSize()

    local itemHeight = 130
    local innerHeight = itemHeight * self.seatNum + 10
    if innerHeight < subTabSize.height-28 then
        innerHeight = subTabSize.height-28
    end
    local ifBunce = self.seatNum > 2 and true or false
    local myscrollview = zc.createScrollview({
        pos = cc.p(0, 0),
        size = cc.size(subTabSize.width,subTabSize.height-28),
        innerSize = cc.size(subTabSize.width, innerHeight),
        dir = ccui.ScrollViewDir.vertical,
        bounceEnable = false,
    })
    subTab:addChild(myscrollview, 1)

   --tab
    local initPosY = zc.height/2 + 70
    self._subTab = {}

    for i = 1, self.seatNum do
        local _shopType = tonumber(self._pictureList[i][1].data.shopType) or 1
        local _file1 = "res/Main/heroSoul/soulBtn" .. _shopType .. "_u.png"
        local _file2 = "res/Main/heroSoul/soulBtn" .. _shopType .. "_d.png"
        if not zc.checkFileExist(_file1) then
            _file1 = "res/Main/heroSoul/soulBtn5_u.png"
        end
        if not zc.checkFileExist(_file2) then
            _file2 = "res/Main/heroSoul/soulBtn5_d.png"
        end
        local labColor = cc.c3b(247, 188, 12)
        local _node = zc.createSprite()
        local nor1 = zc.createSprite(_file1)
        nor1:setScale(0.6)
        local _label = zc.createLabel({
            text = LANGUAGE_get_color_text(_shopType) .. zc.lang("light_heroSoul"),
            fontSize = 36,
            color = display.COLOR_YELLOW,
            outLine = true,  
            pixel = 3,
            pos = cc.p(nor1:getContentSize().width*0.5, 10),
        })
        nor1:addChild(_label)
        local se1 = zc.createSprite("res/Main/research/qunxiong/select_down.png")
        local _s = zc.createSprite(_file2)
        _s:setScale(0.6)
        _s:setPosition(se1:getContentSize().width/2, se1:getContentSize().height/2)
        se1:addChild(_s)
        local _label = zc.createLabel({
            text = LANGUAGE_get_color_text(_shopType) .. zc.lang("light_heroSoul"),
            fontSize = 36,
            outLine = true,
            pixel = 3,  
            pos = cc.p(nor1:getContentSize().width*0.5, 10),
        })
        _s:addChild(_label)

        local tabBtn = zc.createPushButton({
            normalNode = nor1,
            selectedNode = se1,
            pos = cc.p(subTabSize.width/2, innerHeight-75-(i-1)*130),
            anchor = cc.p(0.5, 0.5),
            needEnableWhenMoving = true,
            needSwallow = false,
            endCallback = function() end,
        })
        tabBtn:setTag(i)
        myscrollview:addChild(tabBtn)

        tabBtn:setTouchEndedCall(function()
            self:changeSubTab(tabBtn)
        end)
        if i == 1 then
            self:changeSubTab(tabBtn)
        end
        self._subTab[i] = tabBtn
    end
end

function HeroSoulShopLayer:changeSubTab(_node) --切换二级tab
    local _tag = _node:getTag()

    local function getNormal(_tag)
        local scaleSize = cc.size(136, 136)
        local _normal = zc.getScaleNode("res/Main/common/img_empty.png", scaleSize)
        local _n = zc.createSprite("res/Main/pub/cardExtract/card_u_1.png")
        _n:setScale(0.6)
        _n:setPosition(cc.p(_normal:getContentSize().width/2, _normal:getContentSize().height/2))
        _normal:addChild(_n)
        return _normal
    end
    local function getSelected(_tag)
        local se1 = zc.createSprite("res/Main/research/qunxiong/select_down.png")
        local _s = zc.createSprite("res/Main/pub/cardExtract/card_d_1.png")
        _s:setScale(0.6)
        _s:setPosition(cc.p(se1:getContentSize().width/2, se1:getContentSize().height/2))
        se1:addChild(_s)
        return se1
    end

    if not self._selectedSubBtn or self._selectedSubBtn ~= _node then
        if not self._selectedSubBtn then
            self._selectedSubBtn = _node
            -- self._selectedSubBtn:setStateNormal(getSelected(_tag))
            self._selectedSubBtn:setEnable(false)
            self._selectedSubBtn:setSelected(true)
            self._selectedSubBtn:setLocalZOrder(1)
        else
            self._selectedSubBtn:setEnable(true)
            self._selectedSubBtn:setSelected(false)
            -- self._selectedSubBtn:setStateNormal(getNormal(self._subTag))
            self._selectedSubBtn:setLocalZOrder(0)
            self._selectedSubBtn = _node
            -- self._selectedSubBtn:setStateNormal(getSelected(_tag))
            self._selectedSubBtn:setLocalZOrder(1)
            self._selectedSubBtn:setEnable(false)
            self._selectedSubBtn:setSelected(true)
        end
        self._subTag = _tag -- 1同符合约 2势如破竹 3三国无双

        self._exchangeData = self._pictureList[_tag] or {}
        self:refreshTableInfo()
    end
end

function HeroSoulShopLayer:refreshTableInfo()
	if self._mytable then
        self._mytable:reloadData()
        return
    end

    local dhBg = self._duihuan
    local dhSize = cc.size(807, 467)
    self._itemsOfLine = 4
    local tableSize = cc.size(dhSize.width - 30, dhSize.height - 2)
    
    local myTable = zc.ZCTableView:create(tableSize)
    myTable:setPosition(175, 1)
    myTable:setInertia(true) --设置惯性
    myTable:setBounceable(true)
    myTable:setDirection(zctech.SCROLLVIEW_DIRECTION_VERTICAL) --设置横向纵向
    myTable:setDelegate()
    myTable:setVerticalFillOrder(zctech.TABLEVIEW_FILL_TOPDOWN)
    
    self._subTabBg:addChild(myTable)
    self._mytable = myTable

    local function cellSizeForTable(table,idx)
        return 210, tableSize.width
    end
    local function numberOfCellsInTableView(table)
        return math.floor((#self._exchangeData-1)/self._itemsOfLine)+1 --需要的行数
    end
    local function tableCellAtIndex(table,idx)
        local nowIdx = idx + 1
        local cell = table:dequeueCell()
        if cell == nil then
            cell = zc.ZCTableViewCell:new()
            cell:setContentSize(cc.size(tableSize.width, 185))
            self:createDuihuanCell(cell, nowIdx)
        end
        self:updateDuihuanCell(cell, nowIdx)
        return cell
    end
    myTable:registerScriptHandler(numberOfCellsInTableView,cc.NUMBER_OF_CELLS_IN_TABLEVIEW)
    myTable:registerScriptHandler(cellSizeForTable,cc.TABLECELL_SIZE_FOR_INDEX)
    myTable:registerScriptHandler(tableCellAtIndex,cc.TABLECELL_SIZE_AT_INDEX)
    myTable:reloadData()
end

function HeroSoulShopLayer:createDuihuanCell(cell, nowIdx)
    local cellSize = cell:getContentSize()
    local distance = (cellSize.width - 190)/(self._itemsOfLine - 1) - 1.5
    local cellImgSize
    for i = 1, self._itemsOfLine do
        local posX = 190/2 + (i - 1)*distance
        local posY = cellSize.height/2 + 8
        local cell_img = zc.createSprite("res/Main/pub/manual/preview_cellBg_orange.png")
        cell_img:setPosition(posX, posY)
        cell:addChild(cell_img)
        cell["_cell_img"..i] = cell_img

        cellImgSize = cell_img:getContentSize()

        local head, heroInfo= zc.createIconByData({
            data = {
                mainType = zc.mainTypeHeroSoul,
                type = 1, 
                id = 1,
            }, 
            pos = cc.p(cellImgSize.width*0.5, 115),
        })
        head:setScale(0.6)
        cell_img:addChild(head)
        cell["_head"..i] = head

        local nameBg = zc.getScaleNode("res/Main/role/trinket/attrDi.png", cc.size(107, 27))
        nameBg:setAnchorPoint(0.5, 1)
        nameBg:setPosition(cellImgSize.width*0.5, cellImgSize.height - 11)
        cell_img:addChild(nameBg)

        local heroName = zc.createLabel({
            fontSize = 18,
            pos = cc.p(nameBg:getContentSize().width*0.5, nameBg:getContentSize().height*0.5),
        })
        nameBg:addChild(heroName)
        cell["_heroName"..i] = heroName

        local _normal = zc.createSprite("res/Main/common/button/btn_sec_u.png")
        local _select = zc.createSprite("res/Main/common/button/btn_sec_d.png")
        _select:setScale(120/184)
        _normal:setScale(120/184)
        local exchangeBtn = zc.createPushButton({
            normalNode = _normal,
            selectedNode = _select,
            needSwallow = false,
            needEnableWhenMoving = true,
            pos = cc.p(cellImgSize.width*0.5, 38),
            endCallback = function() end,
        })
        cell_img:addChild(exchangeBtn)
        cell["_exchangeBtn"..i] = exchangeBtn
        local consume = zc.createSprite(zc.getImgByType(zc.dataLightSoul))
        consume:setPosition(25, exchangeBtn:getContentSize().height*0.5)
        exchangeBtn:addChild(consume)
        local consumeNum = zc.createLabel({
            text = "",
            outLine = true,
            fontSize = 18,
            ap = cc.p(0, 0.5),
            pos = cc.p(consume:getPositionX() + consume:getContentSize().width*0.5,  consume:getPositionY()),
        })
        exchangeBtn:addChild(consumeNum)
        exchangeBtn["consume"] = consume
        exchangeBtn["consumeNum"] = consumeNum
    end
end

function HeroSoulShopLayer:updateDuihuanCell(cell, nowIdx)
    local cellSize = cell:getContentSize()
    local distance = (cellSize.width - 156)/(self._itemsOfLine - 1) - 1.5
    local cell_img = cell._cell_img
    for i = 1, self._itemsOfLine do
        local cell_img = cell["_cell_img"..i]
        local head = cell["_head"..i]
        local heroName = cell["_heroName"..i]
        local exchangeBtn = cell["_exchangeBtn"..i]
        local consumeNum = exchangeBtn["consumeNum"]
        local dataId = (nowIdx-1)*self._itemsOfLine+i
        local heroData = self._exchangeData[dataId]
        if heroData then
            cell_img:setVisible(true)
            local newParmas = {
                data = {
                    mainType = zc.mainTypeHeroSoul,
                    type = 1, 
                    id = heroData.itemId,
                }
            }
            local heroInfo = zc.updateIconByData(head, newParmas)
            head:setTouchEndedShowTip()
            heroName:setText(heroInfo.name or "???")
            heroName:setColor(zc.nameColor(zc.getQualityByQualifications(heroInfo.quality)))
            local _cost = tonumber(heroData.data.price) or 0
            consumeNum:setText(_cost)
            exchangeBtn:setTouchEndedCall(function()
            	local _num = zc.getNumByTypeId(zc.mainTypeResource, zc.dataLightSoul)
            	if _num < _cost then
            		zc.tipInfo(LANGUAGE_getReousrceNameById(zc.dataLightSoul) .. zc.lang("un_enough") .. "!")
            		return
            	end
                local comfirm = ZCConfirmDialog:createWithParams({
                    title = zc.lang("prompt"),
                    msg = zc.lang("tip_exchange_herosoul_ask"),
                    rightCallback = function()
                            local _nums = table.nums(PlayerData:getHeroSoul())
                            if _nums + 1 > 200 then
                            local comfirm = ZCConfirmDialog:createWithParams({
                                title = zc.lang("prompt"),
                                msg = zc.lang("tip_soulbag_is_full_to_tidy"),
                                rightText = zc.lang("qianwang"),
                                rightCallback = function()
                                    zc.createHeroSoul()
                                end
                            })
                            self:addChild(comfirm, 11)
                            return
                        end
                        zc.sendHttp({
					        apiName = "HeroSoul_buy",
					        params = {id = heroData.id},
					        successCallback = function (net_data)
					            PlayerData:updataData(net_data)
                                zc.createShowReward(net_data)
					        end,
					    })
                    end
                })
                self:addChild(comfirm, 11)
            end)
        else
        	cell_img:setVisible(false)
        end
    end
end

return HeroSoulShopLayer