--[[
    FileName: LevyRewardPop.lua
    Author: andong
    Date: 2016-05-19
    Purpose: 征收宝箱奖励弹窗
]]
local LevyRewardPop = class( "LevyRewardPop", function ()
    return ZCPopLayer:create()
end)
function LevyRewardPop:create(params)
    return LevyRewardPop.new(params)
end
function LevyRewardPop:ctor(params)
    -- dump(params, "params=====")
    self:initData(params)
    self:initUI()
    self:show()
end
function LevyRewardPop:initData(params)
    self._callback = params.callback
    self._params = params.info
    self._rewardData = self._params.award
    self._house = PlayerData:getHouseInfoByHouseId( 16 )
    -- dump(self._house, "self._house  ======== ")

end
function LevyRewardPop:initUI()
    --local popSize = cc.size(500, 300)
    --local popBg = ccui.Scale9Sprite:create(cc.rect(50,50,1,1), "res/Main/common/common_inner5.png")
    --popBg:setContentSize(popSize)
    local popBg = cc.Sprite:create("res/Main/wushenTower/pop_reward.png")
    popBg:setPosition(zc.width/2, zc.height/2)
    self:addContent(popBg)
    self._popBg = popBg
    local close = zc.createBackButton({
        pos = cc.p(popBg:getContentSize().width-10, popBg:getContentSize().height-10),
        listener = function () 
            self:hide()
        end,
    })
    popBg:addChild(close)

    self:createTableView()

    local getBtn = zc.createCommomBtn({
        tag =1,
        btnText = "",
        needSwallow = false,
        endCallback = function()
        end,
        anchor = cc.p(0.5, 0.5),
        pos = cc.p(popBg:getContentSize().width/2, 65)
    })
    popBg:addChild(getBtn)

    local btnText = ""
    local btnColor = display.COLOR_DEEPGRAY
    local btnState = 1
    if self._params.status == 2 then
        getBtn:setEnable(false)
        getBtn:setText(LANGUAGE_TOLLGATEHERO.fetched)
    elseif self._params.status == 0 then
        getBtn:setEnable(false)
        getBtn:setText(zc.lang("un_finish"))
    else
        getBtn:setText(LANGUAGE_TOLLGATEHERO.can_fetch)
        btnState = 2
    end

    local btnLab = zc.createLabel({
        text = btnText,
        stroke = true,
        fontSize = 24,
        pos = cc.p(getBtn:getContentSize().width/2, getBtn:getContentSize().height/2),
        color = btnColor,
        color2 = display.COLOR_BLACK,
        align = kCCTextAlignmentCenter,
        pixel = 1.3
    })
    getBtn:addChild(btnLab, 1)
    

    getBtn:setTouchEndedCall(function()
        if self._params.status == 2 then
            zc.tipInfo(LANGUAGE_TOLLGATEHERO.fetched .. "!")
        elseif self._params.status == 0 then
            zc.tipInfo(zc.lang("un_finish"))
        else
            zc.sendHttp({
                apiName = "Levy_getRwards",
                params = {id=self._params.id}, 
                successCallback = function(net_data)
                    if self._callback then
                        self._callback(net_data)
                    end
                    self._params.status = 2 
                    getBtn:setEnable(false)
                    getBtn:setText(LANGUAGE_TOLLGATEHERO.fetched)
                end,
            })
        end

    end)

end
function LevyRewardPop:createTableView()
    local tableSize = cc.size(435, 200)
    local tableNode = self._popBg
    local myTableBg = ccui.Scale9Sprite:create(cc.rect(26,25,1,1), "res/Main/wushenTower/pop_tableBg.png")
    myTableBg:setContentSize(tableSize)
    myTableBg:setAnchorPoint(cc.p(0.5, 0.5))
    myTableBg:setPosition(cc.p(tableNode:getContentSize().width/2, tableNode:getContentSize().height/2 + 20))
    tableNode:addChild(myTableBg)
    local myTable = zc.ZCTableView:create(cc.size(myTableBg:getContentSize().width-4,myTableBg:getContentSize().height-4))
    myTable:setPosition(2,2)
    myTable:setInertia(true) --设置惯性
    myTable:setBounceable(true)
    myTable:setDirection(zctech.SCROLLVIEW_DIRECTION_VERTICAL) --设置横向纵向
    myTable:setDelegate()
    myTable:setVerticalFillOrder(zctech.TABLEVIEW_FILL_TOPDOWN)
    
    myTableBg:addChild(myTable)
    
    local function cellSizeForTable(table,idx)
        return 92, tableSize.width-4
    end
    local function numberOfCellsInTableView(table)
        return #self._rewardData
    end
    local function tableCellAtIndex(table,idx)
        local nowIdx = idx + 1
        local cell = table:dequeueCell()
        if cell == nil then
            cell = zc.ZCTableViewCell:new()
            cell:setContentSize(cc.size(tableSize.width-4, 92))
        else
            cell:removeAllChildren()
        end
        self:updateCell(cell, nowIdx)
        return cell
    end
    myTable:registerScriptHandler(numberOfCellsInTableView,cc.NUMBER_OF_CELLS_IN_TABLEVIEW)
    myTable:registerScriptHandler(cellSizeForTable,cc.TABLECELL_SIZE_FOR_INDEX)
    myTable:registerScriptHandler(tableCellAtIndex,cc.TABLECELL_SIZE_AT_INDEX)
    
    myTable:reloadData()
end

function LevyRewardPop:updateCell(cell, indx)
    local cellData = self._rewardData[indx]
    -- dump(cellData, "cellData =================== ")
    local cellImg = cc.Sprite:create("res/Main/wushenTower/pop_cell_img.png")
    cellImg:setAnchorPoint(0.5, 0.5)
    cellImg:setPosition(cell:getContentSize().width/2, cell:getContentSize().height/2)
    cell:addChild(cellImg)
    local cellSize = cellImg:getContentSize()
    
    local name = zc.createLabel({
        text = zc.lang("reward") .. " "..indx,
        outLine = true,
        fontSize = 30,
        ap = cc.p(0.5, 0.5),
        pos = cc.p(100, cellSize.height/2 + 20),
        -- pixel = 1.3
    })
    cellImg:addChild(name)
    local desc = zc.createLabel({
        text = cellData.desc,
        outLine = true,
        fontSize = 20,
        ap = cc.p(0.5, 0.5),
        pos = cc.p(100, cellSize.height/2 - 20),
        color = display.COLOR_BTNFONTYELLOW,
        -- pixel = 1.3
    })
    cellImg:addChild(desc)

    local reward = string.split(cellData.items, "|")

    -- dump(reward, "reward ====")
    local item, info = zc.createIconByData({
        data = {
            mainType = reward[1],
            type = reward[2], 
            id = reward[2],
            num = indx == 1 and tonumber(self._house["level"])*reward[3] or reward[3],
        }, 
        showDetailPop = true,
        pos = cc.p(280, cellSize.height/2), 
        color = iconcolor
    })
    item:setScale(0.65)
    cellImg:addChild(item)

end


return LevyRewardPop