local MainCityTargetLayer = class("MainCityTargetLayer", function(params)
	return zc.createNormalDialog({
		showBack = true,
		showFlower = true
	})
end)
--更新乱加的修改。

function MainCityTargetLayer:create( params )
	return MainCityTargetLayer.new( params )
end

function MainCityTargetLayer:ctor( params )
	self._size = self:getContentSize()
	self._leftSize = cc.size( 208, 453 )
    self._rightSize = cc.size( 626, 453 )
end

function MainCityTargetLayer:onEnter( ... )
	self.taskData = {}
    self.taskRewardData = {}
	zc.sendHttp({
		apiName = "Target_Activity_Main",
		successCallback = function( net_data )
			dump(net_data,"net_data")
			self.task_status = net_data.status
			self.taskGroupId = tonumber(net_data.taskIds.taskId)
			self.taskId = net_data.taskIds.rate
			--  2 绿色，3 蓝色
			self:freshData()
			self:initData()
			self:initUI()
			self:initRight()
			self:initReward()
		end
	})
end

function MainCityTargetLayer:freshData()
	for k,v in pairs(self.taskId) do
		local target_tableData = gameData.getDataFromCacheWithPrimaryKey("target_table",tonumber(k))
		table.insert(self.taskData,target_tableData)
		if target_tableData.reward ~= "" then
			local data = string.split(target_tableData.reward,",")
			if data then
				for i,n in pairs(data) do
					table.insert(self.taskRewardData,n)
				end
			end
		end
	end
	-- dump(self.taskRewardData)
end

function MainCityTargetLayer:initData()
	local _upMatrix = {}
    for i, v in pairs( PlayerData:getFormationsInfo()) do
        if ( tonumber( v.status ) or 0 ) == 1 then
            for j = 1, 9 do
                _upMatrix[tonumber( v["location"..j])] = true
            end
        end
    end
    self._upMatrix = _upMatrix

    --武将列表
    self._heroList = {}
    local _heroList = PlayerData:getGeneralInfo()
    local _mainHeroData = {}
    for i, v in ipairs( _heroList ) do
	    if tonumber(v.id) == tonumber(PlayerData.info.heroId) then
	        _mainHeroData = v
	    else
	    	table.insert(self._heroList,v)
	    end
    end
    table.sort(self._heroList, function( a, b )
    	local idA = tonumber(a.id)
        local idB = tonumber(b.id)
        if _upMatrix[idA] ~= _upMatrix[idB] then
            return  _upMatrix[idA]
    	end
		local _canComposeA = tonumber(a.canCompose) or 0
		local _canComposeB = tonumber(b.canCompose) or 0
		if _canComposeA ~= _canComposeB then
			return _canComposeA > _canComposeB
		end
		if _canComposeA == 1 then
			local _dbA = a.db or {}
			local _dbB = b.db or {}
			local _qualificationsA = tonumber(_dbA.qualifications) or 0
			local _qualificationsB = tonumber(_dbB.qualifications) or 0
			if _qualificationsA ~= _qualificationsB then
				return _qualificationsA > _qualificationsB
			end
			local _idA = tonumber( _dbA.id ) or 0
			local _idB = tonumber( _dbB.id ) or 0
			return _idA < _idB
		end
    	return tonumber( a.fighting ) > tonumber( b.fighting )
    end)
    table.insert(self._heroList, 1, _mainHeroData)
end

function MainCityTargetLayer:initUI()
    -- 背景
    local bg = cc.Sprite:create()
    bg:setContentSize( 885, 527 )
    bg:setPosition( self._size.width/2, self._size.height/2 )
    self:addChild( bg )
    self._bg = bg
    self._bgSize = bg:getContentSize()
    -- local bgSp = cc.Sprite:create( "res/Main/common/popBg/bg1.jpg" )
    local bgSp = ccui.Scale9Sprite:create( cc.rect( 13, 60, 9, 62 ), "res/Main/common/popBg/bg1.jpg" )
    bgSp:setAnchorPoint( 0.5, 0 )
    bgSp:setContentSize(self._rightSize.width + 50, self._leftSize.height + 30 )
    bgSp:setPosition( self._bgSize.width/2 + self._leftSize.width/2 - 5, 6 )
    bg:addChild( bgSp )
    -- title
    local titleBg = zc.createSprite("res/Main/target/target.png")
    titleBg:setPosition(cc.p(self._leftSize.width - 100,self._leftSize.height *1.15))
    bg:addChild(titleBg,5)

    -- 框
    local frame_1 = ccui.Scale9Sprite:create( cc.rect( 13, 60, 9, 62 ), "res/Main/common/frame_s.png" )
    frame_1:setContentSize( self._leftSize.width - 5, self._leftSize.height + 30 )
    frame_1:setPosition( self._leftSize.width/2 + 10, self._leftSize.height/2 + 12 )
    bg:addChild( frame_1 , 1)
    -- top
    local top = cc.Sprite:create( "res/Main/common/popBg/titleBg2.jpg" )
    top:setAnchorPoint( 0.5, 1 )
    top:setPosition( self._bgSize.width/2 + 4, self._bgSize.height - 7 )
    bg:addChild( top , 1)
    -- 黑底
    local black = ccui.Scale9Sprite:create( cc.rect( 13, 60, 9, 62 ), "res/Main/common/popBg/di_4.png" )
    black:setContentSize(self._rightSize.width + 15,self._rightSize.height - 20)
    black:setPosition(self._rightSize.width/2 + self._leftSize.width + 22,self._rightSize.height/2 + 20)
    bg:addChild(black)
    -- 右边的底
    local di = ccui.Scale9Sprite:create( cc.rect( 20, 17, 9, 62 ), "res/Main/role/trinket/sellDi.png" )
    di:setContentSize(self._rightSize.width + 37,105)
    di:setPosition(black:getPositionX() - 1,62)
    bg:addChild(di)
    self.di = di
  	-- 框
    local frame_2 = ccui.Scale9Sprite:create( cc.rect( 13, 60, 9, 62 ), "res/Main/common/frame_s.png" )
    frame_2:setContentSize( self._bgSize.width - 14	, self._bgSize.height)
    frame_2:setPosition( self._bgSize.width/2 + 5, self._bgSize.height/2 -1 )
    bg:addChild( frame_2 , 1)

    -- side
    local side_b = zc.getScaleNode( "res/Main/common/popBg/shadow_b.png", cc.size( self._bgSize.width + 6, 31 ) )
    side_b:setAnchorPoint( 0, 1 )
    side_b:setPosition( -6, 11 )
    bg:addChild( side_b )
    local side_r = zc.getScaleNode( "res/Main/common/popBg/shadow_r.png", cc.size( 32, self._bgSize.height + 21 ) )
    side_r:setAnchorPoint( 0, 1 )
    side_r:setPosition( self._bgSize.width - 14, self._bgSize.height + 1)
    bg:addChild( side_r )

    -- leftbg
    local leftbg = cc.Sprite:create( "res/Main/matrix/matrix_generalbg.png" )
	leftbg:setAnchorPoint( 0, 0 )
	leftbg:setPosition( 5, 14 )
	self._bg:addChild( leftbg )

    self:initLeft()
end

function MainCityTargetLayer:initLeft()
	local tableSize = cc.size(190,442)
    local tableView = zc.ZCTableView:create(tableSize)
    tableView:setDirection( cc.SCROLLVIEW_DIRECTION_VERTICAL )
    tableView:setPosition(15, 14 )
    tableView:setDelegate()
    tableView:setVerticalFillOrder(cc.TABLEVIEW_FILL_TOPDOWN) --kTableViewFillBottomUp  kTableViewFillTopDown
    local _cellWidth = 200
    local _cellHeight = 90
    -- dump(self._data)
    local function cellSizeForTable(table, cellIndex) 
        return _cellHeight, _cellWidth
    end
    local function tableCellAtIndex(table, cellIndex) 
        local cell = table:dequeueCell()
        -- 创建模板
        if cell == nil then
            cell = zc.ZCTableViewCell:new()
            self:buildCell(cell,cellIndex + 1)
        end
        -- 更新界面
        -- print("cellIndex.       ",cellIndex)
        self:updateCell(cell, cellIndex + 1,table)

        return cell
    end
    local _num = math.floor((#self._heroList+1)/2)
    local function numberOfCellsInTableView()
        return _num
    end
    tableView:registerScriptHandler(cellSizeForTable, cc.TABLECELL_SIZE_FOR_INDEX)
    tableView:registerScriptHandler(tableCellAtIndex, cc.TABLECELL_SIZE_AT_INDEX)
    tableView:registerScriptHandler(numberOfCellsInTableView, cc.NUMBER_OF_CELLS_IN_TABLEVIEW)
    self._bg:addChild( tableView )
    tableView:reloadData()

    self._tableView = tableView
end

function MainCityTargetLayer:buildCell(cell, cellIndex)
    cell._itemArray  ={}
    for i=1,2 do 
        local newIndex = (cellIndex-1)*2+i
        cell._itemArray[i] = {}
        local item = zc.createIconByData({
            data = {
                mainType = zc.mainTypeSoldier,
                type = 1, 
                id = 1,
                quality = 1,
                num = 1,
                level = 1,
            }, 
            showLevel = true,
            pos = cc.p(5 + (i-1+1/2) * 92, 50), 
            listener = function ()  end
        })
        item:setScale(0.65)
        cell:addChild(item)
        cell._itemArray[i].item = item
        --是否上阵
        local isup = zc.createSprite("res/Main/role/role_zhen.png")
        isup:setAnchorPoint(1, 0)
        isup:setPosition(item:getContentSize().width+5, 3)
        isup:setScale(1.4)
        item:addChild(isup)
        cell._itemArray[i].isup = isup
    end
end

function MainCityTargetLayer:updateCell(cell, cellIndex)
    for i=1,2 do 
        local newIndex = (cellIndex-1)*2+i
        -- dump(self._heroList[newIndex],"self._heroList[newIndex]")
        if #self._heroList >= newIndex then
            cell._itemArray[i].item:setVisible(true) 
            cell._itemArray[i].item:setTouchEnabled(true)
            local newParams = {
                data = {
                    mainType = zc.mainTypeSoldier,
                    type = 1, 
                    id = self._heroList[newIndex].heroId,
                    level = zc.getLevelTipShow()..self._heroList[newIndex].level,
                    reincarnate = self._heroList[newIndex]["reincarnate"]
                },
                quality = self._heroList[newIndex].quality,
                showLevel = true,
                listener = function ()
                    -- self:_upMatrixFunc(newIndex)
                end
            }
            zc.updateIconByData(cell._itemArray[i].item, newParams )
            if self._upMatrix[tonumber(self._heroList[newIndex].id)] then 
                cell._itemArray[i].isup:setVisible(true) 
            else
                cell._itemArray[i].isup:setVisible(false) 
            end
        else
            cell._itemArray[i].item:setVisible(false) 
            cell._itemArray[i].item:setTouchEnabled(false)
        end
    end
end

function MainCityTargetLayer:initRight()
	local tableSize = cc.size(641,334)
    local tableView = zc.ZCTableView:create(tableSize)
    tableView:setDirection( cc.SCROLLVIEW_DIRECTION_VERTICAL )
    tableView:setPosition(self._leftSize.width + 20, 123 )
    tableView:setDelegate()
    tableView:setVerticalFillOrder(cc.TABLEVIEW_FILL_TOPDOWN) --kTableViewFillBottomUp  kTableViewFillTopDown
    local _cellWidth = 615
    local _cellHeight = 112
    -- dump(self._data)
    local function cellSizeForTable(table, cellIndex) 
        return _cellHeight, _cellWidth
    end
    local function tableCellAtIndex(table, cellIndex) 
        local cell = table:dequeueCell()
        -- 创建模板
        if cell == nil then
            cell = zc.ZCTableViewCell:new()
            self:buildRightCell(cell,cellIndex + 1)
        end
        self:updateRightCell(cell, cellIndex + 1,table)
        return cell
    end
    local _num = #self.taskData
    local function numberOfCellsInTableView()
        return _num
    end
    tableView:registerScriptHandler(cellSizeForTable, cc.TABLECELL_SIZE_FOR_INDEX)
    tableView:registerScriptHandler(tableCellAtIndex, cc.TABLECELL_SIZE_AT_INDEX)
    tableView:registerScriptHandler(numberOfCellsInTableView, cc.NUMBER_OF_CELLS_IN_TABLEVIEW)
    self._bg:addChild( tableView )
    tableView:reloadData()

    self.right_tableView = tableView
end

function MainCityTargetLayer:buildRightCell( cell,cellIndex )
	-- bg
	local bg = ccui.Scale9Sprite:create(cc.rect(25, 25, 2, 10),"res/Main/grabFood/cellDi.png")
	bg:setContentSize(615,100)
	bg:setPosition( 615/2 + 8,112/2)
	cell:addChild( bg )
	local bgSize = bg:getContentSize()
	cell._bg = bg
	-- hua
	local y = 70
	local _baseAttrTitleLeft = cc.Sprite:create( "res/Main/common/lace.png" )
    _baseAttrTitleLeft:setAnchorPoint( 1, 0.5 )
    _baseAttrTitleLeft:setPosition(170,y )
    bg:addChild( _baseAttrTitleLeft )
    local _baseAttrTitleRight = cc.Sprite:create( "res/Main/common/lace.png" )
    _baseAttrTitleRight:setAnchorPoint( 0, 0.5 )
    _baseAttrTitleRight:setPosition(295, y )
    _baseAttrTitleRight:setFlippedX( true )
    bg:addChild( _baseAttrTitleRight )

    local title = zc.createSprite("res/Main/target/rolelevel.png")
    title:setPosition(_baseAttrTitleLeft:getPositionX() + 60,y)
    bg:addChild(title)
    cell.title = title
    -- desc
    local desc = zc.createLabel({
    	text = "五个任意武将的等级达到",
    	ap = cc.p(0, 0.5 ),
    	pos = ccp(20,30),
    	color = cc.c3b(45,23,12),
    	fontSize = 20,
	})
	bg:addChild(desc)
	cell.desc = desc

	-- limit
	local limit = zc.createLabel({
    	text = "15级",
    	ap = cc.p(0, 0.5 ),
    	pos = ccp(desc:getPositionX() + desc:getContentSize().width + 10,desc:getPositionY()),
    	color = cc.c3b(219,14,23),
    	outLine = true,
    	pixel = 2,
    	fontSize = 24,
	})
	bg:addChild(limit)
	cell.limit = limit

	-- num
	local current_num = zc.createLabel({
    	text = "4/",
    	ap = cc.p(1, 0.5 ),
    	pixel = 2,
    	pos = ccp(382,desc:getPositionY()),
    	color = cc.c3b(219,14,23),
    	outLine = true,
    	fontSize = 24,
	})
	bg:addChild(current_num)
	cell.current_num = current_num
	-- total_num
	local total_num = zc.createLabel({
    	text = "5",
    	pixel = 2,
    	ap = cc.p(1, 0.5 ),
    	pos = ccp(current_num:getPositionX() + current_num:getContentSize().width + 15,desc:getPositionY()),
    	color = cc.c3b(235,182,147),
    	outLine = true,
    	fontSize = 24,
	})
	bg:addChild(total_num)
	cell.total_num = total_num
	-- btn
	local btn = zc.createCommomBtn({
		tag = 2,
		text = zc.lang("qianwang_2"),
		pos = cc.p(612 - 81,50),
		scale = 0.9,
		endCallback = function() 
			local _data = cell._data
	        -- self:receiveTaskRewards(_data.id)
		end
	})
	bg:addChild(btn)
	cell.btn = btn
	-- yidacheng
	local get = zc.createSprite("res/Main/activity/fightingRank/get.png")
	get:setPosition(btn:getPosition())
	get:setVisible(false)
	bg:addChild(get)
	cell.get = get
end
function MainCityTargetLayer:updateRightCell(cell,cellIndex )
	local data = self.taskData[cellIndex]
	if not data then return end
	local desc = data.desc
	cell.desc:setString(desc)
	local conditions = data.conditions
	local _con_arr = string.split(conditions,"|")
	local img = "res/Main/target/rolelevel.png"
	local type_ = tonumber(_con_arr[1])
	-- dump(data)
	-- dump(_con_arr)
	if type_ == 6 then -- 武将等级
		img = "res/Main/target/rolelevel.png"
	elseif type_ == 78 then -- 突破等级
		img = "res/Main/target/topolevel.png"
	elseif type_ == 74 then -- 装备品质
		img = "res/Main/target/equipqulations.png"
	end
	cell.title:setTexture(img)

	local limit_data = tonumber(_con_arr[2])
	if type_ == 74 then
		if limit_data == 2 then
			local str = LANGUAGE_get_advance_color_text(1)
			cell.limit:setString(str)
			cell.limit:setColor(cc.c3b(219,14,23))
		elseif limit_data == 3 then
			local str = LANGUAGE_get_advance_color_text(2)
			cell.limit:setString(str)
			cell.limit:setColor(cc.c3b(219,14,23))
		else
			cell.limit:setString(_con_arr[2]..zc.lang("level_1"))
			cell.limit:setColor(cc.c3b(219,14,23))
		end
	else
		cell.limit:setString(_con_arr[2]..zc.lang("level_1"))
		cell.limit:setColor(cc.c3b(219,14,23))
	end
	local str = self.taskId[tostring(data.id)] or 0
	cell.current_num:setString(str.."/")
	cell.total_num:setString(_con_arr[3])
	cell.current_num:setPositionX(cell.total_num:getPositionX() - cell.total_num:getContentSize().width + 5)

	cell.limit:setPosition(cell.desc:getPositionX() + cell.desc:getContentSize().width + 3,cell.desc:getPositionY())

	if tonumber(str) < tonumber(_con_arr[3]) then
		cell.current_num:setColor(cc.c3b(255,0,28))
		cell.btn:setVisible(true)
		cell.get:setVisible(false)
	else
		cell.current_num:setColor(cc.c3b(0,255,58))
		cell.btn:setVisible(false)
		cell.get:setVisible(true)
	end
	cell.btn:setTouchEndedCall(function ( ... )
		if type_ == 78 or type_ == 74 then -- 突破等级 -- 装备品质
			zc.createSourceScene("HeroListLayer", "src/layer/role/HeroListLayer.lua")
		elseif type_ == 6 then 
			zc.createDrillFieldLayer()
		end
	end)
end

function MainCityTargetLayer:initReward()
	self.xiaohao_tiao = zc.createSprite("res/Main/target/reward.png")
	self.xiaohao_tiao:setPosition(50,self.di:getContentSize().height/2)
	self.di:addChild(self.xiaohao_tiao)

	local num = #self.taskRewardData
	for i = 1,num do
		local data = self.taskRewardData[i]
		-- print("data....",data)
		if data ~= "" then
			local _tb_ = string.split(data, "|")
			local item_icon = zc.createIconByData({
					 data = {
			            mainType = _tb_[1],
			            type = _tb_[2], 
			            id = _tb_[2],
			        },
			        scale = 0.61,
			        pos = cc.p(self.xiaohao_tiao:getPositionX() + self.xiaohao_tiao:getContentSize().width*1.7 + (i-1)* 85,self.di:getContentSize().height/2)
				})
			item_icon:setTouchEndedShowTip()
			self.di:addChild(item_icon)

			local str = ""..(zc.getWan(_tb_[3]) or 1)
			local label = zc.createLabel({
				text = str,
				fontSize = 28,
				ap = cc.p(1,0.5),
				pos = cc.p(item_icon:getContentSize().width - 5,18),
				scale = 1.5,
				})
			item_icon:addChild(label)
			if tonumber(str) <= 1 then
				label:setVisible(false)
			else
				label:setVisible(true)
			end
		end
	end
	local btn = zc.createCommomBtn({
		tag = 1,
		text = zc.lang("fetch_2"),
		pos = cc.p(self.di:getContentSize().width - 120,self.di:getContentSize().height/2),
		fontSize = 24,
		-- outLine = true,
		scale = 1.1,
		-- pixel = 2,
		endCallback = function() 
			zc.sendHttp({
				apiName = "Target_Activity_Reward",
				successCallback = function( backData )
					dump(backData,"backData")
					backData.noAnimation = true
					PlayerData:updataData(backData)

					PlayerData.targetFromSever = backData.status
					local callback = function ()
						if tolua.isnull(self) then
			                return
			            end
                    	LayerManager.removeLayout()
					end
					backData.callback = callback
					zc.createShowReward(backData)
					self.getRewardBtn:setEnable(false)
				end
			})
		end
	})
	if tonumber(self.task_status) == 1 then
		btn:setEnable(true)
	else
		btn:setEnable(false)
	end
	self.di:addChild(btn)
	self.getRewardBtn = btn
end

return MainCityTargetLayer