--[[
    FileName: RankTitlePop.lua
    Author: andong
    Date: 2016-08-04
    Purpose: 排行称号弹窗
]]
local RankTitlePop = class( "RankTitlePop", function ()
    return ZCPopLayer:create()
end)

function RankTitlePop:create(params)
    return RankTitlePop.new(params)
end

function RankTitlePop:ctor(params)
    self._tag = params.tag
    self._rank = params.rank or 1
    local title = gameData.getDataFromCache("title",{displayPosition=self._tag}) or {}
    self._title = title
    
    local popSize = cc.size(346,212)
    local popBg = zc.getScaleNode("res/Main/common/common_inner17.png", popSize)
    popBg:setAnchorPoint(cc.p(0.5, 0.5))
    popBg:setPosition(cc.p(zc.width/2, zc.height/2))
    self:addContent(popBg)
    local chenghaoImgPath = "res/Main/rankList/rank_"..self._rank..".png"
    local chenghaoImg = zc.createSprite(chenghaoImgPath)
    chenghaoImg:setAnchorPoint(0.5, 0.5)
    chenghaoImg:setPosition(popSize.width/2, popSize.height-55)
    popBg:addChild(chenghaoImg)
    local titleInfo = self._title[self._rank] or {}
    local top3Title = zc.createLabel({
        text = titleInfo["name"] or "",
        stroke = false,
        fontSize = 18,
        pos = cc.p(61, 16),
        color = display.COLOR_GOLD,
    })
    top3Title:setName("top3Title")
    chenghaoImg:addChild(top3Title, 1)
    local tip1 = zc.createLabel({
        text = zc.lang("rank_title_tip1")..self._rank..zc.lang("num_ming"),
        stroke = false,
        fontSize = 18,
        ap = cc.p(0, 0.5),
        pos = cc.p(50, popSize.height/2 - 25),
    })
    popBg:addChild(tip1)
    local tip2 = zc.createLabel({
        text = zc.lang("rank_title_tip2")..self._rank..zc.lang("num_ming"),
        stroke = false,
        fontSize = 18,
        ap = cc.p(0, 0.5),
        pos = cc.p(50, popSize.height/2-60),
    })
    popBg:addChild(tip2)

    self:show()
end

return RankTitlePop