--[[
	武将升星技能信息弹窗
	唐实聪
	2016.4.9
]]
local RoleStarupSkillPop = class("RoleStarupSkillPop", function()
	return ZCPopLayer:create()
end)

function RoleStarupSkillPop:create( params )
	return RoleStarupSkillPop.new( params )
end

function RoleStarupSkillPop:ctor( params )
	self:show()
	self:initData( params )
	self:initUI()
end

function RoleStarupSkillPop:initData( params )
	-- dump( params, "params" )
	self._skillData = params.skillData or {}
	self._size = self:getContentSize()
	self.heroData = params.heroData
	self.skillLevel = self._skillData.skillLevel or 1
	self.list = {}
	self.star = {}
	table.insert(self.list,self._skillData)
	if self.heroData then
		local heroData = gameData.getDataFromCacheWithPrimaryKey("hero",self.heroData.heroId)
		local comBineSkillID2 = tonumber(heroData.combineSkillId2)
		
		if comBineSkillID2 ~= 0  then
			local skillData = gameData.getDataFromCacheWithPrimaryKey("skill",comBineSkillID2)
			local desc_data = string.split( skillData.desc1, "%" )
			local str = ""
			for k,v in pairs(desc_data) do
				local n,m = string.find(v,"|")
		    	if n then
		    		local gongshi = string.split(v,"|")
		    		local func = loadstring("return "..string.gsub(gongshi[2],"lv",self.skillLevel))
		    		local str2 = func()
					str = str..str2.."%"
		    	else
		    		str = str..v
		    	end
			end
	        self._skillData1 = {
	            id = skillData.id,
	            desc = str or "",
	            name = skillData.name or "",
	            starLevel = self.heroData.star + 1,
	            skillLevel = self.skillLevel,
	        }
	        table.insert(self.list,self._skillData1)
		end
	end
	self.aoyiNum = #self.list
end

function RoleStarupSkillPop:initUI()
	-- 背景
	local background 
	if self.aoyiNum > 1 then
		local bg = cc.Sprite:create()
		bg:setContentSize(540,305)
		bg:setPosition( self._size.width/2 + 60 , self._size.height/2 )
		self:addContent(bg)
		background = ccui.Scale9Sprite:create( cc.rect( 15, 15, 70, 70 ), "res/Main/common/common_inner17.png" )
		background:setContentSize( 460, 305 )
		background:setPosition( 560/2 - 60, 305/2 )
		bg:addChild(background)

	else
		background = ccui.Scale9Sprite:create( cc.rect( 15, 15, 70, 70 ), "res/Main/common/common_inner17.png" )
		background:setContentSize( 460, 305 )
		background:setPosition( self._size.width/2, self._size.height/2 )
		self:addContent( background )
	end

	self._bgSize = background:getContentSize()

	local function SetUI(index)
		-- 技能图标
		if self.iconBg == nil then
			self.iconBg = cc.Sprite:create( "res/Main/role/starup/iconBg.png" )
			self.iconBg:setPosition( 90, self._bgSize.height - 80 )
			background:addChild( self.iconBg )
		end
		if self.icon == nil then
			self.icon = zc.createIconByData({
		        data = {
		            mainType=zc.mainTypeSkill,
		            type= self.list[index].id,
		            id=self.list[index].id,
		        },
		    })
			self.icon:setPosition( self.iconBg:getPosition() )
			background:addChild( self.icon )
		else
			zc.updateIconByData(self.icon,{
				data = {
		            mainType=zc.mainTypeSkill,
		            type= self.list[index].id,
		            id=self.list[index].id,
		        },
			})
		end
		-- 技能名字
		if self.skillName == nil then
			self.skillName = zc.createLabel({
				text = self.list[index].name or "",
		        fontSize = 22,
		        ap = cc.p( 0, 0.5 ),
		        pos = cc.p( 170, self._bgSize.height - 60 ),
		        color = display.COLOR_YELLOW,
		        outLine = true,
		        pixel = 2,
			})
			background:addChild(self.skillName )
		else
			self.skillName:setString( self.list[index].name or "")
		end
		-- 解锁
		local unlockText = ""
		if ( tonumber( self.list[index].skillLevel ) or 0 ) == 1 then
			unlockText = LANGUAGE_ROLE.unlock
		else
			unlockText = zc.lang("upgrade")
		end
		if self.unlockLabel == nil then
			self.unlockLabel = zc.createLabel({
				text = unlockText..":",
		        fontSize = 22,
		        ap = cc.p( 0, 0.5 ),
		        pos = cc.p( 170, self._bgSize.height - 100 ),
		        color = zc.COLOR_RED,
		        outLine = true,
		        pixel = 2,
			})
			background:addChild( self.unlockLabel )
		else
			self.unlockLabel:setString(unlockText..":")
		end
		-- 解锁星级
		local starX = 220
		local starY = self._bgSize.height - 100
	    local starNum = tonumber( self.list[index].starLevel or 0 )
	    local starShowNum = ( starNum - 1 )%5 + 1
	    local starSrcData = {
	        "res/Main/common/common_hero_star_2.png",
	        "res/Main/common/common_hero_star_1.png",
	        "res/Main/role/starup/star_blue.png",
	        "res/Main/role/starup/star_purple.png",
	    }
	    local starSrc = starSrcData[math.ceil( starNum/5 ) + 1]
	    if self.starShowNum then
	    	for i = 1, self.starShowNum do
	    		local star = background:getChildByTag(i)
	    		if star then
	    			background:removeChildByTag(i)
	    		end
	    	end
	    end
	    self.starShowNum = starShowNum 
	    for i = 1, starShowNum do
	        local star = cc.Sprite:create( starSrc )
	        star:setPosition( starX + i*30, starY )
	        star:setTag(i)
	        background:addChild( star )
	    end


		-- 分隔线
		if self.split == nil then
			self.split = ccui.Scale9Sprite:create( cc.rect( 0, 0, 1, 2 ), "res/Main/common/spline.png" )
			self.split:setContentSize( self._bgSize.width - 20, 2 )
			self.split:setPosition( self._bgSize.width/2, 150 )
			background:addChild( self.split )
		end

		-- 技能说明背景
		if self.descBg == nil then
			self.descBg = ccui.Scale9Sprite:create( cc.rect( 18, 18, 4, 4 ), "res/Main/common/descDi.png" )
			self.descBg:setContentSize( self._bgSize.width - 35, 115 )
			self.descBg:setPosition( self._bgSize.width/2, 80 )
			background:addChild( self.descBg )
		end

		local _desc = self.list[index].desc or ""
		if string.find( _desc, "|" ) then
			local _strList = string.split( _desc, "|" )
			local _num = ( #_strList - 1 )/2
			for i = 1, _num do
				local _str = string.gsub( _strList[2*i], "lv", self.list[index].skillLevel )
				local _script = "return ".._str
				local _value = loadstring( _script )()
				_strList[2*i] = _value
			end
			_desc = "" 
			for i, v in ipairs( _strList ) do
				_desc = _desc..v
			end
		end
		if self.desc == nil then
			self.desc = zc.createLabel({
		        text = _desc,
		        width = self.descBg:getContentSize().width - 20,
		        fontSize = 20,
		        ap = cc.p( 0.5, 1 ),
		        pos = cc.p( self.descBg:getContentSize().width/2 + 20, self.descBg:getContentSize().height )
		    })
			background:addChild( self.desc )
		else
			self.desc:setString(_desc)
		end
	end
	SetUI(1)
	-- 技能页签 只有在奥义技能大于1时才会有
	if self.aoyiNum > 1 then
		local tagbtns = {}
		local fontcolors = {cc.c3b(225, 213, 147), cc.c3b(140, 35, 35)}
		local function _selectedBtn(index)
			for i=1,self.aoyiNum do
				if i == index then
					tagbtns[i]:setEnable(false)
				else
					tagbtns[i]:setEnable(true)
				end
			end
		end
		for i = 1,self.aoyiNum do
			local personbtn =  zc.createPushButton({
				normalFile = "res/Main/role/btn_unselet.png",
				selectedFile = "res/Main/role/btn_unselet.png",
				disableFile = "res/Main/role/btn_selet.png",
				noScaleAction = true,
				needSwallow = false,
				needEnableWhenMoving = true,
				text = zc.lang("combineSkill_Title")..i,
				fontSize = 24,
				fontColor = fontcolors[1],
				pos = cc.p(self._bgSize.width + 40, self._bgSize.height - (i - 1) * 65 - 50),
				endCallback = function()
					_selectedBtn(i)
					SetUI(i)
				end
			})
			background:addChild(personbtn)
			tagbtns[i] = personbtn
		end
		_selectedBtn(1)
	end
end

return RoleStarupSkillPop