--[[
    商城购买弹窗
    wcc
    2015-11-20
    唐实聪2016.4.5修改
]]
local ShopBuyPop = class("ShopBuyPop",function()
	return ZCPopLayer:create()
end)

function ShopBuyPop:create( params )
    return ShopBuyPop.new( params )
end

function ShopBuyPop:ctor( params )
    self._limit = params.limit
    self._info = params.info
    self._callback = params.callback
    self._clickHide = params.clickHide

    self._size = self:getContentSize()

    -- 背景
    local background = cc.Sprite:create( "res/Main/common/popBg/popup_Bg_blue.png" )
    background:setPosition( self._size.width/2, self._size.height/2 )
    self:addContent( background )
    self._bgSize = background:getContentSize()
    
    local middleBg = zc.getScaleNode("res/Main/common/popBg/di_1.png", cc.size(460, 200))
    middleBg:setPosition( self._bgSize.width/2, self._bgSize.height*0.5 + 30 )
    middleBg:setName("middleBg")
    background:addChild(middleBg)

    local close = zc.createBackButton({
        pos = cc.p( self._bgSize.width - 20, self._bgSize.height - 20), 
        listener = function()
            self:hide()
        end,
    })
    background:addChild( close )
    local title =  zc.getTipPopTitle( "goumai" )
    title:setPosition( self._bgSize.width/2, self._bgSize.height - 30 )
    background:addChild(title)
    --道具
	local icon = zc.createIconByData({
        data = {
            mainType = self._info.itemType,
            type = self._info.itemId, 
            id = self._info.itemId,
            num = self._info.itemNum,
            color = self._info.color,
        }, 
        pos = cc.p( 70, middleBg:getContentSize().height*0.5 ), 
    })
    icon:setScale( 0.8 )
    middleBg:addChild( icon )
    -- 折扣
    if self._info.rebatePrice1 and tonumber( self._info.rebatePrice1 ) > 0 or self._info.rebatePrice2 and tonumber( self._info.rebatePrice2 ) > 0 then
        -- noteBg
        local noteBg = cc.Sprite:create( "res/Main/shop/shop_zk.png" )
        noteBg:setAnchorPoint( 0, 1 )
        noteBg:setPosition( 0, icon:getContentSize().height + 10 )
        icon:addChild( noteBg )
        -- note
        local note = zc.createLabel({
            text = LANGUAGE_SHOP.discount,
            fontSize = 20,
            outLine = true,
            pixel = 2,
            color = display.COLOR_YELLOW,
            ap = cc.p( 0, 0.5 ),
            pos = cc.p( noteBg:getContentSize().width/2 - 30, noteBg:getContentSize().height/2 - 8 ),
        })
        note:setRotation( -45 )
        noteBg:addChild( note )
    end
    local _partW = 30
    local _partH = 100
    -- 名字
    local name = zc.createLabel({
    	text = self._info.name,
    	fontSize = 20,
        ap = cc.p( 0, 0.5 ),
        pos = cc.p( 170 - _partW, 230 - _partH ),
        outLine = true,
        color = display.COLOR_WHITE,
    })
    middleBg:addChild(name)
    -- 当前拥有
    local hastitle = zc.createLabel({
        text = zc.lang("curr_have")..":",
        fontSize = 20,
        ap = cc.p( 0, 0.5 ),
        pos = cc.p( 170 - _partW, 180 - _partH),
        outLine = true,
        color = display.COLOR_WHITE,
    })
    middleBg:addChild( hastitle )
    local desc = ""
    if self._info.itemType and tonumber(self._info.itemType) == zc.mainTypeResource then 
        --资源
    elseif self._info.itemType and tonumber(self._info.itemType) == zc.mainTypeProp then
        --背包
        if self._info.desc and self._info.ownNum then --如果已经传递了数据就不再去重复取
            desc = self._info.desc
        else
            local baginfo = PlayerData:getBagInfoByID(self._info.itemId)
            if baginfo then 
                desc = baginfo.desc
            end
        end
    end

    -- 拥有数量
    local hasNum = zc.createLabel({
        text = zc.getNumByTypeId( self._info.itemType, self._info.itemId ),
        fontSize = 20,
        ap = cc.p( 0, 0.5 ),
        pos = cc.p( 270 - _partW, 180 - _partH),
        outLine = true,
        color = display.COLOR_YELLOW,
    })
    middleBg:addChild( hasNum )
    self._hasNum = hasNum
    -- 商品描述
    local descLabel = zc.createLabel({
        text = desc,
        fontSize = 20,
        ap = cc.p( 0.5, 0.5 ),
        pos = cc.p( middleBg:getContentSize().width*0.5, 123 - _partH),
        color = display.COLOR_BROWN,
    })
    middleBg:addChild(descLabel)
    -- 购买按钮
    local buyBtn = zc.createCommomBtn({
        tag = 1,
        pos = cc.p( self._bgSize.width - 120, 70 ), 
        text = LANGUAGE_SHOP.buy,
        listener = function()
            if self._callback then
                self._callback(function()
                    self._hasNum:setText( zc.getNumByTypeId( self._info.itemType, self._info.itemId ) )
                    if self._clickHide then
                        self:hide()
                    end
                end)
            end
        end
    })
    background:addChild( buyBtn )
    local _buyed = tonumber( self._info.buyed ) or 0
    if self._limit and _buyed > 0 then
        buyBtn:setEnable( false )
    end
    -- 价格
    local consume = {}
    local totalWidth = 0
    for i = 1, 2 do
        if self._info["priceType"..i] and tonumber( self._info["priceType"..i] ) > 0 and self._info["price"..i] and tonumber( self._info["price"..i] ) then
            -- icon
            local consumeIcon = cc.Sprite:create( zc.getImgByType( self._info["priceType"..i] ) )
            consumeIcon:setAnchorPoint( 0, 0.5 )
            consumeIcon:setScale( 0.8 )
            background:addChild( consumeIcon )
            -- num
            local _num = tonumber( self._info["rebatePrice"..i] ) or 0
            if _num == 0 then
                _num = tonumber( self._info["price"..i] ) or 0
            end
            local consumeNum = zc.createLabel({
                text = _num,
                fontSize = 20,
                outLine = true,
                pixel = 1.5,
                ap = cc.p( 0, 0.5 ),
                pos = cc.p( consumeIcon:getContentSize().width + 2, consumeIcon:getContentSize().height/2 ),
            })
            consumeIcon:addChild( consumeNum )

            consume[#consume + 1] = {icon = consumeIcon, posX = totalWidth}
            totalWidth = totalWidth + consumeIcon:getContentSize().width + consumeNum:getContentSize().width + 10
        end
    end
    totalWidth = totalWidth - 10
    local beginX = buyBtn:getPositionX() - totalWidth/2
    for i, v in ipairs( consume ) do
        v.icon:setPosition( beginX + v.posX, 115 )
    end

    --取消按钮
    local cancelBtn = zc.createCommomBtn({
        tag = 2,
        pos = cc.p(120, 70), 
        text = zc.lang("cancel"),
        listener = function () 
            self:hide()
        end,
    })
    background:addChild(cancelBtn)

    self:show()
end

return ShopBuyPop