--[[
    FileName: WushenshilianLayer.lua
    Author: andong
    Date: 2016-03-23
    Purpose: xx界面
]]
local WushenshilianLayer = class( "WushenshilianLayer", function ()
    return ZCDialog:create()
end)
function WushenshilianLayer:create(parmas)
    return WushenshilianLayer.new(parmas)
end
function WushenshilianLayer:ctor(parmas)
    self._btnTitle = zc.lang("sweep")
    if APP_REVIEW then
        self._btnTitle =zc.lang("challenge")
    end
    self._record = {}
    self:initData(parmas)
    self:initUI()
end

function WushenshilianLayer:initData(parmas)
    self._perSweepTime = parmas.sweepTime or 5 --每5秒扫荡一关
    if parmas and parmas.callback then
        self._callback = parmas.callback
    end
    self._parmas = parmas
    self._zhengtaoTime = tonumber(parmas.crusadeTimes) or 0
    self._haveResetTimes = (tonumber(parmas.resetTimes) or 0) - (tonumber(parmas.todayResetTimes) or 0) --剩余重置次数 
    self._rewardRecord = parmas["awardRecord"] or {}
    self:refreshChapterInfo(parmas)
end
--刷新关卡数据
function WushenshilianLayer:refreshChapterInfo(parmas)
    self._maxTollgate = tonumber(parmas["maxTollgate"]) or 0 --最大挑战关卡id
    self._nowTollId = tonumber(parmas["nowTollgate"]) or 0 --已挑战的关卡 1001
    if parmas.tollgateRecord then
        if parmas.tollgateRecord[tostring(self._nowTollId)] and tonumber(parmas.tollgateRecord[tostring(self._nowTollId)]) == 0 then
            self._failerTheBattle = true -- 失败了
        end
    end
    local chaellengeInfo = gameData.getDataFromCacheWithPrimaryKey("arenaTower_npcGroup",  self._nowTollId) or {}
    local chellengedTollId = tonumber(chaellengeInfo["tollgateId"]) or  0 
    self._nowchengeTollId = chellengedTollId + 1 --当前正要挑战的层 (第一关、第二关......)
    if self._failerTheBattle then
        self._failerTheBattle = false --重置失败判断
        self._nowchengeTollId = (self._nowchengeTollId-1) > 1 and (self._nowchengeTollId-1) or 1
    end
    --3关 关卡信息
    self._tollInfoList = {}

    --检查是否通关
    self._passedAll = false
    local subTollNum = 2
    local tollInfo = gameData.getDataFromCacheWithPrimaryKey("arenaTower_tollgate",  self._nowchengeTollId) or {}
    if tollInfo and tollInfo.groupId then
        local groupInfo = gameData.getDataFromCacheWithPrimaryKey("arenaTower_npcGroup",  tollInfo.groupId) or {}
        if groupInfo and groupInfo.id then
        else
            subTollNum = 3
            self._passedAll = true
        end
    else
        subTollNum = 3
        self._passedAll = true
    end

    for i = 1, 3 do
        local tollInfo = gameData.getDataFromCacheWithPrimaryKey("arenaTower_tollgate",  self._nowchengeTollId-subTollNum+i) or {}
        local groupId = tollInfo.groupId or 0 
        local groupInfo = gameData.getDataFromCacheWithPrimaryKey("arenaTower_npcGroup",  groupId) or {}
        if groupInfo.id then
            self._tollInfoList[i] = {}
            if tollInfo and tollInfo["id"] then
                self._tollInfoList[i] = tollInfo
            end
        end
    end
    if parmas.sweepAwardTime and tonumber(parmas.sweepAwardTime) > 0 then
        --正在扫荡
        self._isSweeping = true
        self._sweepTime = tonumber(parmas.sweepAwardTime)
    end
end
function WushenshilianLayer:initUI()
    local background = zc.createSprite("res/Main/wushenTower/bg_img.jpg")
    background:setPosition(cc.p(zc.width/2, zc.height/2))
    self:addChild(background, -1)
    zc.setBgSize(background)
    local close = zc.createTopBackButton({
        pos = cc.p(self:getContentSize().width-60, self:getContentSize().height-40),
        listener = function () 
            if self._guideHand then
                local mainCity = zc.getScene("mainCity")
                if mainCity then
                    mainCity:setFubenHandFlag()
                end
            end
            LayerManager.removeLayout()
        end,
    })
    self._close = close
    self:addChild(close, 11)
    --添加云动画
    zc.getYunDongTai(nil,2,function(armUp, armDown)
        if not tolua.isnull(self) then
            self:addChild( armUp )
            self:addChild( armDown )
        end
    end)
    local title = cc.Sprite:create("res/Main/wushenTower/title.png")
    title:setAnchorPoint(0, 1)
    title:setPosition(1, zc.height)
    self:addChild(title, 1)

    local myScale9 = zc.createSprite()
    myScale9:setContentSize(cc.size(zc.width, 300))
    local touBtn = zc.createPushButton({
        normalNode = myScale9,
        needSwallow = true,
        noScaleAction = true,
        endCallback = function()
        end,
        pos = cc.p(zc.width/2, zc.height/2-20)
    })
    self:addChild(touBtn,1)

    --创建关卡信息
    self:createTollInfo()
    --创建宝箱信息
    self:createTreasureInfo()
    --重置和扫荡
    self:createResetAndSweepBtn()
end
function WushenshilianLayer:createResetAndSweepBtn()
    cc.SpriteFrameCache:getInstance():addSpriteFrames("res/Main/home/homeUI.plist", "res/Main/home/homeUI.pvr.ccz")
    
    local resetSp1 = self:getBtnDi(zc.lang("reset"))
    local resetSp2 = zc.createSprite("res/Main/wushenTower/reset.png")
    resetSp2:setPosition(cc.p(resetSp1:getContentSize().width/2,resetSp1:getContentSize().height/2+12))
    resetSp1:addChild(resetSp2)
    
    local function cantRest()
        zc.setGray(resetSp1,true)
        zc.setGray(resetSp1._namedi,true)
        resetSp1._nameLab:setColor(display.COLOR_DEEPGRAY)
        zc.setGray(resetSp2,true)
    end
    if self._haveResetTimes <= 0 then
        cantRest()
    end

    local function _getRewards( nowTollId )
        local _nowTollId = nowTollId or 1
        local rewardMap = {}
        local totalReward = {}
        local maxChallenge = gameData.getDataFromCacheWithPrimaryKey("arenaTower_npcGroup",  self._maxTollgate) or {}
        local maxChallengeId = tonumber(maxChallenge["tollgateId"]) or  0
            
        --处理奖励
        local function doReward(_reward)
            local rewardTa = string.split(_reward, ",")
            for i = 1, #rewardTa do
                local reward = string.split(rewardTa[i], "|")
                if reward[1] and reward[2] then
                    local itemType = tonumber(reward[1])
                    local itemId = tonumber(reward[2])
                    if not rewardMap[itemType] then
                        rewardMap[itemType] = {}
                    end
                    local typeMap = rewardMap[itemType]
                    if typeMap[itemId] then
                        local idx = typeMap[itemId]
                        totalReward[idx].num = tonumber(totalReward[idx].num) +  tonumber(reward[3])
                    else
                        local idx = #totalReward + 1
                        typeMap[itemId] = idx
                        totalReward[idx] = {}
                        totalReward[idx].itemType = itemType
                        totalReward[idx].itemId = itemId
                        totalReward[idx].type = itemId
                        totalReward[idx].num = tonumber(reward[3])
                    end
                end
            end
        end
        --宝箱奖励
        local arenaTowerBox = gameData.getDataFromCache("arenaTowerBox")
        for k,v in pairs(arenaTowerBox) do
            if v.id and tonumber(v.id) <= tonumber(self._maxTollgate) then
                --如果没有领取
                if not self._rewardRecord[tostring(v.id)] then
                    local boxReward = v.boxReward or ""
                    doReward(boxReward)
                    --随机宝石奖励
                    local gemRewardUi = tonumber(v.gemRewardUi) or 0
                    if gemRewardUi > 0 then
                        doReward("12|"..gemRewardUi.."|1")
                    end
                end
            end
        end

        for i = _nowTollId, maxChallengeId do
            local tollInfo = gameData.getDataFromCacheWithPrimaryKey("arenaTower_tollgate",  i )
            local groupId = tollInfo["groupId"] 
            local groupInfo = gameData.getDataFromCacheWithPrimaryKey("arenaTower_npcGroup",groupId)
            if groupInfo and groupInfo["awards"] then
                doReward(groupInfo["awards"])
                --随机宝石奖励
                local gemRewardUi = tonumber(groupInfo.gemRewardUi) or 0
                if gemRewardUi > 0 then
                    doReward("12|"..gemRewardUi.."|1")
                end
            end
        end
        table.sort(totalReward,function(a,b)
            if tonumber(a.itemType) ~= tonumber(b.itemType) then
                return tonumber(a.itemType) < tonumber(b.itemType)
            else
                return tonumber(a.itemId) < tonumber(b.itemId)
            end
        end)

        return totalReward, maxChallengeId
    end

    local resetBtn = zc.createPushButton({
        normalNode = resetSp1,
        needSwallow = true,
        touchScale = 0.9,
        endCallback = function()
            if self._haveResetTimes <= 0 then
                zc.tipInfo(zc.lang("tips_today_reset_times_over"))
                return
            end
            local function doReset()
                zc.sendHttp({
                    apiName = "Wushenshilian_reset",
                    successCallback = function (net_data)
                        PlayerData:updataData(net_data)
                        self._rewardRecord = net_data["awardRecord"] or {}
                        self:refreshChapterInfo(net_data)
                        for i = 1,#self._tollBgList do
                            local v = self._tollBgList[i]
                            v:removeFromParent()
                        end
                        self:createTollInfo(true)
                        self:refreshTreasure()
                        self._haveResetTimes = self._haveResetTimes - 1
                        if self._haveResetTimes <= 0 then
                            cantRest()
                        end
                    end
                })
            end
            local comfirm = ZCConfirmDialog:createWithParams({
                title = zc.lang("prompt"),
                msg = zc.lang("tips_tostrart_new_challenge"),
                showDi = true,
                rightCallback = function()
                    doReset()
                end,
            })
            self:addChild(comfirm, 11)
        end,
        pos = cc.p(zc.width-60, zc.height/2 + 170)
    })
    self:addChild(resetBtn, 10)
    local resetSp3 = self:getBtnDi(self._btnTitle)
    local resetSp4 = zc.createSprite("res/Main/common/common_icon_zhandou.png")
    resetSp4:setScale(70/143)
    resetSp4:setPosition(cc.p(resetSp3:getContentSize().width/2,resetSp3:getContentSize().height/2+10))
    resetSp3:addChild(resetSp4)
    local sweepBtn = zc.createPushButton({
        normalNode = resetSp3,
        needSwallow = true,
        touchScale = 0.9,
        endCallback = function()
            if self._nowTollId >= self._maxTollgate then
                zc.tipInfo(zc.lang("tips_now_cannot_sweep"))
                return
            end
            local _showLay = ZCDialog:create(200)
            self:addChild(_showLay, 10) 
            
            local touchBtn = zc.createPushButton({
                touchSize = cc.size(10000,10000),
                needSwallow = true,
                pos = cc.p(zc.width/2, zc.height/2),
                endCallback = function() _showLay:removeFromParent() end,
            })
            _showLay:addChild(touchBtn)


            local _showBg = zc.createSprite("res/Main/copy/copy_sweepbg1.png")
            _showBg:setPosition( cc.p(zc.width/2, zc.height/2-50) )
            _showLay:addChild(_showBg)

            local _showTouch = zc.createPushButton({
                touchSize = cc.size(893, 260),
                needSwallow = true,
                anchor = cc.p(0.5, 1),
                pos = cc.p(_showBg:getContentSize().width/2, _showBg:getContentSize().height-20),
            })
            _showTouch:setContentSize( cc.size(893, 260) )
            _showBg:addChild(_showTouch)

            local totalReward, maxChallengeId = _getRewards(self._nowchengeTollId)
            local totalSweepToll = tonumber(maxChallengeId)-tonumber(self._nowchengeTollId) + 1
            local _msg = "[size=24][color=ffffffff]" .. zc.lang("can") .. zc.lang("sweep") .. " [/size][/color][size=28][color=fff8c905]"..totalSweepToll.."[/size][/color][size=24][color=ffffffff] " .. zc.lang("num_guan") .. "[/size][/color]"
            local tipLab = zc.createRichLabel({
                text = _msg,
                pos = cc.p(_showBg:getContentSize().width/2, _showBg:getContentSize().height - 50),
            })
            tipLab:enableStroke(display.COLOR_BLACK, 0.1)
            _showBg:addChild(tipLab, 1)

            local posT = zc.sortFromMiddle(cc.p(_showBg:getContentSize().width/2, 129+105), #totalReward, 94)
            for i = 1, #totalReward do
                local reward = totalReward[i]
                local item, info = zc.createIconByData({
                    data = {
                        mainType = reward.itemType,
                        type = reward.type, 
                        id = reward.itemId,
                        num = tonumber(reward.itemType) == 12 and 1 or reward.num,
                    }, 
                    showDetailPop = true,
                    pos = posT[i],
                })
                item:setScale(80/125)
                _showBg:addChild(item)
            end

            local tip = zc.createLabel({
                text = zc.lang("yuji_time") .. "：",
                outLine = true,
                fontSize = 22,
                ap = cc.p(0, 0.5),
                pos = cc.p(315, 48+95),
            })
            _showBg:addChild(tip)
            local _str = zc.getTimeHMS( totalSweepToll*self._perSweepTime )
            local tipLab = zc.createLabel({
                text = _str,
                outLine = true,
                fontSize = 22,
                ap = cc.p(0, 0.5),
                pos = cc.p(tip:getPositionX()+tip:getContentSize().width, tip:getPositionY()),
                color = display.COLOR_GREEN
            })
            _showBg:addChild(tipLab)

            local sweepBtn = zc.createCommomBtn({
                tag =1,
                btnText = self._btnTitle,
                needSwallow = false,
                anchor = cc.p(0.5, 0.5),
                pos = cc.p(600, tip:getPositionY() ),
                endCallback = function() 
                    zc.sendHttp({
                        apiName = "Wushenshilian_sweep",
                        successCallback = function (net_data)
                            _showLay:removeFromParent()
                            self._isSweeping = true
                            self._sweepTime = net_data.sweepAwardTime
                            self:createSweepInfo()
                        end
                    })
                end,
            })
            _showBg:addChild(sweepBtn)

        end,
        pos = cc.p(zc.width - 60, zc.height/2 + 40)
    })
    self:addChild(sweepBtn, 10)


    --整套
    local resetSp3 = self:getBtnDi(zc.lang("zhengtao"))
    local resetSp4 = zc.createSprite("res/Main/common/common_icon_zhenzhan.png")
    resetSp4:setScale(70/143)
    resetSp4:setPosition(cc.p(resetSp3:getContentSize().width/2,resetSp3:getContentSize().height/2+10))
    resetSp3:addChild(resetSp4)
    local _zhengtao = zc.createPushButton({
        normalNode = resetSp3,
        needSwallow = true,
        touchScale = 0.9,
        endCallback = function()
            -- do zc.tipInfo("功能尚未开放") return end
            if self._maxTollgate == 0 then
                zc.tipInfo(zc.lang("tips_now_cannot_zhengtao"))
                return
            end
            local _rewards = _getRewards()
            local _dropInfo = {}
            for k,v in pairs(_rewards) do
                if v.itemType == 4 and inArray(tonumber(v.itemId), {522, 523, 524, 525, 526, 612, 613}) then
                else
                    table.insert(_dropInfo, v)
                end
            end
            zc.createSourcePop("WushenSweep", "src/layer/wushenshilian/WushenSweepPop.lua", {
                dropInfo = _dropInfo,
                nowTime = self._zhengtaoTime,
                callback = function( time )
                    self._zhengtaoTime = time
                end
            })
        end,
        pos = cc.p(zc.width - 60, zc.height/2 - 90)
    })
    self:addChild(_zhengtao, 10)
    self._zhengtao = _zhengtao

    --jiaose
    local resetSp3 = self:getBtnDi(zc.lang("role"))
    local resetSp4 = zc.createSprite("res/Main/common/common_icon_wujiang.png")
    resetSp4:setScale(70/143)
    resetSp4:setPosition(cc.p(resetSp3:getContentSize().width/2,resetSp3:getContentSize().height/2+10))
    resetSp3:addChild(resetSp4)
    local roleBtn = zc.createPushButton({
        normalNode = resetSp3,
        needSwallow = true,
        touchScale = 0.9,
        endCallback = function()
            --新手引导
            local _currentGID = getGuideManager():getCurrentGID()
            if inArray(_currentGID, GuideGroup.BTN_ROLE)
              or _currentGID == GuideKey.KEY_11401
              then
                zc.setGuideFuncNextStep(_currentGID, false)
            end
            zc.createHeroListLayer()
        end,
        pos = cc.p(zc.width - 60, zc.height/2 - 220)
    })
    self:addChild(roleBtn, 10)
    self._roleBtn = roleBtn

end
function WushenshilianLayer:getBtnDi(_name)
    local _btn = zc.getSprite({src = "bottomDi.png",plist = true,})
    local _namedi = zc.getSprite({
        src = "btnNameDi.png",
        plist = true,
        pos = cc.p(_btn:getContentSize().width*0.5, 10),
    })
    _btn:addChild(_namedi)
    local nameLab = zc.createLabel({
        text = _name,
        outLine = true,
        fontSize = 22,
        pos = cc.p(_namedi:getContentSize().width/2, _namedi:getContentSize().height/2),
    })
    _namedi:addChild(nameLab)
    _btn._namedi = _namedi
    _btn._nameLab = nameLab
    return _btn
end
--创建宝箱信息
function WushenshilianLayer:createTreasureInfo()
    local arenaTowerBox = gameData.getDataFromCache("arenaTowerBox")
    self._treasureInfo = {}
    for k,v in pairs(arenaTowerBox) do
        self._treasureInfo[#self._treasureInfo+1] = v
    end
    table.sort(self._treasureInfo,function(a,b)
        return tonumber(a.id) < tonumber(b.id)
    end)

    local progressBg = zc.createSprite("res/Main/wushenTower/progressbg.png")
    progressBg:setScale(1.1)
    progressBg:setPosition(zc.width*0.5 - 30, 70)
    self:addChild(progressBg)

    local progressBar = cc.ProgressTimer:create(cc.Sprite:create("res/Main/wushenTower/progress.png"))
    progressBar:setType(cc.PROGRESS_TIMER_TYPE_BAR)
    progressBar:setMidpoint(cc.p(0, 1))
    progressBar:setBarChangeRate(cc.p(1, 0))
    progressBar:setAnchorPoint(cc.p(0.5,0.5))
    progressBar:setPosition(cc.p(progressBg:getContentSize().width/2,progressBg:getContentSize().height/2))
    progressBg:addChild(progressBar)
    self._progressBar = progressBar

    self._treasureList = {}
    self._onePart = 5
    self._nowIdx = 0

    for i = 1, 5 do
        local v = self._treasureInfo[self._nowIdx*self._onePart + i]
        local boxBtn = zc.createPushButton({
            touchSize = cc.size(100, 100),
            needSwallow = false,
            touchScale = 0.9,
            needEnableWhenMoving = true,
            endCallback = function()
                local _v = self._treasureInfo[self._nowIdx*self._onePart + i]
                local params = {
                    rewardRecord = self._rewardRecord,
                    info = _v,
                    callback = function(_id)
                        if _id then
                            self._rewardRecord[tostring(_id)] = 1
                            self:refreshTreasure()
                        end
                    end,
                }
                zc.createSourcePop("WushenshilianRewardPop", "src/layer/wushenshilian/WushenshilianRewardPop.lua", params)
            end,
            anchor = cc.p(0.5, 0.5),
            pos =cc.p(100+140*(i-1), 0)
        })
        progressBg:addChild(boxBtn)
        boxBtn:setContentSize(cc.size(100, 100))

        self._treasureList[#self._treasureList+1] = boxBtn

        local armature = zc.createSpine({
            fileName = "missionbox",
            actName = "animation",
            needInit = false,
        })
        armature:setPosition( cc.p(50,50) )
        boxBtn:addChild(armature)
        boxBtn._armature = armature

        local treasureBg = zc.createSprite("res/Main/wushenTower/treasureBg.png")
        treasureBg:setAnchorPoint(0.5, 0.5)
        treasureBg:setPosition(50, 50)
        boxBtn:addChild(treasureBg)

        local nameBg = zc.createSprite("res/Main/wushenTower/tollNameBg.jpg")
        nameBg:setAnchorPoint(0.5, 0.5)
        nameBg:setPosition(80, 80)
        boxBtn:addChild(nameBg)

        local nameLab = zc.createLabel({
            outLine = true,
            fontSize = 20,
            pos = cc.p(nameBg:getContentSize().width/2, nameBg:getContentSize().height/2+10),
        })
        nameBg:addChild(nameLab)
        boxBtn._nameLab = nameLab
        local myLab = zc.createLabel({
            text = zc.lang("num_guan"),
            outLine = true,
            fontSize = 20,
            pos = cc.p(nameLab:getPositionX(), nameLab:getPositionY()-23),
        })
        nameBg:addChild(myLab)
    end

    for i = 1, #self._treasureInfo do
        local chaellengeInfo = gameData.getDataFromCacheWithPrimaryKey("arenaTower_npcGroup", self._treasureInfo[i]["id"]) or {}
        self._treasureInfo[i]["tollgateId"] = chaellengeInfo.tollgateId or 99999999
    end

    local _leftBtn = zc.createPushButton({
        normalNode = zc.createSprite("res/Main/common/arrow_new.png"),
        pos = cc.p(progressBg:getPositionX() - progressBg:getBoundingBox().width*0.5, progressBg:getPositionY()),
        endCallback = function()
            if self._nowIdx > 0 then
                self._nowIdx = self._nowIdx - 1
                self:refreshTreasure(false)
            end
            self._leftBtn:setVisible(self._nowIdx ~= 0)
            self._rightBtn:setVisible(true)
        end
    })
    self:addChild(_leftBtn)
    self._leftBtn = _leftBtn

    local _node = zc.createSprite("res/Main/common/arrow_new.png")
    _node:setScaleX(-1)
    local _rightBtn = zc.createPushButton({
        normalNode = _node,
        pos = cc.p(progressBg:getPositionX() + progressBg:getBoundingBox().width*0.5 - 10, progressBg:getPositionY()),
        endCallback = function()
            local _max = math.ceil((table.nums(self._treasureInfo) - 1)/self._onePart) - 1
            if self._nowIdx < _max then
                self._nowIdx = self._nowIdx + 1
                self:refreshTreasure(false)
            end
            self._leftBtn:setVisible(true)
            self._rightBtn:setVisible(self._nowIdx ~= _max)
        end
    })
    self:addChild(_rightBtn)
    self._rightBtn = _rightBtn

    self:refreshTreasure()
end
--刷新宝箱
function WushenshilianLayer:refreshTreasure( doFreshNowIdx )
    local _doFreshNowIdx = doFreshNowIdx == nil and true or doFreshNowIdx
    if _doFreshNowIdx then
        local _idx = 0
        local _have0, _tag
        for i = 1, #self._treasureInfo do
            local _info = self._treasureInfo[i]
            local _status = 0 --0没奖励 1有可领取奖励 2已经领取
            if self._rewardRecord[tostring(_info["id"])] then
                _status = 2
            elseif _info["tollgateId"] < self._nowchengeTollId then
                _status = 1 
            end 
            if self._isSweeping and _status ~= 2 then --
                _status = 0
            end
            if _status == 1 then
                _idx = i
                break
            end 
            if _status == 0 and not _have0 then
                _have0 = i
            end
        end
        local _max = math.ceil((table.nums(self._treasureInfo) - 1)/self._onePart) - 1
        if _idx ~= 0 then
            _tag = math.modf((_idx - 1)/self._onePart)
        elseif _have0 then
            _tag = math.modf((_have0 - 1)/self._onePart)
        else    
            _tag = _max
        end
        self._nowIdx = _tag

        self._leftBtn:setVisible(_tag ~= 0)
        self._rightBtn:setVisible(_tag ~= _max)
    end


    local amId = 4
    self._hasRewardGet = false
    for i = 1, #self._treasureList do
        local _info = self._treasureInfo[self._nowIdx*self._onePart + i]
        local boxBtn = self._treasureList[i]
        if _info then
            boxBtn:setVisible(true)
            local armature = boxBtn._armature
            local _status = 0 --0没奖励 1有可领取奖励 2已经领取
            if self._rewardRecord[tostring(_info["id"])] then
                _status = 2
            elseif _info["tollgateId"] < self._nowchengeTollId then
                _status = 1 
            end
            _info["status"] = _status
            if self._isSweeping and _status ~= 2 then --
                _status = 0
            end
            if _status == 0 then
                armature:playAction("box"..(amId).."_lock", true) --没奖励
            elseif _status == 2 then
                armature:playAction("box"..(amId).."_open", true) --已经领取
            elseif _status == 1 then
                armature:playAction("box"..(amId).."_closer", true) --有可领取奖励
            end
            if _status == 1 then
                self._hasRewardGet = true
            end

            local chaellengeInfo = gameData.getDataFromCacheWithPrimaryKey("arenaTower_npcGroup", _info["id"]) or {}
            _info["tollgateId"] = chaellengeInfo.tollgateId or 99999999
            boxBtn._nameLab:setString(_info["tollgateId"])
        else
            boxBtn:setVisible(false)
        end
    end
end

--创建关卡信息
function WushenshilianLayer:createTollInfo(_isReset)
    if not _isReset then
        self._distance = zc.width/3
        self._middleHeiht = zc.height/2-20
        local pos = zc.sortFromMiddle(cc.p(zc.width/2,self._middleHeiht), 3 ,self._distance)
        self._middlePos = pos

        local quan = cc.Sprite:create("res/Main/arena/maleLight.png")
        quan:setPosition(cc.p(zc.width/2, zc.height/2-60))
        self:addChild(quan,2)

        local arrow = cc.Sprite:create("res/Main/wushenTower/arrow.png")
        arrow:setPosition(cc.p(zc.width/2, zc.height/2 + 140))
        self:addChild(arrow,2)
        arrow:setScale(0.8)

        arrow:runAction(cc.RepeatForever:create(cc.Spawn:create(
            cc.Sequence:create(
                cc.MoveBy:create(0.7, cc.p(0, 20)),
                cc.MoveBy:create(0.7, cc.p(0, -20))
            )
        )))
    end

    self._tollBgList = {}
    for i = 1, 3 do
        local v = self._tollInfoList[i]
        local _heroBtn = self:createOneTollgate(self._middlePos[i],v)
        if v and tonumber(v["id"]) == tonumber(self._nowchengeTollId) then
            self._guideHeroBtn = _heroBtn
        end

        if i == 2 then
            if not self._dropBg then
                local dropBg = zc.createSprite()
                dropBg:setAnchorPoint(0.5, 1)
                dropBg:setPosition(_heroBtn:getPositionX(), _heroBtn:getPositionY()-_heroBtn:getContentSize().height/2 + 5)
                self:addChild(dropBg, 10)
                self._dropBg = dropBg

                for i = 1, 2 do
                    local item, info = zc.createIconByData({
                        data = {
                            mainType = 1,
                            type = 2, 
                            id = 2,
                            num = 1,
                        }, 
                        showDetailPop = true,
                        pos = cc.p(68+(i-1)*68, 79/2+2), 
                    })
                    item:setScale(60/125)
                    dropBg:addChild(item)
                    dropBg["item_"..i] = item
                end
            end

            --
            self:refreshDropInfo()

        end
    end
end
--创建一个关卡
function WushenshilianLayer:createOneTollgate(_pos,_info)
    local oneTollBg = zc.createSprite()
    oneTollBg:setContentSize(cc.size(250,200))
    oneTollBg:setAnchorPoint(0.5, 0.5)
    oneTollBg:setPosition(_pos)
    self:addChild(oneTollBg,2)
    --记录
    self._tollBgList[#self._tollBgList+1] = oneTollBg
    if _info and _info["id"] then
        local hero = zc.battle.createHeroArmature({fileName = _info.model , async = true, asyncCallback = function ( _armature )
            if not tolua.isnull(oneTollBg) then
                if _armature then
                    _armature:setOpacity(0)
                    _armature:runAction(cc.Sequence:create(cc.FadeIn:create(0.2),cc.CallFunc:create(function()  
                        _armature:getAnimation():play("idle", -1, 1) 
                    end )))
                end
            end
        end})  
        hero:setPosition( cc.p(250/2, 100-40) )
        oneTollBg:addChild(hero, 1)
        self._record[_info.model] = true
        local scaleSize = cc.size(120, 150)
        local heroBtn = zc.createPushButton({
            touchSize = cc.size( 120, 150 ),
            pos = cc.p(  hero:getPositionX() , hero:getPositionY()+60 ),
            endCallback = function()
                if tonumber(_info["id"]) == tonumber(self._nowchengeTollId) then
                    self:gotoChellenge()
                else
                    if self._passedAll then
                        zc.tipInfo(zc.lang("already_finish_tollgate"))
                    end
                end
            end
        })
        oneTollBg:addChild( heroBtn )
        if tonumber(_info["id"]) < tonumber(self._nowchengeTollId) then
            local killed = zc.createSprite("res/Main/arena/killed.png")
            killed:setPosition(250/2, 125)
            killed:setScale(0.9)
            oneTollBg:addChild(killed, 1)
        end
        --关卡lab
        local nameBg = zc.createSprite("res/Main/wushenTower/tollNameBg2.png") 
        nameBg:setPosition(hero:getPositionX(), hero:getPositionY()-40)
        oneTollBg:addChild(nameBg)
        local chapterLab = zc.createLabel({
            text = zc.lang("num_di") .._info["id"].. zc.lang("num_guan"),
            stroke = true,
            fontSize = 20,
            pos = cc.p(nameBg:getContentSize().width/2, nameBg:getContentSize().height/2),
            color = cc.c3b(220,156,34),
        })
        nameBg:addChild(chapterLab)
    end
    return oneTollBg
end

function WushenshilianLayer:gotoChellenge()
    local _currentGID = getGuideManager():getCurrentGID()
    if _currentGID == GuideKey.KEY_12305 then
        zc.setGuideFuncNextStep(_currentGID)
    end
    local function getNpc(_id)
        return gameData.getDataFromCacheWithPrimaryKey("arenaTower_npc", _id)
    end
    local tollInfo = gameData.getDataFromCacheWithPrimaryKey("arenaTower_tollgate",  self._nowchengeTollId )
    local groupId = tollInfo["groupId"]
    local tollInGroupfo = gameData.getDataFromCacheWithPrimaryKey("arenaTower_npcGroup", groupId )
    local _enemysData = table.copy(tollInGroupfo)
    _enemysData["enemys"] = {}
    for i = 1, 9 do
        local enemyId = tonumber(_enemysData["location"..i])
        if enemyId ~= 0 then 
            _enemysData["enemys"][i] = getNpc(enemyId)
        else
            _enemysData["enemys"][i] = {}
        end
    end
    local _isFirst = 1
    if tonumber(self._nowTollId) < tonumber(self._maxTollgate) then
        _isFirst = 2
    end
    local _dataInfo = {isFirstFight=_isFirst,battleType = BattleType.Wushenshilian, tollgateId = _enemysData["id"], enemys = _enemysData,topinfo = false}
    zc.createMatrixBattle( _dataInfo )
end
function WushenshilianLayer:onCleanup()
    if self._callback and type(self._callback) == "function" then
        self._callback()
    end
    local _forms = PlayerData:getNowFormationFiles()
    for k, v in pairs( self._record ) do
        -- 如果已上阵，不删除
        local _path, _resId = zc.battle.getHeroArmaturePathByResId( k )
        if not _forms[_resId] then
            ccs.ArmatureDataManager:getInstance():removeArmatureFileInfo( _path )
        end
    end
    helper.collectMemory(true)
end
function WushenshilianLayer:onEnter( ... )
    if self._hasInit then
        local _data = PlayerData:getLastSceneData() --关卡新数据
        if _data and _data.lastScene and _data.lastScene == "Wushenshilian"  and _data.success then
            local parmas = {}
            parmas.nowTollgate = _data.nowTollgate
            parmas.maxTollgate = _data.maxTollgate
            if not _data.success then
                parmas.tollgateRecord = {}
                parmas.tollgateRecord[tostring(_data.nowTollgate)] = 0 
            end
            self:refreshChapterInfo(parmas)
            if _data.success then
                --刷新关卡数据
                if table.nums(self._tollInfoList) == 3 then
                    local _fouthPos = cc.p(self._middlePos[#self._middlePos].x+self._distance, self._middleHeiht)
                    self:createOneTollgate(_fouthPos, self._tollInfoList[#self._tollInfoList])
                end
                for i = 1, #self._tollBgList do
                    local oneTollBg = self._tollBgList[i]
                    oneTollBg:runAction(cc.Sequence:create(
                        cc.CallFunc:create(
                            function()
                                if i == 2 then
                                    local killed = zc.createSprite("res/Main/arena/killed.png")
                                    killed:setPosition(250/2, 125)
                                    killed:setScale(0.9)
                                    oneTollBg:addChild(killed, 1)
                                end
                            end
                        ),
                        cc.CallFunc:create(
                            function() 
                                if self._passedAll then
                                    oneTollBg:stopAllActions()
                                end
                            end
                        ),
                        cc.DelayTime:create(0.2),
                        cc.MoveBy:create(0.3, cc.p(-self._distance,0)),
                        cc.CallFunc:create(
                            function()
                                if i == 1 then
                                    oneTollBg:removeFromParent()
                                    table.remove(self._tollBgList, 1)
                                end
                                --刷新掉落
                                self:refreshDropInfo()
                            end
                        )))
                end
                --刷新其它数据
                self:refreshTreasure()
            else

            end
            PlayerData:setLastSceneData(nil)
        end
    end
    self._hasInit = true

    --如果正在扫荡
    if self._isSweeping then
        self:createSweepInfo()
    end

    getGuideManager():addMaskLayer()
    performWithDelay(self, function()    
        getGuideManager():removeMaskLayer()
        self:guideFunc()
    end, 0.1)
end
--刷新掉落
function WushenshilianLayer:refreshDropInfo()
    local _isFirst = true
    if self._passedAll or (tonumber(self._nowTollId) < tonumber(self._maxTollgate)) then
        _isFirst = false
        self._dropBg:setTexture("res/Main/wushenTower/drop_bg2.png")
    else
        self._dropBg:setTexture("res/Main/wushenTower/drop_bg1.png")
    end
    local info = self._tollInfoList[2] or {}
    local groupInfo = gameData.getDataFromCacheWithPrimaryKey("arenaTower_npcGroup",  info["groupId"]) or {}

    local awards = groupInfo["awards"] or ""
    local firstReward = groupInfo["firstReward"] or ""
    local awardInfo = string.split(awards, ",")
    local firstRewardInfo = string.split(firstReward, ",")
    self._rewardData = {}
    local function getReward(_info)
        local v = string.split(_info, "|")
        if v and v[2] then
            local idx = #self._rewardData + 1
            self._rewardData[idx] = {}
            self._rewardData[idx].mainType = v[1]
            self._rewardData[idx].type = v[2]
            self._rewardData[idx].itemId = v[2]
            self._rewardData[idx].num = v[3]
            self._rewardData[idx].random = false
            if v[4] and tonumber(v[4]) < 1 then
                self._rewardData[idx].random = true
            end
        end
    end
    for i = 1, #awardInfo do
        getReward(awardInfo[i])
    end
    if _isFirst then
        for i = 1, #firstRewardInfo do
            getReward(firstRewardInfo[i])
        end
    else
        local gemRewardUi = tonumber(groupInfo["gemRewardUi"]) or 0
        if gemRewardUi and gemRewardUi > 0 then
            getReward("12|"..gemRewardUi.."|1")
        end
    end
    for i = 1, 2 do
        local item = self._dropBg["item_"..i]
        local _reward = self._rewardData[i]
        if item and _reward and _reward.mainType then
            item:setVisible(true)
            local newParmas = {
                data = {
                    mainType = _reward["mainType"],
                    type = _reward["type"], 
                    id = _reward["itemId"],
                    num = _reward["num"],
                },
                showDetailPop = true,
            }
            zc.updateIconByData(item,newParmas)
        elseif item then
            item:setVisible(false)
        end
    end
end
function WushenshilianLayer:createSweepInfo()
    local _showLay = ZCDialog:create(200)
    self:addChild(_showLay, 10) 

    local lastTime = (self._sweepTime or 0 ) - PlayerData:getTssTime() --剩余扫荡时间
    if lastTime <= 0 then
        lastTime = 0
    end
    local _showBg = zc.createSprite("res/Main/copy/copy_sweepbg3.png")
    _showBg:setPosition( cc.p(zc.width/2, zc.height/2-50) )
    _showLay:addChild(_showBg)

    local shalou = zc.getSpine( "shalou" )
    shalou:setPosition( cc.p(90, _showBg:getContentSize().height/2+35) )
    shalou:playAction( "animation", true )
    _showBg:addChild(shalou,2)

    local maxChallenge = gameData.getDataFromCacheWithPrimaryKey("arenaTower_npcGroup",  self._maxTollgate) or {}
    local maxChallengeId = tonumber(maxChallenge["tollgateId"]) or  0
    local totalSweep = maxChallengeId --总扫荡关卡
    local lastSweep = math.floor((lastTime-1)/self._perSweepTime) --剩余扫荡关卡
    local _to = totalSweep-lastSweep
    if _to > tonumber(totalSweep) then
        _to = totalSweep
    end
    --248,201,5
    local _msg = "[size=22][color=ffffffff]" .. zc.lang("now_sweeping") .. " [/size][/color][size=28][color=fff8c905]".._to.."/"..totalSweep.."[/size][/color][size=22][color=ffffffff] " .. zc.lang("num_guan") .. "...[/size][/color]"
    local tipLab = zc.createRichLabel({
        text = _msg,
        pos = cc.p(120, _showBg:getContentSize().height/2+35),
        anchor = cc.p(0,0.5),
    })
    tipLab:enableStroke(display.COLOR_BLACK, 0.1)
    _showBg:addChild(tipLab, 1)
    
    local lastTimeLab = zc.createLabel({
        text = zc.lang("overplus_time") .. "：",
        outLine = true,
        fontSize = 22,
        ap = cc.p(0, 0.5),
        pos = cc.p(380, _showBg:getContentSize().height/2+35),
    })
    _showBg:addChild(lastTimeLab)

    local timeStr = zc.getTimeHMS(lastTime)
    local timeLab = zc.createLabel({
        text = timeStr,
        outLine = true,
        fontSize = 22,
        ap = cc.p(0, 0.5),
        pos = cc.p(lastTimeLab:getPositionX()+lastTimeLab:getContentSize().width+10, lastTimeLab:getPositionY() ),
        color = display.COLOR_GREEN,
    })
    _showBg:addChild(timeLab)

    local function doComPlete(_type)
        local _type = _type or 1
        zc.sendHttp({
            apiName = "Wushenshilian_sweepReward",
            params = {type=_type},
            successCallback = function (net_data)
                net_data.noAnimation = true
                PlayerData:updataData(net_data)
                self._isSweeping = false
                _showLay:stopAllActions()
                net_data.callback = function()
                    _showLay:removeFromParent()
                    self._rewardRecord = net_data["awardRecord"] or {}
                    self:refreshChapterInfo(net_data)
                    self:refreshAllChapter()
                end
                zc.createShowReward(net_data)
            end
        })
    end

    local completeBtn = zc.createCommomBtn({
        tag = 1,
        btnText = zc.lang("immediately_complete"),
        touchScale = 0.9,
        pos = cc.p( 700,tipLab:getPositionY() ),
        needSwallow = true,
        needEnableWhenMoving = true,
        endCallback = function()
            doComPlete(2)
        end
    })
    _showBg:addChild(completeBtn)

    local vipInfo = gameData.getDataFromCacheWithPrimaryKey("vip", 24 ) or {}
    local selfVip = PlayerData.info.vip or 0
    if vipInfo  and vipInfo["vip"..selfVip] and tonumber(vipInfo["vip"..selfVip]) == 1 then
        local free = zc.createLabel({
            text = zc.lang("free"),
            fontSize = 22,
            outLine = true,
            pos = cc.p( 700, tipLab:getPositionY() + 48 ),
            color = display.COLOR_GREEN
        })
        _showBg:addChild( free )
    else
        local goldImg = cc.Sprite:create( "res/Main/common/common_icon_gold.png" )
        goldImg:setPosition(700-10, tipLab:getPositionY() + 48)
        _showBg:addChild( goldImg )
        local price = zc.createLabel({
            text = "",
            fontSize = 22,
            outLine = true,
            ap = cc.p( 0, 0.5 ),
            pos = cc.p( goldImg:getContentSize().width, goldImg:getContentSize().height/2 ),
        })
        goldImg:addChild( price )
        local consume = gameData.getDataFromCache("consume_price", {type=43} ) or {}
        if not consume["price"] then
            consume["price"] = 0
        end
        price:setText(tonumber(consume["price"]))
    end
    if lastTime > 0 then
        lastTime = lastTime + 1
        schedule(_showLay,function()
            lastTime = lastTime - 1
            local timeStr = zc.getTimeHMS(lastTime)
            timeLab:setText(timeStr)
            -- price:setText(tonumber(consume["price"]) * (math.floor(lastTime/2)+1) )
            lastSweep = math.floor((lastTime-1)/self._perSweepTime)
            local _msg = "[size=22][color=ffffffff]" .. zc.lang("now_sweeping") .. " [/size][/color][size=28][color=fff8c905]"..(totalSweep-lastSweep).."/"..totalSweep.."[/size][/color][size=22][color=ffffffff] " .. zc.lang("num_guan") .. "...[/size][/color]"
            tipLab:setString(_msg)
            if lastTime <= 0 then
                -- price:setText(0)
                local _msg = "[size=22][color=ffffffff]" .. zc.lang("now_sweeping") .. " [/size][/color][size=28][color=fff8c905]"..totalSweep.."/"..totalSweep.."[/size][/color][size=22][color=ffffffff] " .. zc.lang("num_guan") .. "...[/size][/color]"
                tipLab:setString(_msg)
                _showLay:stopAllActions()
                doComPlete(1)
            end
        end,1.0)
    elseif lastTime <= 0 then
        doComPlete(1)
    end
end
--重置关卡信息
function WushenshilianLayer:refreshAllChapter()
    for i = 1,#self._tollBgList do
        local v = self._tollBgList[i]
        v:removeFromParent()
    end
    self:createTollInfo(true)
    self:refreshTreasure()
end

-----------------引导---------------------
function WushenshilianLayer:guideFunc()
    local _currentGID = getGuideManager():getCurrentGID()
    if _currentGID == GuideKey.KEY_12304 then
        local function _callBack()
            getGuideManager():setObjTarget(self._guideHeroBtn)
            getGuideManager():startGuide()
        end
        getGuideManager():setHeroFuncCallBack(_callBack)
        getGuideManager():startGuide()
    elseif _currentGID == GuideKey.KEY_12307 then
        local function _callBack()
            getGuideManager():setObjTarget(self._roleBtn)
            getGuideManager():startGuide()
        end
        getGuideManager():setHeroFuncCallBack(_callBack)
        getGuideManager():startGuide()
    elseif _currentGID == GuideKey.KEY_12314 then
        getGuideManager():setFuncGuideOver()
        local _guideHand = zc.createSpine({
            fileName = "shou",
            actName = "shou",
            scale = 0.8
        })
        _guideHand:setRotation(90)
        _guideHand:setPosition(cc.pMul(cc.pFromSize(self._close:getContentSize()), 0.5))
        self._close:addChild(_guideHand)
        self._guideHand = true
        performWithDelay(_guideHand, function()
            _guideHand:removeFromParent()
            self._guideHand = false
        end, 4)
    end
end

return WushenshilianLayer